2003-08-19  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.4.2.

	* MH-E-NEWS, README: Updated for release 7.4.2.

	* mh-e.el (Version, mh-version): Updated for release 7.4.2.

	* mh-e.el (mh-folder-size, mh-folder-size-folder)
	(mh-folder-size-flist): If flist is not present use folder to find
	the number of messages in the folder. Also the .mh_sequences file
	is read to find the number of unseen messages (patch from 1.349
	and branched for 7.4.2, closes SF #791021).

	* mh-utils.el (mh-flists-present-flag, mh-find-progs): Introduce a
	new variable to test for the presence of the flists program and
	set it in mh-find-progs.
	(mh-collect-folder-names): Use folders instead of flists. One
	advantage is that folders is available on MH while flists is not.
	Another is that if an explicit -sequence argument isn't given and
	Unseen-Sequence profile is not present then flists croaks while
	folders doesn't.
	(mh-collect-folder-names-filter): Don't consider folder names that
	start with a `.' character. This is needed since the folders
	command doesn't filter them out like flists does.
	(patches from 1.307 and 1.309 and branched for 7.4.2, closes SF
	#791021).

2003-06-25  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.4.1.

	* MH-E-NEWS, README: Updated for release 7.4.1.

	* mh-e.el (Version, mh-version): Updated for release 7.4.1.

2003-06-25  Bill Wohler  <wohler@newt.com>

	* mh-unit.el (require 'cl): Added. Needed when compiling
	separately.

	* Makefile (clean): Now a double-colon rule. Added a second clean
	target to remove mh-unit.elc.
	(compile): Removed mh-unit.elc.
	(mh-unit.elc): New target used to compile mh-unit.

2003-06-24  Bill Wohler  <wohler@newt.com>

	* mh-e.el (Version, mh-version):  Set to 7.4+cvs.

2003-06-24  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.4.

	* MH-E-NEWS, README: Updated for release 7.4.

	* mh-e.el (Version, mh-version): Updated for release 7.4.

2003-06-24  Bill Wohler  <wohler@newt.com>

	* mh-alias.el (mh-alias-gecos-name, mh-alias-local-users)
	(mh-alias-suggest-alias): s/gcos/gecos. The original acronym was
	GECOS but was later renamed to GCOS (see
	http://info.astrian.net/jargon/terms/g/GCOS.html). But the term
	really needs to match the field named pw_gecos in struct passwd in
	/usr/include/pwd.h

	* mh-customize.el (mh-letter-faces): New group to house
	mh-letter-header-field-face.
	(mh-interpret-number-as-range-flag)
	(mh-kill-folder-suppress-prompt-hook): Use "you" instead of "the
	user" to make text more friendly.
	(mh-index-ticked-messages-folders, mh-visible-headers)
	(mh-visible-header-fields): Alphabetized.
	(mh-alias-passwd-gcos-comma-separator-flag): Alphabetized and
	s/gcos/gecos.
	(mh-alias-local-users-prefix): Fixed docstring. Prefixes are
	prepended, not appended. Additional checkdoc fix.
	(mh-letter-header-field-face): Set group to new group
	mh-letter-faces and moved option into this group.

	* mh-index.el (mh-index-sequenced-messages): Improved wording of
	docstring and mentioned use of prefix argument.

	* mh-seq.el (mh-widen): Made docstring more accurate (hopefully!).

2003-06-18  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-replace-string): Modified to preserve case of
	replacement text.
	(mh-index-parse-search-regexp): Preserve case of search terms.
	This is needed to take advantage of the acronym indexing in
	swish++	(closes SF #755718).

2003-06-13  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-show-index-sequenced-messages): Interactive
	function callable from the show buffer.
	(mh-show-folder-map): Add key binding for "F q".

	* mh-e.el (mh-folder-map): Same as above.

	* mh-index.el (mh-index-sequenced-messages): Add interactive spec
	to the function (closes SF #718833).

2003-06-13  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-flists-execute): Needed to expand mhpath too.

2003-06-12  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-flists-execute): Modified so that flists
	present in mh-progs is called.

2003-06-07  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-forward, mh-forward): Use (mh-mail-header-end) to
	find the end of headers instead of doing an re-search-forward
	based on mh-mail-header-separator.

2003-06-06  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-toggle-header-field-display): Make the
	function callable from the show buffer. This means that the
	buffer is temporarily made writable and the modification status
	of the buffer restored to the original value.

2003-06-06  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-address-mail-regexp): Bug fix!  It wasn't a true
	copy of the goto-addr variable.  My modification only recognized
	addresses with one dot after the @.  Sorry about that.

2003-06-05  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-replace-in-string): Move comment into doc
	string to satisfy checkdoc.

	* mh-alias.el (mh-alias-apropos): Checkdoc fix.

2003-06-05  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-identity-list): Fixed typo in docstring.

2003-06-05  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-letter-complete-function-alist): Add bcc an reply-to.

2003-06-04  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-letter-complete-function-alist): Add dcc.

2003-06-03  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-replace-in-string): New function name instead of
	`dired-replace-in-string'.
	* mh-alias.el (mh-alias-gcos-name): Use it.
	
	* mh-alias.el (mh-alias-apropos): New command. Show all aliases
	that match REGEXP either in name or content.

	* mh-alias.el (mh-alias-suggest-alias): Add no-comma-swap optional
	arg.
	(mh-alias-canonicalize-suggestion): Change a comma to a period in
	created aliases.
	(mh-alias-local-users): Call `mh-alias-suggest-alias' with
	`no-comma-swap' arg set to t.

	* mh-alias.el (mh-alias-local-users): Fix case of nil
	`mh-alias-passwd-gcos-comma-separator-flag'.

	* mh-alias.el (mh-alias-gcos-name): Fix for case of empty gcos
	name field.
	(mh-alias-local-users): Fix same.

	* mh-alias.el (mh-alias-canonicalize-suggestion): Replace use by
	verbose `replace-regexp' by a looped `replace-match'

2003-06-02  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (dired-replace-in-string): Bind if not already
	defined.  Borrowed from dired.el 

	* mh-alias.el (mh-alias-gcos-name): switch to using
	dired-replace-in-string.

2003-06-02  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-letter-font-lock-keywords): Fontify header
	fields in the draft buffer that aren't skipped when navigating
	with TAB (or S-TAB).

	* mh-customize.el (mh-clean-message-header-flag)
	(mh-invisible-headers, mh-invisible-header-fields)
	(mh-alias-passwd-gcos-comma-separator-flag): Checkdoc fix.
	(mh-letter-header-field-face): New face to fontify the header
	fields.

	* mh-comp.el (mh-insert-auto-fields-done-local): Checkdoc fix.
	(mh-letter-mode, mh-letter-mail-header-end-marker): Remember the
	end of the message header in a marker. This is used to fontify the
	header fields.
	(mh-font-lock-field-data, mh-letter-header-end): Functions used
	to fontify message header fields.

	* mh-alias.el (mh-alias-gcos-name): Checkdoc fix.

2003-06-02  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-gcos-name): New function. Return a usable
	address string from a GCOS-NAME and USERNAME.
	(mh-alias-local-users): Use it.

	* mh-customize.el (mh-alias-passwd-gcos-comma-separator-flag): New
	defcustom. Whether the gcos field in the passwd file uses comma as
	a separator.

	* mh-customize.el (mh-alias-local-users-prefix): New
	defcustom. String to append to the real names of users from the
	passwd file. If nil, use the username string unmodified instead of
	the real name from the gcos field of the passwd file.

	* mh-alias.el (mh-alias-local-users): Use it to generate aliases
	which by default are now the real name prefixed by "local."

2003-06-01  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-modify-header-field): Bug fix.  Calling with with
	a value that was already inserted causes it to get inserted a
	second time.  I have wrapped the value around \b word delimiters.
	Hope there are no side effects for other code.

	* mh-comp.el (mh-insert-auto-fields): Attempt regardless of 
	`mh-insert-auto-fields-done-local' flag in interactive use.

	* mh-comp.el (mh-insert-auto-fields-done-local): Keep track of
	whether `mh-insert-auto-fields' was called in a buffer.
	(mh-insert-auto-fields): Set it and use it.  Also, don't enter an
	identity if one was already entered manually.
	(mh-send-letter): Call `mh-insert-auto-fields' again when sending
	message.
	(mh-compose-and-send-mail): Call `mh-insert-auto-fields' _after_
	`mh-letter-mode' so `mh-identity-local' doesn't get cleared by the
	mode invocation.

2003-06-01  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-thread-parse-scan-line): The value of
	mh-scan-field-from-start-offset was hardcoded in one place. The
	change fixes that.

	* mh-utils.el (mh-show-mode): Setup mh-show-mode to display
	elipsis for truncated header fields and to skip over them quickly.
	(mh-clean-msg-header): Make another pass over the message header
	fields truncating long headers.

	* mh-comp.el (mh-letter-complete): Remove unnecessary autoload.
	(mh-letter-toggle-header-field-display): Take into account that
	an empty line can also end the message header. The function was
	originally written with the draft buffer in mind.

2003-06-01  Mark D. Baushke  <mdb@gnu.org>

	* mh-comp.el (mh-letter-mode-map): Do not steal C-t. Use C-c C-t
	for the mh-letter-toggle-header-field-display command.

2003-05-31  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-visible-headers): Changed to a defvar that
	will be set using new `mh-visible-headers' function using
	`mh-visible-header-fields' as input.
	(mh-visible-headers): New function, described above.
	(mh-visible-header-fields): New defcustom.  The UI to set
	`mh-visible-headers'.
	(mh-invisible-header-fields-set): Deleted.  Code merged into
	defcustom since it's so short.

2003-05-31  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-toggle-header-field-display): Extended to
	truncate headers if they are too long.
	(mh-letter-truncate-header-field): Make code that would be
	duplicated into a function.
	(mh-letter-hide-all-skipped-fields): Modified so that fields that
	are important are hidden if they are too long.

2003-05-31  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el ("tool-bar"): Since tool-bar isn't available on
	XEmacs, requiring it causes problems. So load it instead.
	(mh-do-at-event-location): New macro to do stuff at location of
	events. This has been refactored out of mh-push-button.

	* mh-mime.el (mh-push-button): Simplified since it now uses the
	mh-do-at-event-location macro.

	* mh-comp.el (mh-hidden-header-keymap): Keymap to make mouse
	clicks on header toggle its display.
	(mh-letter-toggle-header-field-display-button): Interactive
	function to toggle header display when mouse button is clicked.

2003-05-31  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-mode): Remove conditional on tool-bar-mode.

	* mh-comp.el (mh-letter-mode): Same.

	* mh-utils.el (mh-show-mode): Same.

2003-05-30  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (tool-bar): Load tool-bar explicitly. This avoids
	problems with incorrect initialization of tool-bar-map otherwise.

2003-05-30  Peter S Galbraith  <psg@mixed.dyndns.org>

	* mh-comp.el (mh-modify-header-field): Minor fix of spaces for
	when an entry already existed.
	(mh-insert-auto-fields): Make interactive. Add optional `quiet'
	arg for use when called systematically on every buffer.  Won't be
	used interactively for more verbose output.
	(mh-letter-mode-map): Add \C-c\M-d keybinding for
	mh-insert-auto-fields.

	* mh-identity.el (mh-identity-make-menu): Add a menu entry in
	Identity menu for mh-insert-auto-fields.

	* mh-customize.el (mh-invisible-header-fields): Add entries for
	`Envelope-to' and `X-Original-To'.

2003-05-30  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-mode): Skip over invisible text quickly.

2003-05-30  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-mode): Use text properties to achieve
	invisibility. This is more portable and the same code can be used
	for all Emacs versions.
	(mh-letter-toggle-header-field-display): Rewritten to use text
	properties.
	(mh-dead-overlay-p, mh-letter-hidden-header-fields)): Removed.

2003-05-29  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-hidden-header-fields, mh-letter-mode): Add
	a hash table, initialized it in mh-letter-mode, to remember the
	overlays introduced to hide long headers fields.
	(mh-insert-x-mailer): checkdoc fix.
	(mh-compose-and-send-mail): Hide unimportant message header
	fields.
	(mh-letter-header-field-regexp, mh-letter-header-field-at-point)
	(mh-letter-next-header-field, mh-letter-previous-header-field):
	Add a variable that contains the header-field name regexp and use
	it instead of the regexp directly.
	(mh-letter-toggle-header-field-display, mh-letter-mode-map): Add
	new key binding in mh-letter-mode that toggles display of long
	header fields, in mh-letter-mode.
	(mh-dead-overlay-p): A predicate which checks if a given header
	field has an active overlay hiding it.
	(mh-letter-hide-all-skipped-fields): New function that shortens
	uninteresting headers.

2003-05-29  Eric Ding  <ericding@acorn.bethesda.net>

	* mh-comp.el (mh-letter-next-header-field-or-indent): Call
	indent-relative rather than indent-for-tab-command.

2003-05-29  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-complete-or-space): The meaning of the
	customizable variable was reversed. Also make the doc string more
	accurate.

2003-05-28  Satyaki Das  <satyakid@stanford.edu>

	* mh-customize.el (mh-compose-skipped-header-fields): New
	customizable variable that lists headers that are skipped.
	(mh-compose-space-does-completion-flag): Option to do completion
	with space (closes SF #745634).

	* mh-comp.el (mh-insert-x-mailer): Check the value of
	mh-insert-x-mailer-flag in this function instead of in its caller.
	(mh-compose-and-send-mail, mh-send-letter): Insert X-Mailer and
	X-Face headers when the draft is first presented to the user
	instead of when the mail is sent (closes SF #745624).
	(mh-letter-complete-or-space): Allow for this key binding to be
	overridden.
	(mh-letter-next-header-field): Fix a problem with multiline header
	fields.
	(mh-letter-next-header-field, mh-letter-previous-header-field):
	Make these functions skip unwanted header fields.
	(mh-letter-skipped-header-field-p): New predicate that checks if a
	header field is to be skipped.

	* mh-seq.el (mh-thread-inc): Inc'ing email in threaded mode was
	causing duplication of the current notation. The change fixes that.

2003-05-28  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-beginning-of-word): Generalize it to skip
	arbitrary number of words.
	(mh-letter-complete-or-space): New interactive function that
	allows space character to be used for completion.
	(mh-letter-mode-map): Add key binding to allow space to be used
	for completion.

2003-05-27  Satyaki Das  <satyakid@stanford.edu>

	* mh-customize.el (mh-compose-prompt-flag): Customizable variable
	that controls whether the user is prompted when composing a draft.
	It replaces mh-dont-prompt-for-address-flag (closes SF #745622).

	* mh-comp.el (mh-letter-next-header-field): If the point is in
	the header field name, then go the start of the header field
	instead of the next field.
	(mh-interactive-read-address, mh-interactive-read-string)
	(mh-letter-adjust-point): Use mh-compose-prompt-flag instead of
	mh-dont-prompt-for-address-flag.

2003-05-27  Satyaki Das  <satyakid@stanford.edu>

	* mh-customize.el (mh-tool-bar-define): Fix incorrect usage of
	set-specifier (closes SF #745655). Also the button enabling code
	interacts poorly with font-lock in XEmacs. So disable that.

2003-05-26  Satyaki Das  <satyakid@stanford.edu>

	* mh-e.el (mh-folder-from-address): The function
	message-fetch-field expects that the buffer is narrowed to the
	mail header. The change makes sure that this is indeed the case.

	* mh-mime.el (mh-add-missing-mime-version-header)
	(mh-decode-message-body): Same as above.

2003-05-25  Satyaki Das  <satyakid@stanford.edu>

	* mh-alias.el (mh-alias-minibuffer-confirm-address): Modified to
	use mh-beginning-of-word.

	* mh-comp.el (mh-letter-confirm-address): Calling
	mh-alias-reload-maybe can be expensive. So do it only if we really
	need to.

2003-05-25  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-comp.el (mh-letter-confirm-address): Load aliases if not yet
	loaded.

	* mh-alias.el (mh-alias-reload-maybe): Autoload it since it is
	used in mh-comp.el.

2003-05-24  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-letter-skip-leading-whitespace-in-header-field):
	New function to skip leading space and tab characters when placing
	point in a header field.
	(mh-letter-next-header-field, mh-letter-previous-header-field):
	Skip leading whitespace when using TAB to navigate to header
	fields.
	(mh-letter-confirm-address): New interactive function that
	displays the last expansion of the last alias when "," is typed.
	(mh-letter-mode-map): Add key binding for "," (closes SF #745634).

2003-05-23  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el (mh-edit-again, mh-forward, mh-send)
	(mh-send-other-window, mh-send-sub): Modified so that if
	mh-dont-prompt-for-address-flag is non-nil, then MH-E won't prompt
	for addresses to send mail to and instead directly jump to the
	draft (closes SF #745622).
	(mh-letter-complete-function-alist): An alist that is used to
	decide which completion function to use in which header. This
	variable should probably be customizable.
	(mh-letter-complete): Now uses mh-letter-complete-function-alist.
	(mh-letter-header-field-at-point, mh-letter-next-header-field)
	(mh-letter-next-header-field-or-indent)
	(mh-letter-previous-header-field): Commands for easier navigation
	to header fields.
	(mh-dont-prompt-for-address-flag): Variable which controls
	whether MH-E prompts for addresses.
	(mh-interactive-read-address, mh-interactive-read-string): Two
	functions to ask user for input depending on the value of the
	above flag.
	(mh-letter-adjust-point): New function that sets point to the
	first header field.
	(mh-letter-mode-map): Add key bindings for TAB and S-TAB (closes
	SF #745627).

2003-05-23  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-comp.el (mh-complete-word): New function which is
	approximately equivalent to mail-abbrev-complete-alias.
	(mh-beginning-of-word): Refactor repeated code into its own
	function.
	(mh-folder-expand-at-point): Make Fcc completion work in XEmacs
	by not using mail-abbrev-complete-alias.

	* mh-alias.el (mh-alias-letter-expand-alias): Make alias
	expansion work in XEmacs. Replace the use of the function
	mail-abbrev-complete-alias, which isn't present in XEmacs.

	* mh-mime.el (mh-mml-to-mime): If a MIME message is created
	immediately after starting MH-E then invoking mh-mml-to-mime
	causes an error because "message" isn't being loaded. The change
	works around this problem.
	(mh-mime-maybe-display-alternatives): Give better indication of
	which MIME parts are alternatives.

2003-05-22  Satyaki Das  <satyakid@stanford.edu>

	* mh-e.el (mh-add-sequence-notation, mh-remove-sequence-notation):
	Just delete and add the same character in the scan line to make
	font-lock refontify it. The previous trick of removing all text
	properties didn't work in XEmacs.

	* mh-seq.el (mh-put-msg-in-seq): Complain if the user tries to
	create an invalid MH sequence.

	* mh-mime.el (mh-mime-display-alternative): Modified to
	optionally display alternatives as buttons.
	(mh-mime-maybe-display-alternatives): New function which displays
	alternative MIME parts as buttons.
	(mh-mime-save-part): Initially mh-mime-save-parts-directory is
	nil and calling file-name-as-directory with nil arg leads to an
	error. So fall back on the default-directory in that case.

	* mh-customize.el (mh-display-buttons-for-alternatives-flag): New
	customizable variable that controls display of the alternative
	MIME parts (closes SF #741288).

2003-05-22  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-invisible-header-fields): Commented out
	"User-Agent:".  It's similar to X-Mailer, so display it.

2003-05-21  Satyaki Das  <satyakid@stanford.edu>

	* mh-customize.el (mh-tool-bar-define): Add an optional argument
	to the button description that can dynamically enable/disable
	buttons.
	(mh-tool-bar-define): The alias grabbing button is disabled if the
	current message doesn't have a From header or if the sender is
	already in the user's alias. This functionality was inadvertently
	lost when the Emacs/XEmacs toolbar unification took place.

2003-05-20  Satyaki Das  <satyakid@stanford.edu>

	* mh-unit.el (mh-unit-construct-call-graph): Be more aggressive
	and flag interactive functions that aren't autoloaded or have no
	key bindings.
	(mh-unit-interactive-function-p): Remove now unused function.
	(mh-unit, mh-unit-construct-call-graph): Replace mh-files with
	mh-unit-files.

2003-05-20  Bill Wohler  <wohler@newt.com>

	* mh-unit.el (mh-prune-trailing-spaces): Renamed to
	mh-unit-prune-trailing-spaces to clean up the namespace.
	(mh-files): Renamed to mh-unit-files. Ditto.
	(mh-unit): Checkdoc fix.

	* mh-index.el (mh-index-p): Added autoload cookie since mh-index-p
	is used by mh-customize.el. This calls for another mh-unit test
	that looks for mh-autoloads for functions that are no longer used
	in other files.

	* mh-loaddefs.el: Regenerated.

2003-05-20  Satyaki Das  <satyakid@stanford.edu>

	* mh-unit.el (mh-unit-construct-call-graph): Factor out the code
	to read the lisp files to a separate function. Also change it to
	construct a function call-graph. Autoloaded functions are taken
	into account.
	(mh-unit-find-all-used-functions, mh-unit-called-functions)
	(mh-unit-find-all-unused-functions): Find all unused functions by
	computing a fixed point starting from the set of top level
	functions.
	(mh-unit-analyze-block): Removed.
	(mh-unit-update-call-graph): mh-unit-functions-called was renamed
	with modifications to update the function call graph.

2003-05-19  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-notate): Modified to keep track of notation
	that was replaced when sequence notation is added. Thus when the
	sequence is deleted, the original notation is recovered.
	(mh-add-msgs-to-seq): Modified to work with the new sequence
	notation code.

	* mh-seq.el (mh-delete-seq, mh-put-msg-in-seq): Simplified since
	we don't need to handle tick and unseen sequences specially any
	more.
	(mh-narrow-to-seq): Don't need to call mh-notate-user-sequences
	since mh-copy-seq-to-eob already does that.
	(mh-widen): Remove sequence notation, so that notation when
	messages are replied to aren't lost.
	(mh-copy-seq-to-eob): Simplified with the use of
	mh-iterate-on-range.
	(mh-thread-inc): This function doesn't need to notate user
	sequences since its callers already do that.
	(mh-thread-parse-scan-line): Simplified since mh-note-seq doesn't
	appear in scan lines it is given as arguments.
	(mh-thread-update-scan-line-map): Remove the test, since its
	caller already does the required check.
	(mh-thread-folder): Simplified by the use of mh-iterate-on-range.
	(mh-tick-add-overlay, mh-tick-remove-overlay, mh-notate-tick):
	These functions aren't needed any more, since overlays aren't used
	any more. Also overlays aren't portable to XEmacs, so nasty
	conditional code that used overlays in Emacs and extents in Xemacs
	have been eliminated.
	(mh-toggle-tick): Generalize it to work on a range of messages
	like the other interactive messages.

	* mh-funcs.el (mh-undo-folder): Use mh-remove-all-notation
	instead of mh-unmark-all-headers.

	* mh-e.el (mh-folder-font-lock-keywords): The entry for unseen
	sequence highlighting is now done by the macro.
	(mh-generate-sequence-font-lock): New macro to highlight any
	arbitrary sequence. This macro is invoked twice to get the
	highlighting for unseen and tick sequences.
	(mh-sequence-notation-history, mh-folder-mode): New variable that
	keeps track of the old notation when a message is notated with
	mh-note-seq.
	(mh-regenerate-headers, mh-get-new-mail): Add appropriate calls to
	mh-notate-user-sequences and mh-remove-all-notation.
	(mh-unmark-all-headers): Add comment that this function shouldn't
	be used any more.
	(mh-add-sequence-notation, mh-remove-sequence-notation): New
	functions to notate message with mh-note-seq and to remove it.
	(mh-remove-all-notation): Simplified to use mh-iterate-on-range.
	(mh-process-commands): Use mh-remove-all-notation instead of
	mh-unmark-all-headers.
	(mh-notate-user-sequences, mh-delete-msg-from-seq): Simplified
	since the tick and unseen sequences don't need special handling
	any more.
	(mh-internal-seq): Make it possible to dynamically change what
	sequences are treated as internal (internal means font lock is
	used to highlight the sequence).
	(mh-clear-text-properties): Removed since it isn't needed
	anymore.

2003-05-19  Satyaki Das  <satyakid@stanford.edu>

	* mh-unit.el (mh-unit-analyze-block, mh-unit-interactive-function-p)
	(mh-unit-find-all-unused-functions): Change argument name bl to
	block.

2003-05-19  Satyaki Das  <satyakid@stanford.edu>

	* mh-unit.el (mh-unit-find-all-unused-functions): New interactive
	function to find all unused functions in MH-E.
	(mh-unit-analyze-block, mh-unit-interactive-function-p)
	(mh-unit-functions-called): Functions used by
	mh-unit-find-all-unused-functions do its job.

	* Makefile (compile): Byte-compile mh-unit.el, since the analysis
	to find unused code runs faster when compiled.

2003-05-18  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-notate-deleted-and-refiled): Add autoload
	declaration since this function is used in mh-index.el.

	* mh-e.el, mh-customize.el, mh-utils.el: Adjust require/provide
	statements so that mh-e.el isn't loaded twice.

2003-05-15  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-defun-show-buffer): Arrange for the current
	line in the folder buffer to be highlighted even when we are in
	the show buffer.

2003-05-14  Satyaki Das  <satyakid@stanford.edu>

	* mh-seq.el (mh-read-range): Allow this to work on invalid
	sequences that only MH-E knows about.

	* mh-index.el (mh-create-sequence-map, mh-index-add-to-sequence)
	(mh-index-delete-from-sequence): Don't consider sequences that
	aren't valid MH sequences.

	* mh-e.el (mh-valid-seq-p): New predicate to check if a symbol
	could be a MH sequence.
	(mh-undefine-sequence, mh-define-sequence): Don't execute "mark"
	unless the sequence name is a valid MH sequence.

	* mh-utils.el (mh-exec-cmd): In case an error happens in the
	call-process and non-strings are present in ARGS, then the error
	message isn't properly displayed. The change fixes this.

2003-05-14  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-mime-save-part): Bug Fix: Make sure
	`mm-default-directory' gets a trailing "/" if
	`mh-mime-save-parts-directory' doesn't have one.  Otherwise the
	default in the prompt of `mh-mm-save-part' will be wrong.  Perhaps
	`mh-mm-save-part' needs to do this check itself.

2003-05-14  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-unpropagated-sequences): New function and
	variable to keep track of sequences that shouldn't be propagated.
	(mh-create-sequence-map, mh-index-add-to-sequence)
	(mh-index-delete-from-sequence): Use mh-unpropagated-sequences to
	stop changes to some sequences being reflected back to the source
	folders.

2003-05-13  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-e.el (mh-process-commands): Preserve sequences when messages
	are refiled (closes SF #737128).

	* mh-index.el (mh-create-sequence-map)
	(mh-index-create-sequences): Refactor code that is reused into a
	new function.

	* mh-customize.el (mh-refile-preserves-sequences-flag): New
	customizable flag that controls whether sequences are preserved
	when messages are refiled.

2003-05-13  Eric Ding  <ericding@alum.mit.edu>

	* mh-e.el (mh-scan-format): The argument for scan format files
	should be -form, not -format.

2003-05-13  Satyaki Das  <satyakid@stanford.edu>

	* mh-seq.el (mh-widen): The scan line map stack was not being
	properly updated when ALL-FLAG is non-nil. The change fixes that.

	* mh-e.el (mh-reset-threads-and-narrowing): The change resets the
	scan line map stack.

2003-05-12  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-thread-scan-line-map-stack)
	(mh-thread-old-scan-line-map): Instead of the old scan line map,
	now we need to maintain a stack of scan line maps.
	(mh-narrow-to-seq): Modified so that multiple level of narrowings
	can be done. We now maintain a stack of old views instead of
	hiding the old scan lines. This makes it possible to have
	multiple levels of narrowings.
	(mh-widen): A optional prefix arg was added to allow undoing all
	narrowing.
	(mh-read-seq-default, mh-read-range): Don't use
	mh-narrowed-to-seq, since it doesn't exist any more.
	(mh-thread-initialize-hash, mh-thread-initialize): The
	mh-thread-initialize function has been refactored.
	(mh-thread-update-scan-line-map): Maintain notations in the stack
	of scan line maps.
	(mh-notate-tick, mh-toggle-tick): Simplified, since we don't have
	mh-narrowed-to-seq any more. This means there is a slight loss of
	functionality. Earlier if we narrowed to the tick sequence the
	ticked messages weren't highlighted. This feature isn't present
	any more.

	* mh-e.el (mh-execute-commands, mh-reset-threads-and-narrowing)
	(mh-folder-sequence-menu, mh-get-new-mail): Use
	mh-folder-view-stack instead of the now removed
	mh-narrowed-to-seq.
	(mh-narrowed-to-seq, mh-tick-seq-changed-when-narrowed-flag):
	These variables have been removed.
	(mh-folder-view-stack): New variable to keep track of a stack of
	narrowings.
	(mh-execute-commands, mh-get-new-mail): Add extra argument to
	mh-widen so that all narrowings are undone.

	* Makefile (MH-E-SRC, MH-E-OTHERS): Move mh-gnus.el from MH-E-SRC
	to MH-E-OTHERS so that it isn't byte compiled.

2003-05-10  Satyaki Das  <satyakid@stanford.edu>

	* mh-seq.el (mh-read-seq): Improve the function a bit by adding
	history to the sequence prompt.

2003-05-09  Satyaki Das  <satyakid@stanford.edu>

	* mh-gnus.el: New file that won't be byte-compiled. From now on
	having different Gnus versions at run-time and compile-time won't
	cause errors in MH-E.

	* mh-mime.el (mh-small-show-buffer-p, mh-display-smileys)
	(mh-display-emphasis): Handle all legal values of
	font-lock-maximum-size. The existing code assumed didn't consider
	the case where it could be an alist.
	(mh-small-image-p): Simplified, so that aliasing XEmacs functions
	in Emacs isn't necessary any more.
	(mh-mm-display-part): Remove unnecessary call to fboundp. The
	mh-funcall-if-exists does that for us any way.
	(mh-defun-compat, gnus-local-map-property, mm-merge-handles)
	(mm-set-handle-multipart-parameter, mm-readable-p)
	(mm-long-lines-p, mm-keep-viewer-alive-p, mm-destroy-parts)
	(mh-mm-save-part, mm-handle-multipart-ctl-parameter): These
	compatibility functions have been moved to mh-gnus.el.

	* Makefile (MH-E-SRC): Add mh-gnus.el.

	* mh-seq.el (mh-narrow-to-header-field)
	(mh-current-message-header-field): Checkdoc fixes.

	* mh-e.el (mh-undefine-sequence): Since mh-coalesce-msg-list
	returns a list, apply is needed.

2003-05-09  Noel Cragg  <noel@red-bean.com> (tiny change)

	* mh-junk.el (mh-spamassassin-blacklist): Separate "--local" and
	"--no-rebuild" arguments to call-process.
	[Patch committed by satyaki]

2003-05-08  Satyaki Das  <satyakid@stanford.edu>

	* mh-seq.el (mh-translate-range): Take into account differnt
	semantics of split-string in Emacs and XEmacs.
	(mh-read-pick-regexp, mh-narrow-to-from, mh-narrow-to-cc)
	(mh-narrow-to-to, mh-narrow-to-header-field)
	(mh-current-message-header-field, mh-narrow-to-range): New
	narrowing functions that can select messages based on different
	message headers.

	* mh-utils.el (mh-show-limit-map): Add new narrowing functions
	callable from the show buffer.

	* mh-e.el (mh-help-messages): Add help text for new functions.
	(mh-limit-map): Add new narrowing functions (closes SF #732823).

2003-05-07  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-collect-folder-names): Use mh-exec-daemon to
	run flists. This means we don't have to remember to expand the MH
	executable in the mh-progs path.
	(mh-exec-cmd-daemon): Return the new process object produced.

2003-05-06  Satyaki Das  <satyakid@stanford.edu>

	* mh-e.el (mh-folder-font-lock-unseen): Use mh-seq-list to do
	unseen sequence highlighting instead of reading the .mh_sequences
	file from disk every time.

2003-05-05  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-show-sequence-map): Add key binding for S'
	(closes SF #732825).

	* mh-e.el (mh-sequence-map): Ditto.
	(mh-help-messages): Updated for S'.

2003-05-04  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-index-write-data): The with-temp-buffer macro
	is a bit better than write-file, so use that instead.

2003-05-03  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-index-update-maps, mh-index-search)
	(mh-index-sequenced-messages): Write index data to disk. This
	allows us to recover index folder information if Emacs is
	restarted, or the index folder is visited after the buffer has
	been killed (closes SF #701762).
	(mh-index-write-data, mh-index-read-data)
	(mh-index-write-hashtable, mh-index-read-hashtable): Functions to
	store and read index data information to disk.
	(mh-index-insert-folder-headers, mh-index-group-by-folder): We
	can no longer use object identity to compare strings, since they
	might have been read back from disk.

	* mh-e.el (mh-index-data-file): New variable that stores the name
	of the file that keeps track of index folder data.
	(mh-make-folder): Read index folder data if available.

	* mh-utils.el (mh-show, mh-summary-height, mh-modify): Make
	checkdoc happy.

	* mh-seq.el (mh-tick-add-overlay): Rearrange code to make code
	more uniform.

	* mh-loaddefs.el: Regenerated.

2003-05-02  Satyaki Das  <satyakid@stanford.edu>

	* mh-seq.el (mh-tick-add-overlay): If a message with a short scan
	line is ticked, then the highlighting didn't extend to the right
	margin. This change fixes that.

2003-05-01  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-help-messages): Added brackets around / and
	downcased limit to be consistent with other commands with
	punctuation keybindings. Don't document aliases.

2003-05-01  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-read-range): Fix comment.

2003-04-30  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (mh-help-messages): Better documentation for the F map.

2003-04-30  Satyaki Das  <satyakid@stanford.edu>

	* mh-utils.el (mh-find-path): Cache folder names so that
	folder name completion is always fast.
	(mh-flists-partial-line, mh-flists-process): Variables used for
	pre-caching folder names.
	(mh-collect-folder-names, mh-collect-folder-names-filter)
	(mh-populate-sub-folders-cache): Functions to pre-cache folder
	names.
	(mh-exec-cmd): Produce more info in *MH-E Log*.

	* mh-index.el (mh-index-search): Call the correct function.
	(mh-index-sequenced-messages): If folders is nil, then all mail
	is searched. The change restores that.

2003-04-30  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-summary-height): Move variable integer out
	of defcustom, and instead specify that `nil' means to calculate
	that size dynamically.  Fixes SF #723267.

	* mh-utils.el (mh-summary-height): New function. Return ideal
	mh-summary-height value for current frame height.
	(mh-show-msg): Use it.

2003-04-30  Mark D. Baushke  <mdb@gnu.org>

	* mh-index.el (mh-index-ticked-messages): Fix prompt and
	description string.
	(mh-index-new-messages): Ditto.

	* mh-loaddefs.el: Regenerated.

	* mh-index.el (mh-index-sequenced-messages): Renamed from
	mh-index-new-messages with minor argument change.
	(mh-index-new-messages): Implement by calling
	mh-index-sequenced-messages with the appropriate arguments.
	(mh-index-ticked-messages): New function. Does the same thing as
	mh-index-new-messages, but on its own set of folders and using the
	mh-tick-seq instead of mh-unseen-seq.

	* mh-e.el (mh-folder-map): Add "F'" to the map for
	mh-index-ticked-messages.
	(mh-help-messages): Replace broken [t]hread with [n]ew messages.
	
	* mh-customize.el (mh-index-ticked-messages-folders): New user
	customizable flag that controls the folders to be searched by
	mh-index-ticked-messages.

	* mh-utils.el (mh-show-index-ticked-messages): Wrapper for
	mh-index-ticked-messages.
	(mh-show-folder-map): Add "F'" to the map for
	mh-index-ticked-messages.

2003-04-30  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-index-search): The old cur in the source folder
	might not exist. This could cause mh-exec-cmd to fail. So don't
	add an error message in that case.

2003-04-29  Satyaki Das  <satyakid@stanford.edu>

	* mh-e.el (mh-folder-from-address): Modified to allow multiple
	Cc: headers to work properly.
	(mh-inc-folder, mh-visit-folder): Fix an off by one error.

	* mh-utils.el (mh-notate): Update the scan line map. This fixes a
	tiny bug. In threaded view, if a message is replied to then the
	message is notated with a "-". Now if inc is done then the "-"
	added is lost. The change fixes this.

	* mh-seq.el (mh-translate-range): Use the correct function.
	(mh-thread-update-scan-line-map): New function that updates the
	scan line map when a message is notated.

2003-04-28  Satyaki Das  <satyakid@stanford.edu>

	* mh-index.el (mh-index-parse-search-regexp): Avoid compiler
	warning in GNU Emacs 21.3.

	* mh-seq.el (mh-widen): Ditto.

2003-04-28  Satyaki Das  <satyakid@stanford.edu>

	* mh-customize.el (mh-interpret-number-as-range-flag): New user
	customizable flag that controls whether a single number, N is
	interpreted as the range last:N.

	* mh-seq.el (mh-read-range): Generalize it for use when reading
	range to scan.
	(mh-interactive-range): Modified to use the new mh-read-range.

	* mh-speed.el (mh-speed-view): Use mh-read-range instead of the
	now removed mh-read-msg-range function.

	* mh-funcs.el (mh-pack-folder): Ditto.

	* mh-e.el (mh-rescan-folder, mh-visit-folder): Ditto.
	(mh-read-msg-range): Removed.

	* mh-loaddefs.el: Regenerated

2003-04-27  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-range-completion-function): Fix checkdoc warning.
	(mh-iterate-on-range): Mention that the macro can iterate over a
	MH message range too.

2003-04-27  Bill Wohler  <wohler@newt.com>

	* mh-unit.el (mh-unit): As it turns out, lm-crack-copyright has
	been updated to handle multiple-line copyrights in 21.3, so
	updated code to run lm-verify only if user has 21.3 or greater.
	Delete buffers after use, unless user already had buffer open.	

2003-04-27  Satyaki Das  <satyakid@stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-index.el (mh-index-search): The MH command "refile" changes
	cur. The change restores cur in source folders.
	(mh-index-new-messages): Use the appropriate arguments for
	mh-read-seq.

	* mh-seq.el (mh-read-seq-default, mh-read-seq): Restore these
	functions to just read sequence names.
	(mh-range-seq-names, mh-range-history, mh-range-completion-map)
	(mh-range-completion-function, mh-read-range): New function which
	reads MH range with completion and history.
	(mh-interactive-range): Use mh-read-range instead of
	mh-read-seq-default.
	(mh-put-msg-in-seq): Change documentation about MH message range.

	* mh-junk.el (mh-junk-blacklist, mh-junk-whitelist): Change
	documentation about MH message range.

	* mh-funcs.el (mh-copy-msg, mh-print-msg): Ditto.

	* mh-e.el (mh-delete-msg, mh-delete-msg-no-motion)
	(mh-refile-msg, mh-undo, mh-delete-msg-from-seq): Ditto.

	* mh-comp.el (mh-forward): Ditto.

2003-04-26  Satyaki Das  <satyakid@stanford.edu>

	* mh-comp.el, mh-e.el, mh-funcs.el, mh-junk.el, mh-seq.el:
	Replace msg-or-seq with range everywhere.

	* mh-loaddefs.el: Regenerated.

2003-04-25  Satyaki Das  <satyakid@stanford.edu>

	* mh-e.el (mh-index-sequence-search-flag, mh-folder-mode): New
	local variable to remember that a folder buffer contains results
	from a sequence search. This is needed so that "C-u F i" will work
	as expected.
	(mh-visit-folder): Create sequences in the index folder.
	(mh-process-commands, mh-delete-msg-from-seq): If speedbar is on
	then update the speedbar message counts immediately.
	(mh-delete-msg-from-seq): Make the code faster by calling "mark"
	just once. Also update source folder sequence if messages are
	being deleted from a sequence in an index folder.
	(mh-undefine-sequence): Simplified to remove the speedbar updating
	code. Also DTRT and don't change any sequence when called with an
	empty list of messages.
	(mh-refile-msg, mh-delete-msg): Move to next message only if the
	current message has been deleted or refiled, as the case may be.

	* mh-utils.el (mh-show-msg): Update the message counts in the
	speedbar, if it is on, immediately.
	(mh-speed-flists-active-p, mh-speed-flists-inhibit-flag): A new
	flag has been added which inhibits updating of the speedbar. This
	is used to avoid needless speedbar updates when
	mh-execute-commands is called in index folders.

	* mh-speed.el (mh-speed-flists): Extended so that multiple
	folders can be given as arguments. Also the code that kept track
	of the current folder, needed since flists adds an extra ?+ char
	at the end of the current folder name, wasn't entirely correct.
	That has also been fixed.

	* mh-seq.el (mh-delete-seq, mh-put-msg-in-seq): Modified so that
	sequence in source folder is updated if we delete a sequence in an
	index folder.
	(mh-read-seq, mh-read-seq-default, mh-translate-range)
	(mh-interactive-msg-or-seq): The mh-interactive-msg-or-seq
	function can read in an arbitrary MH message range.
	(mh-iterate-on-msg-or-seq): The macro has been extended to work on
	a MH range.
	(mh-subject-to-sequence, mh-subject-to-sequence-unthreaded)
	(mh-subject-to-sequence-threaded, mh-thread-find-msg-subject): Fix
	the mh-subject-to-sequence function so that it will work in
	threaded folders too.
	(mh-tick-add-overlay): Fix a leak of overlays.
	(mh-toggle-tick): Ticking, or unticking, messages in the index
	folder is propagated to the source folders (closes SF #709664).

	* mh-index.el (mh-flists-results-folder, mh-flists-sequence)
	(mh-flists-called-flag): New variables to implement searching for
	arbitrary sequences.
	(mh-index-generate-pretty-name): Updated so that folder names are
	generated for flists search that can take any sequence name.
	(mh-index-search): Since sequences are now properly maintained the
	unseen-flag argument isn't needed and hence removed. Also redoing
	a sequence search with "C-u F i" is handled correctly. Finally
	the speedbar is updated to reflect the new index folder created.
	(mh-index-create-sequences): New function that creates sequences
	in the index folder.
	(mh-index-matching-source-msgs, mh-index-execute-commands):
	Improved so that scan lines for refiled/deleted messages are
	removed from the source folders as well.
	(mh-index-add-to-sequence, mh-index-delete-from-sequence): New
	functions to update sequences in source folder to reflect changes
	in index folder.
	(mh-index-quote-for-shell): A utility function to that quotes
	characters with special meaning to /bin/sh.
	(mh-flists-execute, mh-index-new-messages): Updated to search for
	arbitrary sequences (closes SF #718833).

	* mh-loaddefs.el: Regenerated.

2003-04-25  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-kill-folder-suppress-prompt-hook): New hook
	used by mh-kill-folder to suppress the prompt.

	* mh-funcs.el (mh-kill-folder): Suppress prompt not if
	mh-index-data is non-nil, but if any functions in
	mh-kill-folder-suppress-prompt-hook return non-nil.

	* mh-index.el (mh-index-p): New function with returns non-nil if
	the current folder was generated by an index search for use by
	mh-kill-folder-suppress-prompt-hook

	* mh-unit.el (mh-unit): Commented out lm-verify step until code
	updated to handle split Copyright lines.

	* mh-e.el (mh-version): Set to 7.3+cvs.

2003-04-24  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.3.

	* MH-E-NEWS, README: Updated for release 7.3.

	* mh-e.el (Version, mh-version): Updated for release 7.3.

2003-04-24  Satyaki Das  <satyakid@stanford.edu>

	* mh-xemacs-compat.el (mh-utils): Require mh-utils at compile
	time, since the mh-do-in-xemacs macro is used.

	* mh-inc.el (cl): Require cl at compile time since we are using
	the loop and setf macros.

2003-04-24  Satyaki Das  <satyakid@stanford.edu>

	* mh-unit.el (mh-files): Fix the list of files to check.

2003-04-24  Bill Wohler  <wohler@newt.com>

	* ChangeLog: Appended copyright to end of file.

	* Makefile: Added copyright and license.

	* README: Added copyright.

	* import-emacs: Changed copyright from Newt Software to Bill
	Wohler and use license from mh-e.el, except that this file is
	a part of MH-E, not GNU Emacs.

	* mh-alias.el: Updated copyright so that it doesn't wrap upon
	advice from Richard Stallman who said to use two-digit years when
	they are surrounded by 4-digit years that are in the same century
	and to break up copyrights on multiple lines.
	* mh-comp.el: Ditto.
	* mh-e.el: Ditto.
	* mh-funcs.el: Ditto.
	* mh-identity.el: Ditto.
	* mh-mime.el: Ditto.
	* mh-seq.el: Ditto.
	* mh-utils.el: Ditto.
	* mh-xemacs-compat.el: Ditto.

	* mh-unit.el: New file. Unit tests for MH-E. This version merely
	runs checkdoc and lm-verify which is useful before releasing the
	software. It can and should be expanded to do real unit tests.

2003-04-22  Mark D Baushke  <mdb@gnu.org>

	* mh-alias.el: Update Copyright.
	* mh-comp.el: Ditto.
	* mh-customize.el: Ditto.
	* mh-e.el: Ditto.
	* mh-funcs.el: Ditto.
	* mh-identity.el: Ditto.
	* mh-index.el: Ditto.
	* mh-mime.el: Ditto.
	* mh-pick.el: Ditto.
	* mh-seq.el: Ditto.
	* mh-speed.el: Ditto.
	* mh-utils.el: Ditto.
	* mh-xemacs-compat.el: Ditto.

2003-04-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-normalize-folder-name): Make the completion
	code work properly with XEmacs. This change is neeeded since
	split-string behaves differently in XEmacs than it does in GNU
	Emacs.
	(mh-exec-cmd-error): Add a comment, so that we change it later on.

2003-04-18  Steve Youngs  <youngs@xemacs.org>

	* mh-xemacs-icons.el (mh-xemacs-icons): Provide 'mh-xemacs-icons'
	not 'mh-xemacs-toolbar'.

	* mh-xemacs-compat.el (mh-xemacs-toolbar): Remove require, it's
	now called 'mh-xemacs-icons' and it is required from
	'mh-customize'.

	* mh-customize.el: Require 'mh-xemacs-icons' instead of
	'mh-xemacs-toolbar'. 

2003-04-17  Peter S Galbraith  <psg@debian.org>

	* mh-xemacs-icons.el: New file (renamed from mh-xemacs-toolbar.el).
	Holds XEmacs icons.

	* mh-xemacs-toolbar.el: Deleted.

	* Makefile: Incorporate the file renaming.

2003-04-15  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-forward): Pass a list of messages into
	mh-compose-and-send-mail instead of msg-or-seq.
	(mh-annotate-msg): The previous version called
	mh-iterate-on-msg-or-seq in the letter buffer. The new version
	simply adds the ability to operate on message lists. Thanks to
	Satyaki for the fix and suggestion for passing a list from
	mh-forward.

2003-04-14  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-annotate-msg): Updated to handle msg-or-seq for
	mh-forward was passing a msg-or-seq to mh-compose-and-send-mail
	which in turn passed the msg-or-seq to mh-annotate-msg. In
	particular, forwarding a region failed. Note that the msgs
	argument in much of mh-comp.el should really be converted to
	msg-or-seq accordingly. But not now, unless something is broken as
	was the case here. We can revamp after the release.

2003-04-13  Bill Wohler  <wohler@newt.com>

	* mh-funcs.el (mh-kill-folder): Added space after prompt to give
	the (yes or no) bit a little elbow room.

	* mh-xemacs-toolbar.el: Removing a copyright is a no-no.
	Reinstated Steve's copyright.

2003-04-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-do-in-gnu-emacs, mh-do-in-xemacs): Add
	indentation hooks for the macros.

2003-04-11  Bill Wohler  <wohler@newt.com>

	* mh-alias.el, mh-comp.el, mh-customize.el, mh-funcs.el,
	mh-identity.el, mh-inc.el, mh-index.el, mh-junk.el, mh-utils.el:
	Merged in changes from CVS GNU Emacs. These included the removal
	of trailing whitespace.

	* mh-customize.el: The "anti-entropy" check-in. Moved groups
	around slightly to reflect commentary. Moved defcustoms around
	to preserve alphabetization. Big diff, little content.
	(mh-xemacs-use-toolbar-flag): Doc fix.
	(mh-xemacs-toolbar-position): Fixed typo in docstring.
	(mh-default-folder-list): Updated docstring to reflect new Check
	Recipient tag. Also, set type of Address to regexp.
	(mh-x-mailer-string): Moved to mh-comp.el where it is used.

	* mh-comp.el (mh-x-mailer-string): Moved here from customize.el.
	Not quite sure how it got to mh-customize.el in the first place.

	* mh-e.el (mh-folder-folder-menu): Added Folder -> View New
	Messages menu item.

	* mh-utils.el (mh-show-folder-menu): Ditto.

	* mh-inc.el: Added Change Log comment (lm-verify fix).

	* mh-index.el (mh-index-search): Added documentation about prefix
	argument for users, in addition to documentation for programmers.

	* mh-mime.el (mh-edit-mhn, mh-edit-mhn, mh-mml-to-mime): Docstring
	fixes germaine to the change whereby we now check for MIME
	directives before sending.

	* mh-xemacs-toolbar.el: Fixed copyright. Added Change Log comment
	(lm-verify fix). Added standard MH-E local variables. Removed
	time-stamp stuff.

2003-04-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-iterate-on-msg-or-seq): Add a missed comma.

2003-04-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-visit-folder): Prompt before reusing
	existing folder buffer.

	* mh-xemacs-toolbar.el (require): Require mh-utils at compile
	time to avoid compilation error when doing "make bootstrap" in
	CVS Emacs.

	* mh-inc.el (mh-inc-spool-list): Declare it so that a compile
	time warning is avoided when doing "make bootstrap" in CVS Emacs.

2003-04-10  Peter S Galbraith  <psg@debian.org>

	* mh-inc.el (mh-inc-spool-generator): Changed to a defun instead
	of a defmacro, applying Satyaki's patch.
	(mh-inc-spool-def-key): same.
	(mh-inc-spool-make): same.

	* mh-utils.el: define-key "I" in mh-show-mode-map for
	mh-inc-spool-map.

	* mh-comp.el (mh-modify-header-field): Remove debug message.

2003-04-10  Peter S Galbraith  <psg@debian.org>

	* mh-inc.el (mh-inc-spool-map-help): Default to nil.
	(mh-inc-spool-map): Make "?" key display message when
	`mh-inc-spool-map-help' is nil (instead of mh-inc-spool-map-help
	containing the message).

	* mh-e.el: require mh-inc.el
	* mh-e.el: define-key "I" in mh-folder-mode-map for mh-inc-spool-map.
	(mh-help-messages): Add help string for "I" key.

2003-04-09  Peter S Galbraith  <psg@debian.org>

	* mh-inc.el: New file. New feature to `inc' mail from various
	spool files into different folders.

	* mh-loaddefs.el: Regenerate for mh-inc's mh-inc-spool-list-set.

	* Makefile (MH-E-IMG): Add highlight icon.
	(MH-E-SRC): Add mh-inc.el file.

	* mh-customize.el (mh-inc-spool-list): New variable for new
	feature to `inc' mail from various spool files into different
	folders.

2003-04-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-mail-delivery-buffer): Add a defconst for
	mh-mail-delivery-buffer.

	* mh-comp.el (mh-send-letter): Use mh-mail-delivery-buffer.

	* mh-mime.el (mh-small-image-p): Add mh-funcall-if-exists to
	avoid compiler warning in GNU Emacs.

2003-04-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-small-image-p): Make the function slightly more
	error-resistant in XEmacs.

	* mh-seq.el (mh-narrow-to-seq, mh-widen): Update tool-bar-map in
	the show buffer if needed. This allows us to display the widen
	button in the show buffer only when the folder is narrowed.

	* mh-customize.el (mh-tool-bar-define): Changed so that a
	separate tool-bar-map is used in show-mode when folder is
	narrowed to a sequence.

2003-04-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-iterate-on-msg-or-seq): Reinstate the use of
	make-symbol since using gensym causes compiler warnings in CVS
	Emacs.

2003-04-08  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-forward): Function didn't handle a region of
	messages. Use new function mh-msg-or-seq-to-msg-list to get a list
	of messages in all circumstances. Also, use mh-coalesce-msg-list
	on message list before submitting to forw since this should always
	be done when calling a program to reduce the chance of exceeding
	command-line limits.

	* mh-seq.el (mh-iterate-on-msg-or-seq): Backed out previous
	change. A nil msg-or-seq should mean no messages, and Satyaki is
	going to use gensym instead of make-symbol.
	(mh-msg-or-seq-to-msg-list): New function to convert a msg-or-seq
	to a list of message numbers.

	* mh-e.el (mh-coalesce-msg-list): Touched up the docstring a
	little.

	* mh-funcs.el (mh-print-msg): Can now print regions, message
	lists, sequences and, of course, single messages. This version
	works a little differently from the old version. Instead of
	calling mhl | lpr once on all messages, mhl | lpr is called once
	per message in order to put each message's number in the header.
	Thanks to Satyaki for some code and ideas.

	* mh-seq.el (mh-iterate-on-msg-or-seq): The argument msg-or-seq
	can now be nil which means the current message. Make local symbols
	so that local variables don't step on user's symbols (the msgs
	symbol got me).

2003-04-06  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-forward):  Updated docstrings to indicate that a
	list of messages is acceptable as well.

	* mh-e.el (mh-delete-msg, mh-delete-msg-no-motion, mh-refile-msg)
	(mh-undo, mh-notate-user-sequences, mh-delete-msg-from-seq): Ditto.

	* mh-funcs.el (mh-copy-msg, mh-print-msg): Ditto.

	* mh-junk.el (mh-junk-blacklist, mh-junk-whitelist): Ditto.

	* mh-seq.el (mh-put-msg-in-seq, mh-iterate-on-msg-or-seq)
	(mh-interactive-msg-or-seq): Ditto.

2003-04-06  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-junk.el (mh-junk-blacklist, mh-junk-whitelist): Call
	mh-refile-a-msg and mh-delete-a-msg with nil as the message
	number since that is more efficient.

	* mh-seq.el (mh-iterate-on-msg-or-seq): Extended so that it will
	handle lists of messages numbers as well.
	(mh-put-msg-in-seq): Use mh-iterate-on-msg-or-seq to simplify the
	function.

	* mh-funcs.el (mh-copy-msg): Same as above.

	* mh-e.el (mh-refile-msg): Make it more efficient. Using nil in
	mh-refile-a-msg avoids needing to re-search-forward to that
	message.
	(mh-undo): Fix typo in interactive spec.
	(mh-notate-user-sequences): Generalize the function to take a
	msg-or-seq as argument.
	(mh-delete-msg-from-seq): Extend the function so that it is now
	able to subtract messages belonging in one sequence from another.
	(mh-undo): Unify the region and sequence handling. The message
	number branch of the function does extra stuff, so we can't merge
	that in.

2003-04-06  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-forward): Use mh-interactive-msg-or-seq. Inserted
	consistent verbiage in docstring for msg-or-seq.
	(mh-reply): Don't mention default in opening line in all
	docstrings.

	* mh-e.el (mh-delete-msg, mh-refile-msg)
	(mh-undo, mh-delete-msg-from-seq): Use mh-interactive-msg-or-seq.
	Inserted consistent verbiage in docstring for msg-or-seq. In
	mh-delete-msg-from-seq, renamed msg-or-region to msg-or-seq.

	* mh-funcs.el (mh-copy-msg, mh-print-msg): Use
	mh-interactive-msg-or-seq. Inserted consistent verbiage in
	docstring for msg-or-seq.

	* mh-junk.el (mh-junk-blacklist, mh-junk-whitelist): Inserted
	consistent verbiage in docstring for msg-or-seq.

	* mh-seq.el (mh-msg-is-in-seq): Don't mention default in opening
	line in all docstrings.
	(mh-put-msg-in-seq): Use mh-interactive-msg-or-seq. Inserted
	consistent verbiage in docstring for msg-or-seq.

	* mh-e.el (mh-delete-msg, mh-delete-msg-no-motion, mh-refile-msg):
	Rewritten to use new mh-interactive-msg-or-seq function and
	mh-iterate-on-msg-or-seq macro. mh-delete-msg-no-motion gained the
	ability to operate on regions.

	* mh-junk.el (mh-junk-blacklist, mh-junk-whitelist): Rewritten to
	use new mh-interactive-msg-or-seq function and
	mh-iterate-on-msg-or-seq macro thereby gaining the ability to
	operate on sequences or regions.

	* mh-seq.el (mh-iterate-on-msg-or-seq): New macro to execute code
	on a message, a region of messages, or a sequence. This macro
	should be in all functions that operate on messages to provide a
	uniform interface.
	(mh-interactive-msg-or-seq): New function used in interactive
	calls to obtain a message number, region, or sequence. This
	function should be in all functions that operate on messages to
	provide a uniform interface.

	* mh-utils.el (with-mh-folder-updating, mh-in-show-buffer): Use
	'defun lisp-indent-hook property instead of 1 to fix indentation
	of these macros.

2003-04-05  Peter S Galbraith  <psg@debian.org>

	* mh-loaddefs.el: Regenerated.
	* mh-funcs.el (mh-ephem-message): autoload.

2003-04-04  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-from-address):  Minor Fix.  Wrong ending of
	`when' block.

2003-04-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-mml-directive-present-p): The regexp has been
	modified to recognize directives to encrypt/sign messages.

2003-04-03  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (mh-folder-from-address): E-mail messages missing the
	To: field, but which have a Cc: field should also be handled.

2003-04-03  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-inc-folder): Modified the prompt text to read
	better.

	* mh-comp.el (mh-forward): Deleted local variable `compose'.
	Deleted obsolete setting of mh-{mmh|mml}-compose-insert-flag.
	(mh-letter-menu): Use mh-{mmh|mml}-directive-present-p instead of
	obsolete. mh-{mmh|mml}-compose-insert-flag.
	(mh-letter-mode): Deleted obsolete setting of
	mh-{mmh|mml}-compose-insert-flag.
	(mh-send-letter): This function now automatically runs the
	directive-to-MIME conversion if any directives are detected,
	rather than relying on the unreliable
	mh-{mmh|mml}-compose-insert-flag variables. Updated docstring
	accordingly.

	* mh-identity.el (mh-insert-identity): Use
	mh-{mmh|mml}-directive-present-p instead of obsolete.
	mh-{mmh|mml}-compose-insert-flag.

	* mh-loaddefs.el: Regenerated.

	* mh-mime.el (mh-mhn-compose-type, mh-mhn-compose-external-type)
	(mh-mhn-compose-forw, mh-edit-mhn, mh-mml-to-mime)
	(mh-mml-forward-message, mh-mml-attach-file)
	(mh-mml-secure-message-sign-pgpmime)
	(mh-mml-secure-message-encrypt-pgpmime): Deleted obsolete setting
	of mh-{mmh|mml}-compose-insert-flag.
	(mh-mml-directive-present-p): Checkdoc fix.

	* mh-utils.el (mh-mhn-compose-insert-flag,
	mh-mml-compose-insert-flag): Deleted. Replaced by
	mh-{mhn|mml}-directive-present-p.

2003-04-03  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (mh-folder-from-address): Fix minor problem with To:
	address processing.

	* mh-e.el (mh-folder-from-address): Bugfix match ?+ character not
	a "?+" string.

2003-04-03  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-inc-folder): Add second optional argument for the
	folder to inc new mail into instead of mh-inbox.

2003-04-03  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-from-address): The first match found in
	`mh-default-folder-list' is used.

	* mh-customize.el (mh-default-folder-list): Tweak docs

2003-04-03  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-mime.el (mh-mhn-directive-present-p): New function to test if
	a MHN directive is present in the current buffer.
	(mh-mml-directive-present-p): New function to test if a MML
	directive is present in the current buffer.

	* mh-comp.el (mh-letter-mode): Originally this function checked if
	a #forw directive was present and set mh-mhn-compose-insert-flag
	to t. The modification generalizes this test so that one of the
	variables mh-{mml|mhn}-compose-insert-flag will get set if we have
	any sort of MHN or MML directive is already present.

	* mh-seq.el (tool-bar-map): Add a defvar to avoid compiler
	warnings in CVS version of GNU Emacs.

	* mh-utils.el (tool-bar-map): Same as above.

	* mh-e.el (tool-bar-map): same as above.

2003-04-02  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-xemacs-toolbar.el (mh-xemacs-toolbar-toggle-tick-icon):
	Change color to match mh-folder-tick-face.

	* highlight.xpm: Same as above.

2003-04-02  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-from-address): Check `mh-default-folder-list'
	for cases against the recipient instead of the originator.

	* mh-customize.el (mh-default-folder-list): Add extra boolean flag
	to conditionally check the recipient address instead of the
	originator.

2003-04-02  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-folder-tick-face): Change tick highlight
	face to a background yellow-green, as suggested by Bill.

2003-04-01  Peter S Galbraith  <psg@debian.org>

	* highlight.xpm: New icon for mh-toggle-tick.

	* mh-xemacs-toolbar.el (mh-xemacs-icon-map): Add tool-bar entry
	for mh-toggle-tick.
	(mh-xemacs-toolbar-toggle-tick-icon): New constant.

	* mh-customize.el: Add tool-bar entry for mh-toggle-tick.

2003-03-31  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-show-narrow-to-tick, mh-show-limit-map)
	(mh-show-sequence-menu): Add new interactive function
	mh-show-narrow-to-tick callable from the show buffer and arrange
	for a key binding and a menu entry.

	* mh-seq.el (mh-narrow-to-tick): New interactive function that
	narrows to the tick sequence.

	* mh-e.el (mh-folder-sequence-menu, mh-limit-map): Arrange for a
	key binding and a menu entry for mh-narrow-to-tick.

	* mh-comp.el (mh-letter-mode): Enable undo since we could be
	reusing a show buffer where undo is disabled (closes SF #712777).

2003-03-31  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-sequence-menu): Add entry for mh-toggle-tick.

	* mh-utils.el (mh-show-sequence-menu): Add entry for
	mh-show-toggle-tick.

2003-03-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-delete-seq): If the tick sequence is killed with
	"S k" then the highlighting wasn't getting removed. The change
	fixes this.

2003-03-27  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-notate-user-sequences): Extend it so that only the
	messages in a part of the folder are notated.
	(mh-delete-msg-from-seq): Extend it so that it will delete all
	messages in the marked region.
	(mh-delete-a-msg-from-seq): New function that deletes a single
	message from a sequence.
	(mh-clear-text-properties): If there is a ticked unseen message
	and the message is removed from the unseen list with "S d" then
	unticking the message doesn't change the highlight. This change
	fixes this.

2003-03-27  Peter S Galbraith  <psg@debian.org>

	* mh-xemacs-toolbar.el (mh-xemacs-toolbar-*-icon): Use original
	24x24 icons, changing background only.

2003-03-27  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-junk.el (mh-spamassassin-identify-spammers): Remove unused
	variable buffer-exists.
	(mh-spamassassin-identify-spammers): Remove unused variable user.

	* mh-customize.el (mh-junk-choose): Tweak it to remove XEmacs
	compiler warning.

2003-03-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-print-scan-lines): Handling of a boundary
	condition when messages from the last source folder had been
	removed was incorrect. This caused a folder header to appear
	without any messages listed under it. This change fixes this.
	(mh-thread-forget-message): Remove the entry from the scan line
	table as well. This is needed for proper display of threaded view
	of index folders.

2003-03-26  Bill Wohler  <wohler@newt.com>

	* Makefile, README, import-emacs, mh-alias.el, mh-comp.el,
	mh-customize.el, mh-e.el, mh-funcs.el, mh-identity.el,
	mh-index.el, mh-loaddefs.el, mh-mime.el, mh-pick.el, mh-seq.el,
	mh-speed.el, mh-utils.el, mh-xemacs-compat.el,
	mh-xemacs-toolbar.el: Removed RCS keywords per Emacs conventions
	(closes SF #680731).


2003-03-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el: Fix commentary to mention that mairix is supported
	as well.

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-show-junk-blacklist, mh-show-junk-whitelist):
	Interactive functions callable from the show buffer.
	(mh-show-junk-map): Key bindings in show mode.

	* mh-e.el (mh-junk-map): Key bindings to call spam program.
	(mh-help-messages): Update help text.

	* mh-customize.el (mh-junk): New customization group for spam
	program interface.
	(mh-junk-choice, mh-junk-function-alist, mh-junk-choose):
	Functions and variables that decide which junk program is used.
	(mh-junk-program, mh-junk-mail-folder): User customizable
	variables that control the choice of spam program and the action
	performed on received spam.

	* Makefile (MH-E-SRC): Add mh-junk.el.

2003-03-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-show-toggle-tick, mh-show-mode-map): New
	interactive function callable from the show buffer and a key
	binding for it.

	* mh-seq.el (mh-delete-seq): Remove highlight from tick sequence.
	(mh-put-msg-in-seq): Disable adding messages to tick sequence.
	(mh-widen): Reset mh-tick-seq-changed-when-narrowed-flag.
	(mh-tick-add-overlay, mh-tick-remove-overlay, mh-notate-tick)
	(mh-toggle-tick): New functions to highlight/unhighlight tick
	sequence and the interactive function that is used to toggle
	tick.

	* mh-e.el (mh-tick-seq-changed-when-narrowed-flag): New variable
	that remembers if we are narrowed to the tick sequence. In that
	case the highlighting isn't shown, since it adds no extra info.
	(mh-folder-mode): Initialize mh-tick-seq-changed-when-narrowed-flag.
	(mh-notate-user-sequences): Notate the tick sequence.
	(mh-internal-seq): Treat mh-tick-seq like an internal sequence.
	(mh-delete-msg-from-seq): Don't allow deletion from tick sequence.
	(mh-folder-mode-map): Add key binding for "'"

	* mh-customize.el (mh-tick-seq, mh-folder-tick-face): New
	customizable variables that contain the name of the tick sequence
	and the face to use to highlight it.

2003-03-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-thread-print-scan-lines): New function which
	prints out thread tree. It maintains the original folder info if
	the folder was created by index search (closes SF #709672).
	(mh-copy-seq-to-eob, mh-thread-inc, mh-thread-folder): Use
	factored out function mh-thread-print-scan-lines.
	(mh-toggle-threads): Since threading is allowed in index folders
	there can be lines in the folder which aren't valid message scan
	lines. So it is OK for mh-get-msg-num to fail once in a while.

	* mh-index.el (mh-index-update-maps): Make the parsing of messages
	that need to annotated with the X-MHE-Checksum header more robust.
	If the search yielded no results then an error was being produced.
	(mh-index-search): Enable automatic threading of index folders if
	mh-show-threads-flag is non-nil (closes SF #709667).
	(mh-index-next-folder): Relax error checking since index folder
	can be threaded while the source folder info is visible.
	(mh-index-group-by-folder): New function that is used in
	mh-thread-folder to keep source folder info visible during
	threading.

2003-03-25  Bill Wohler  <wohler@newt.com>

	* mh-loaddefs.el: Regenerated.

	* mh-customize.el (mh-index-new-messages-folders): New variable
	that controls which folders "F n (mh-index-new-messages)"
	accesses. Was mh-flists-search-folders.

	* mh-index.el (mh-flists-search-folders): Still used internally,
	but users now use new option mh-index-new-messages-folders.
	Removed documentation since to avoid duplication with
	mh-index-new-messages-folders.
	(mh-flists-recursive-search-flag): Deleted. Use
	mh-recursive-folders-flag instead.
	(mh-flists-execute): Updated docs to specify which global
	variables are used. Use mh-recursive-folders-flag instead of
	mh-flists-recursive-search-flag.
	(mh-index-new-messages): Edited doc, and refer to new option
	mh-index-new-messages-folders. Ditto within code. Don't need to
	prepend + to folder name as flists does that for us. Use

2003-03-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-refile-msg): Add optional argument that controls
	whether mh-last-destination-folder is updated or not.

2003-03-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-tool-bar-define): Fix a problem in the
	XEmacs version which caused the show mode toolbar to have the
	buttons in the reverse order. Also the add-hooks are no longer
	needed since mh-toolbar-init is called in the appropriate modes.

	* mh-comp.el (mh-letter-mode): Call mh-toolbar-init in XEmacs to
	initialize toolbar.

	* mh-utils.el (mh-show-mode): Same as above.

	* mh-e.el (mh-folder-mode): Same as above.

2003-03-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-exec-cmd-env-daemon): New function which
	executes a command asynchronously with its own environment.

	* mh-comp.el (mh-redistribute): The function has been modified so
	that /bin/sh isn't used to run send. It has also been refactored
	so that the same code isn't repeated.

2003-03-21  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-invisible-header-fields): Added X-Bogosity
	for bogofilter.

2003-03-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-xemacs-toolbar.el: Remove the code since that gets generated
	when mh-tool-bar-define is expanded.
	(mh-xemacs-icon-map): A alist to map GNU Emacs icon names to the
	actual icons to be used in XEmacs. This is used in
	mh-tool-bar-define.

	* mh-customize.el (mh-toolbar): Use this group in XEmacs as well.
	(mh-tool-bar-item-*): All these constants have been removed since
	they aren't needed in the new scheme.
	(mh-tool-bar-reply-3-buttons-flag): This variable has been
	removed.
	(mh-tool-bar-search-function): This is now used in XEmacs as well.
	(mh-tool-bar-folder-set, mh-tool-bar-folder-buttons-set)
	(mh-tool-bar-letter-buttons-set, mh-tool-bar-show-set)
	(mh-tool-bar-letter-set): These functions aren't defined at the
	top level any more.
	(mh-tool-bar-reply-generator): A macro to generate the required
	functions for the three reply buttons.
	(mh-tool-bar-search, mh-tool-bar-customize)
	(mh-tool-bar-folder-help, mh-tool-bar-letter-help)
	(mh-tool-bar-reply-from, mh-show-tool-bar-reply-from)
	(mh-tool-bar-reply-to, mh-show-tool-bar-reply-to)
	(mh-tool-bar-reply-all, mh-show-tool-bar-reply-all): New
	interactive functions that are called when tool bar buttons are
	clicked.
	(mh-xemacs-use-toolbar-flag, mh-xemacs-toolbar-position):
	Additional customizable variables that are present only for
	XEmacs.
	(mh-tool-bar-define): A macro that generates the required code
	for GNU Emacs and XEmacs tool bar.
	(mh-tool-bar-define): Define the MH-E tool bar.

2003-03-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-notate-cur): Notate current message only if it
	hasn't been marked for deletion or refiling.

2003-03-15  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-invisible-header-fields): Added
	X-Spam-Checker-Version.
	(mh-auto-fields-list): checkdoc fix.

2003-03-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-new-messages): If the destination folder
	where the unseen messages are supposed to be copied to was
	already present, but MH-E doesn't have it open, then a new folder
	was being created. The change fixes this.
	(mh-index-update-unseen, mh-flists-recursive-search-flag): Fix
	checkdoc warnings.

	* mh-loaddefs.el: Regenerated.

2003-03-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-flists-results-folder): Subfolder under
	+mhe-index where the results of the flists call is put.
	(mh-index-generate-pretty-name): Make sure that normal index
	searching will never use the folder reserved for the flists
	results.
	(mh-index-search): Add an extra parameter that marks all the
	messages in the index folder to the unseen sequence.
	(mh-index-update-unseen): Function to keep unseen sequence of
	index folder synced with the actual folders from where the
	messages were copied. This works only if the unseen messages are
	displayed with mh-show. Killing the unseen sequence in the index
	folder or adding/removing messages to it doesn't change the
	unseen sequence in the source folders yet.
	(mh-flists-search-folders): Variable that decides the folders on
	which flists is run.
	(mh-flists-recursive-search-flag): If non-nil, flists is passed
	the -recurse option.
	(mh-flists-execute): Function which uses /bin/sh to execute
	flists and then print out the list of message files that match.
	(mh-index-new-messages): New interactive function which searches
	for messages in the unseen sequence (closes SF #701756).

	* mh-utils.el (mh-show-folder-map): Add binding for
	mh-index-new-messages.
	(mh-show-msg): Update the unseen sequence in the source folder.

	* mh-e.el (mh-folder-font-lock-unseen): The function assumes that
	the end of buffer is reached when there isn't a valid scan line
	on the current line. This doesn't work in the index folder since
	we have lines containing the folder name and empty lines in
	between the actual scan lines. The modification removes this
	assumption.
	(mh-folder-map): Add key binding for "Fn"

	* mh-seq.el (mh-iterate-on-messages-in-region): If the point is
	not at the beginning of the line, then the first message in the
	region would be missed. The fix avoids this.

	* mh-mime.el (mh-inline-vcard-p): Don't try to inline vcards if
	we don't have the right libraries.

2003-03-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-next-undeleted-msg, mh-previous-undeleted-msg)
	(mh-next-msg): Add optional argument wait-after-complaining-flag.
	If non-nil and there are no undeleted messages after (or before)
	the current one, then pause for a second after printing out the
	message.
	(mh-refile-or-write-again): Modify call to mh-next-msg to use the
	wait-after-complaining-flag.

2003-03-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-refile-or-write-again): If mh-next-msg fails to find
	a message to go to it prints out a diagnostic, which overwrites
	the diagnostic about the folder the message was refiled to. The
	change fixes this.

2003-03-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-widen, mh-narrow-to-seq): Update
	mh-narrowed-to-seq before notating sequences. This is a bit
	helpful for mh-tick.el.
	(mh-put-msg-in-seq): Fix a minor bug. No internal sequence should
	be notated -- the original code was doing the right thing only for
	the "unseen" sequence.

	* mh-index.el (mh-index-choose): Add autoload cookie for
	mh-index-choose. This is needed for GNU Emacs 20.5.

	* mh-loaddefs.el: Regenerated.

2003-03-09  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-display-smileys): This function originally had a
	test to see if font-lock-maximum-size was bound, but this was
	recently removed. The test was put in for a reason; if
	font-lock-maximum-size isn't bound, void-variable errors would
	ensue. I put the bound test back in.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-mime.el (mh-mime-security-button-map): Use 'mh-push-button'
	in XEmacs as well.

2003-03-07  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-xemacs-toolbar.el: Declare a whole bunch of stuff for GNU
	Emacs, so that we don't get so many compiler warnings. Also
	surround calls to set-specifier and toolbar-make-button-list with
	mh-funcall-if-exists. Maybe GNU Emacs shouldn't try to compile
	this file in the first place.

	* mh-xemacs-compat.el (mh-modeline-glyph): Declare it within
	mh-do-in-xemacs to avoid compiler warning in GNU Emacs.
	(mh-xemacs-push-button): Removed.

	* mh-mime.el (mh-mime-button-map): Use the generalized
	mh-push-button function.
	(mh-push-button): Enhance it so that it works on XEmacs too.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-xemacs-compat.el (mh-modeline-logo): New constant holding the
	modeline image.
	(mh-modeline-glyph): Use it.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-xemacs-toolbar.el: New file that defines and displays a
	toolbar in XEmacs.

	* mh-xemacs-compat.el (mh-xemacs-toolbar): Require it here.

	* Makefile (MH-E-SRC): Add mh-xemacs-toolbar.el.

	* mh-customize.el (mh-toolbar):
	(mh-tool-bar-letter-buttons):
	(mh-tool-bar-letter-buttons-set):
	(mh-tool-bar-folder-buttons):
	(mh-tool-bar-folder-buttons-set):
	(mh-tool-bar-search-function):
	(mh-tool-bar-reply-3-buttons-flag):
	(mh-tool-bar-item-inc):
	(mh-tool-bar-item-save-mime):
	(mh-tool-bar-item-prev-msg):
	(mh-tool-bar-item-page-msg):
	(mh-tool-bar-item-next-msg):
	(mh-tool-bar-item-delete):
	(mh-tool-bar-item-refile):
	(mh-tool-bar-item-undo):
	(mh-tool-bar-item-perform):
	(mh-tool-bar-item-toggle-show):
	(mh-tool-bar-item-reply-from):
	(mh-tool-bar-item-reply-to):
	(mh-tool-bar-item-reply-all):
	(mh-tool-bar-item-reply):
	(mh-tool-bar-item-alias):
	(mh-tool-bar-item-compose):
	(mh-tool-bar-item-rescan):
	(mh-tool-bar-item-repack):
	(mh-tool-bar-item-search):
	(mh-tool-bar-item-visit):
	(mh-tool-bar-item-prefs):
	(mh-tool-bar-item-help):
	(mh-tool-bar-item-widen):
	(mh-tool-bar-item-send):
	(mh-tool-bar-item-attach):
	(mh-tool-bar-item-spell):
	(mh-tool-bar-item-save):
	(mh-tool-bar-item-undo-op):
	(mh-tool-bar-item-kill):
	(mh-tool-bar-item-copy):
	(mh-tool-bar-item-paste):
	(mh-tool-bar-item-kill-draft):
	(mh-tool-bar-item-comp-prefs):
	The MH-E toolbar for XEmacs is defined differently from the
	GNU/Emacs version, so only define these if we're in GNU/Emacs.
	XEmacs doesn't need to see them and it's always good to cut down
	on pollution.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-mime.el (mh-mime-button-map): Bind the 2nd mouse button to
	`mh-xemacs-push-button' in XEmacs.
	(mh-mime-security-button-map): Ditto.

	* mh-xemacs-compat.el: Shush the byte-compiler.
	(mh-xemacs-push-button): New function to make MIME buttons work in
	XEmacs.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-mime.el (mh-display-emphasis): Don't test
	`font-lock-maximum-size' to see if it is bound, just test for a
	non-nil value.  This variable can have a nil value which makes it
	bound and dividing nil by 8 throws an error.
	This fixes a bug in MH-E under XEmacs when
	`font-lock-maximum-size' is nil that prevented article emphasis
	and smiley display which in turn was causing the "Flush changes in
	article x y/n" errors.
	(mh-display-smileys): Ditto.

2003-03-08  Steve Youngs  <youngs@xemacs.org>

	* mh-utils.el (mh-logo-display): Display logo in XEmacs as well.

	* mh-xemacs-compat.el (mh-modeline-glyph): New.  The MH-E modeline
	logo for XEmacs.

2003-03-06  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-allow-root-folder-flag): New global variable
	that decides if "+" is an acceptable folder name.
	(mh-folder-completion-function): Refine the test for existing
	folders to take mh-allow-root-folder-flag into account.
	(mh-folder-completing-read, mh-prompt-for-folder): Use the
	allow-root-folder-flag argument of mh-prompt-for-folder and add a
	similar argument to mh-folder-completing-read.
	(mh-exec-cmd-error): Make the function nicer by using
	process-environment to pass the environment variable assignments.

2003-03-05  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-push-button): Preserve point in the show buffer
	if the mouse is used to expand/contract a button.

	* mh-customize.el (mh-x-face-file): Mention X-Image-URL in
	documentation.

	* mh-comp.el (mh-insert-x-face): Modified to allow insertion of
	X-Image-URL header field.

2003-03-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-face-display-function): Modified to facilitate
	display of X-Image-URL images.
	(mh-find-path): Initialize X-Image-URL cache directory.
	(mh-x-image-url-cache-canonicalize, mh-x-image-url-fetch-image)
	(mh-x-image-scale-and-display, mh-x-image-url-display)
	(mh-x-image-display): New functions for X-Image-URL image display
	and cache management.

	* mh-customize.el (mh-show-use-xface-flag): Add info about
	requirements for X-Image-URL display.
	(mh-fetch-x-image-url): New customizable variable that controls
	fetching of X-Image-URL.

2003-03-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-make-local-hook): New macro which works around
	API changes in add-hook. Version of GNU Emacs before 21.1 and
	XEmacs require a call to make-local-hook and just the LOCAL
	argument of add-hook is not sufficient.
	(mh-show-mode): Make kill-buffer-hook buffer local.

	* mh-e.el (mh-folder-mode): Same as above.

	* mh-comp.el (mh-compose-and-send-mail): Same as above.

2003-03-02  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-push-button): Clicking on a MIME button used to
	cause the window with the show buffer to be selected. With this
	change the selected window doesn't change.

2003-03-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-flists): Avoid a potential race condition.
	When flists is called manually, or when an unseen message is read,
	mh-speed-partial-line was not reinitialized.

	* mh-e.el (mh-visit-folder): If mh-visit-folder is used to visit
	the folder currently being visited (effectively doing a rescan)
	then mh-previous-window-config is erroneously set. The change
	fixes this.

	* mh-customize.el (mh-index-show-hook): Remove unused variable.

2003-02-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-scan-folder): Call mh-reset-threads-and-narrowing
	only after the user has replied to question. This avoids premature
	clearing of the folder.
	(mh-rescan-folder, mh-visit-folder): Remove calls to
	mh-reset-threads-and-narrowing since it is now called in
	mh-scan-folder anyway.

	* mh-funcs.el (mh-sort-folder): Same as above.

2003-02-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-alias.el (mh-alias-alist): Change initial value to a symbol,
	so that it is different from the empty list, which could also
	mean that there are no aliases.
	(mh-alias-reload-maybe): Change test so that empty alist of
	aliases is properly handled (closes SF #693859).

2003-02-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-decode-message-header): The message header could
	be encoded, for instance the author's name could contain
	characters not in ASCII. This function will decode such header
	fields.
	(mh-mm-inline-message): Use mh-decode-message-header.

	* mh-utils.el (mh-display-msg): Use mh-decode-message-header.
	(mh-message-number-width): Use mh-scan-prog instead of "scan".

	* mh-loaddefs.el: Regenerated.

2003-02-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-truncate-log-buffer): Refine it so that the
	function will do the right thing even if called from a buffer
	other than mh-log-buffer.

2003-02-22  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-add-alias): Really fix SF #690216.
	This functions needs to strip brackets on standalone addresses as
	well.

2003-02-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-xemacs-compat.el (replace-regexp-in-string): Remove the
	definition since it isn't used any more.

2003-02-20  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-which-file-has-alias): Bug fix.  Needed to
	specify `noerror' on search.

	* mh-alias.el (mh-alias-suggest-alias): Add condition for input
	string being an email address in brackets.  We need to strip out
	the brackets. (closes SF #690216)

2003-02-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-pick.el (mh-search-folder): The function was setting the
	global value of the variables mh-current-folder and
	mh-previous-window-config. This can lead to problems in code which
	assumes that these variables are nil when we aren't in a folder
	buffer. So make the variables local before setting them.

2003-02-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-mime-display): All the MIME display code has been
	wrapped in a condition-case so that if something goes wrong, the
	raw message will be displayed.

	* mh-funcs.el (mh-undo-folder): Comment out call to sit-for that
	seems unnecessary.

	* mh-e.el (mh-scan-folder): Messages marked for deletion or
	refiling weren't getting annotated properly. The change fixes
	this.
	(mh-process-or-undo-commands): Change prompt to reflect what
	really happens in the code.

2003-02-18  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-folder-expand-at-point): The function
	mail-abbrev-complete-alias often returns nil. This had the
	unfortunate consequence of always causing an error. The change
	fixes this.

	* mh-alias.el (mh-alias-canonicalize-suggestion): New function
	which obviates the our need replace-regexp-in-string.
	(mh-alias-suggest-alias): Use mh-alias-canonicalize-suggestion to
	eliminate calls to replace-regexp-in-string. This avoids problems
	in Emacs20.

	* mh-utils.el (mh-notate): Handle the case when nil is passed as
	notation gracefully.
	(mh-speed-flists-active-p): New function that returns non-nil if
	flists is being used in the speedbar to update message counts.

	* mh-seq.el (mh-put-msg-in-seq): Fix a bug which made it
	impossible to add messages to the unseen sequence. Also adding
	messages to the unseen sequence will now update the speedbar
	message counts immediately.

	* mh-e.el (mh-get-new-mail, mh-process-commands)
	(mh-undefine-sequence): Update speedbar message counts, if the
	speedbar is active and is displaying message counts.
	(mh-delete-msg-from-seq): In addition to updating message counts,
	unhighlight the message so that interactively removing messages
	from the unseen sequence makes the bold highlight of unseen
	messages in the scan buffer go away.
	(mh-clear-text-properties): New function that removes all text
	properties from the current scan line.

2003-02-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-face-display-function): Wrap call of
	insert-image in mh-funcall-if-exists. This avoids a compiler
	warning in Emacs20.

	* mh-speed.el (mh-speed-flists): Weaken test a bit to avoid
	compiler warning in Emacs20.
	(mh-speedbar-change-expand-button-char): Wrap call of
	speedbar-insert-image-button-maybe in mh-funcall-if-exists. This
	function isn't present in the speedbar that ships with Emacs20, so
	calling it there causes an error.

	* mh-seq.el (mh-msg-is-in-seq): Adjust loop call a bit to avoid
	compiler warning in XEmacs. The XEmacs compiler should be improved
	so that such spurious warnings from builtin macros are suppressed.

	* mh-index.el (mh-index-search): Same as above.

	* mh-e.el (tool-bar-mode): The declaration is needed for Emacs20
	too.

	* mh-comp.el (mailabbrev): Try loading it any way. Some day XEmacs
	will get it and then MH-E will just use it.
	(tool-bar-mode, tool-bar-map): These declarations are needed for
	Emacs20 too.
	(mh-mail-abbrev-make-syntax-table, mh-folder-expand-at-point):
	Remove mh-mail-abbrev-make-syntax-table since mh-funcall-if-exists
	can be used instead.

	* mh-alias.el (require): Avoid autoloading functions that may not
	be defined.
	(mh-read-address, mh-alias-letter-expand-alias): Rewrite using
	mh-funcall-if-exists.

2003-02-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-speed.el (mh-folder-speedbar-buttons, mh-speed-add-buttons)
	(mh-speed-toggle): Reuse markers instead of creating more of them.
	(mh-speed-flists-folder, mh-speed-flists): Add optional folder
	argument to mh-speed-flists so that message counts are updated
	only for that one folder.
	(mh-speed-parse-flists-output): If no change in counts then avoid
	consing.

	* mh-index.el (mh-index-execute): Rewritten to use a temporary
	buffer that is not left behind.

	* mh-funcs.el (mh-store-buffer): Use mh-log-buffer instead of the
	special purpose *Store Output* buffer.

2003-02-14  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-show-xface-face): Make it always be black
	foreground on a white background (the reverse of that can make
	some X-Face images look creepy).

	* mh-utils.el (mh-truncate-log-buffer): Modify the function to
	return the current size of mh-log-buffer. Also we are now a bit
	more careful in adding separators between consecutive messages.
	(mh-exec-cmd): Fix a bug where the the log buffer would be
	displayed even if no error happened in the current command but
	the log buffer had messages from a previous error.

	* mh-mime.el (mh-mime-save-parts): Use mh-log-buffer to show
	error messages.

	* mh-alias.el (mh-alias-local-users): Add a space between parens.

2003-02-14  Steve Youngs  <youngs@xemacs.org>

	* mh-utils.el (mh-face-display-function): Call
	`x-face-xmas-wl-display-x-face' using `mh-funcall-if-exists'.

	* mh-xemacs-compat.el (replace-regexp-in-string): New.

2003-02-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-log-buffer-lines): New variable that keeps
	track of the number of lines to keep in mh-log-buffer.
	(mh-truncate-log-buffer): New function that is used to make sure
	that the log buffer doesn't grow to unbounded size.
	(mh-exec-cmd, mh-exec-cmd-daemon, mh-handle-process-error): Use
	mh-truncate-log-buffer instead of erase-buffer to keep some
	number of previous log messages around (closes SF #685476).

2003-02-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (tool-bar-mode): Declare it in XEmacs.
	(mh-folder-mode): Use mh-funcall-if-exists to call hl-line-mode.

	* mh-utils.el (mh-funcall-if-exists): New macro that calls a
	function only if it exists.
	(mh-logo-display, mh-defun-show-buffer): Use mh-funcall-if-exists
	to call the functions find-image and deactivate-mark.

	* mh-mime.el (mh-mime-cleanup, mh-small-image-p)
	(mh-mm-display-part): Use mh-funcall-if-exists to call the
	functions image-size and remove-images.

	* mh-comp.el (tool-bar-map, tool-bar-mode): Declare the variables
	in XEmacs.
	(mh-folder-expand-at-point): Use mh-funcall-if-exists to call
	mail-abbrev-complete-alias if it exists.

	* mh-alias.el (mh-read-address): Use mh-funcall-if-exists for
	future extensibility.

2003-02-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-logo-display): The function find-image is
	present only in GNU Emacs.
	(mh-defun-show-buffer): The function deactivate-mark is present
	only in GNU Emacs.
	(default-enable-multibyte-characters): Declare it in XEmacs to
	avoid compiler warning.
	(mh-face-display-function): Avoid inserting space if there isn't
	any Face or X-Face header field to display.

	* mh-seq.el (mh-thread-last-ancestor): Move declaration of
	variable before its first use to silence XEmacs warning.

	* mh-mime.el (default-enable-multibyte-characters, dots, type):
	Declare these in XEmacs to remove compiler warnings in XEmacs.
	(mh-mime-cleanup, mh-mm-display-part): Call remove-images only in
	GNU Emacs.
	(mh-small-image-p): Call image-size only in GNU Emacs.

	* mh-index.el (mh-mairix-next-result): Fix a bug where a quote
	was missing.
	(mh-swish++-regexp-builder): Remove the unused binding meta.

	* mh-e.el (mh-folder-size): Pass on an extra value to remove
	XEmacs warning.
	(mh-folder-mode): Surround calls to hl-line-mode and
	tool-bar-mode with mh-do-in-gnu-emacs since these functions
	aren't present in XEmacs.

	* mh-customize.el (mh-tool-bar-show-set, mh-tool-bar-letter-set)
	(mh-tool-bar-folder-set): These functions call tool-bar-*
	functions which are present only in GNU Emacs. So surround them
	with mh-do-in-gnu-emacs.

	* mh-comp.el (mh-letter-mode, mh-folder-expand-at-point): Only
	call these functions in GNU Emacs.
	(mail-abbrevs): Declare it in XEmacs.

	* mh-alias.el (mh-read-address): Call completing-read-multiple
	only in GNU Emacs.
	(mail-abbrevs): Declare it in XEmacs.
	(mh-alias-add-alias-to-file): Remove unused code.

2003-02-14  Ville Skyttä  <scop@xemacs.org>

	* mh-comp.el: Add autoloaded auto-mode-alist association.

2003-02-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-face-display-function): Make the XEmacs part a
	little simpler.

2003-02-14  Steve Youngs  <youngs@xemacs.org>

	* mh-customize.el (mh-show-xface-face): XEmacs doesn't have the
	':inherit' keyword for defface, rewrite with sane defaults.

	* mh-utils.el (mh-face-display-function): Fix bug that was
	corrupting xface images when displayed with XEmacs' internal
	xface image support.  Also make XEmacs honour 'mh-show-xface-face'
	when using internal xface image support.

2003-02-12  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-modify-header-field): New function. To header
	FIELD add VALUE.  If OVERWRITE-FLAG is non-nil then the old value,
	if present, is discarded.  This is more flexible than before.
	(mh-insert-auto-fields): Use it.  This and the new function are a
	courtesy of Satyaki.  Thanks!

	* mh-customize.el (mh-auto-fields-list): Doc tweaks suggested by
	Bill.

2003-02-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-folder-expand-at-point): Tweak the error
	message. Completion in the Fcc header field is only supported in
	GNU Emacs 21.

2003-02-12  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-auto-fields-list): Reorder after
	`mh-identity-list' since it needs it to be defined.  Move to
	mh-identity customization group.

2003-02-11  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-insert-mail-followup-to-flag): Removed.
	Obsolete.
	(mh-insert-mail-followup-to-list): Removed.  Obsolete.  Use
	`mh-auto-fields-list' instead, which is a more general solution.
	(mh-auto-fields-list): New defcustom.  Alist of addresses for
	which header lines are automatically inserted.  Replaces
	`mh-insert-mail-followup-to-list'.

	* mh-comp.el (mh-insert-mail-followup-to): Removed.  Obsolete.
	(mh-insert-auto-fields): New function. Insert custom fields if To
	or Cc match `mh-auto-fields-list', replacing
	mh-insert-mail-followup-to with a more general solution.
	(mh-compose-and-send-mail): Call mh-insert-auto-fields instead of
	mh-insert-mail-followup-to.  Also don't call mh-insert-identity to
	insert default setting if mh-insert-auto-fields inserted an
	identity.

2003-02-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-xface-function): Try to load the external
	x-face library only if XEmacs doesn't have xface support.
	(mh-face-display-function): Renamed. Also handle various
	permutations of x-face and xface support in XEmacs better.

	* mh-customize.el (mh-show-use-xface-flag): Any emacs whose
	major version is greater than or equal to 21 supports display of
	X-Face and Face header fields.

2003-02-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-do-in-gnu-emacs, mh-do-in-xemacs): Macros that
	execute code only in GNU Emacs and XEmacs respectively.
	(mh-emacs21-face-display-function): Refactor to make it slightly
	nicer. Get rid of compiler warnings in GNU Emacs by using the
	above macros. Also check for presence of xface feature (in XEmacs
	specific code) before trying to display X-Face header field image.

2003-02-11  Steve Youngs  <youngs@xemacs.org>

	* mh-customize.el (mh-show-use-xface-flag): If using XEmacs and
	can't find the external x-face pkg still enable X-Face images if
	feature 'xface is present.
	Update the doc string.

	* mh-utils.el (mh-emacs21-face-display-function): Make it work in
	XEmacs.
	(mh-show-xface-function): If using XEmacs without xface support,
	use x-face.el pkg.  If using XEmacs with xface support, or Emacs
	21, use mh-emacs21-face-display-function.

2003-02-11  Mark D. Baushke  <mdb@gnu.org>

	* mh-customize.el (mh-invisible-header-fields): Add
	"X-Notes-Item:" which is generated by Lotus Notes Domino. See
	URL<http://www-12.lotus.com/ldd/doc/domino_notes/Rnext/help6_admin.nsf
	/f4b82fbb75e942a6852566ac0037f284/5eda03c647f879c285256c1d00396051
	?OpenDocument&Highlight=0,x-notes-item> for details on how Domino
	users may disable (restore the default) generation of these headers.

2003-02-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-folder-expand-at-point): Add function doc string
	and produce a nicer error message for Emacs versions that lack
	mail-abbrev-complete-alias.

	* mh-utils.el (mh-handle-process-error): Check doc fix.

	* mh-e.el (mh-folder-from-address): Same as above.

2003-02-10  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el: require mailabbrev, except in XEmacs.
	(mh-mail-abbrev-make-syntax-table): New defmacro to call
	mail-abbrev-make-syntax-table introduced in Emacs21.
	(mh-folder-expand-at-point): Handle nested folders.
	All of the above was written by Satyaki.  I just applied the patch
	and tested.

2003-02-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el: Fixes to keep the byte compiler happy.

	* mh-customize.el (mh-invisible-header-fields): Modified to
	remove space after ":" in header field names.

2003-02-09  Peter S Galbraith  <psg@mixed.dyndns.org>

	* mh-comp.el (mh-letter-complete): Add completion for fcc lines.
	(mh-folder-expand-at-point): Do completion at point for folder
	name.  Like `mh-alias-letter-expand-alias' for aliases, it doesn't
	work on XEmacs because it relies on `mail-abbrev-complete-alias'
	to do completion.  Maybe Steve could update XEmacs' mailabbrev.el?

2003-02-09  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-invisible-header-fields): Remove trailing
	space in "X-Face: " and "Face: " entries since those line often
	break there.

2003-02-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-emacs21-face-display-function): Use
	mh-show-xface-face to colorize X-Face image.

	* mh-customize.el (mh-invisible-header-fields): Add extra headers
	to ignore.
	(mh-show-xface-face): Allow customization of the X-Face colors.

2003-02-07  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-uncompface-executable, mh-uncompface): Remember
	the path of the uncompface executable so that we don't need to
	search for it every time.
	(mh-emacs21-face-display-function): If more than one X-Face (or
	Face) header field was present then the fields would get
	concatenated, leading to garbled output. The change only displays
	the first image.

	* mh-customize.el (mh-x-face-file): Change documentation since it
	can now be used to insert a Face header field.

	* mh-comp.el (mh-insert-x-face): Generalized to allow insertion
	of Face header field.

2003-02-06  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (mh-emacs21-face-display-function): Updated
	docstring. It is a common mistake to refer to a header field as a
	header. The term header refers to the entire header while the term
	header field refers to a single field.

	* mh-customize.el (mh-show-use-xface-flag): Ditto.

2003-02-06  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-xface-function): Modified to use
	mh-emacs21-face-display-function if we are running GNU Emacs 21.
	(mh-face-to-png): New function to convert a Face header to a png
	image.
	(mh-uncompface): New function which converts an X-Face header to
	a pbm image.
	(mh-icontopbm): New function that does the job of icontopbm.
	(mh-emacs21-face-display-function): New function that displays
	Face/X-Face image in GNU Emacs 21.
	(mh-show-xface): Modified to test if we are running in X.
	Otherwise face display is suppressed.

	* mh-customize.el (mh-show-use-xface-flag): Tweak it, now that
	MH-E supports face display natively on Emacs 21. Also remove the
	check for window-system since it doesn't belong in a customizable
	variable.

2003-02-06  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (sendmail): Require it so that XEmacs can find
	rfc822-goto-eoh.
	(mh-mail-header-end): A substitute for mail-header-end that
	doesn't widen the buffer. This is essential to avoid problems when
	dealing with nested messages.
	(mh-in-header-p, mh-letter-header-font-lock)
	(mh-header-field-font-lock, mh-show-font-lock-fontify-region)
	(mh-show-unquote-From): Use mh-mail-header-end instead of
	mail-header-end.

	* mh-mime.el (mh-decode-message-body): same as above (closes SF
	#681518).

	* mh-comp.el (mh-yank-cur-msg): same as above.

2003-02-05  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-display-msg): Call mh-show-mode before invisible
	headers are cleaned. This means that any surviving X-Face header
	can be removed unconditionally in mh-clean-msg-header.
	(mh-clean-msg-header): Since the function is now called with a
	read-only buffer, make the buffer temporarily writable.

	* mh-mime.el (mh-mm-inline-message): Do X-Face display before
	invisible headers are removed.

	* mh-customize.el (mh-invisible-headers): Simplified since the
	X-Face header isn't treated specially any more.
	(mh-invisible-header-fields): Add Face: and X-Face: to list of
	invisible headers.

	* mh-mime.el (mh-mime-display): If body is empty the headers would
	be treated like the body. The change fixes this (closes SF #681162).
	(mh-mime-display): This change really fixes the above problem.

2003-02-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-current-folder-name): Global variable that
	keeps track of current folder.
	(mh-normalize-folder-name): Substitute @ with
	mh-current-folder-name (closes SF #666774).
	(mh-prompt-for-folder): Bind mh-current-folder-name. Also
	invalidate cache if we are visiting a folder that wasn't found in
	the sub-folder cache. This is an indication that folders may have
	been created outside of MH-E and so the cache may be stale.

2003-02-03  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-decode-content-transfer-encoded-message): Removed.
	(mh-display-msg): Remove the use of the above function.
	(mh-normalize-folder-name): Leading "/" characters were being
	lost. The change fixes this (closes SF #676890).

	* mh-mime.el (mh-decode-message-body): New function, factored out
	from mh-mime-display and enhanced, to decode message based on
	charset and content-transfer-encoding. This eliminates the need
	for the external mimencode (closes SF #674857).
	(mh-mime-display): Use mh-decode-message-body.

	* mh-e.el (mh-header-display): Don't need the binding since the
	variable isn't present any more.
	(mh-inc-folder): Avoid calling mh-show if point is not on a valid
	scan line (closes SF #678115).

	* mh-customize.el
	(mh-decode-content-transfer-encoded-message-flag): Removed.

2003-02-03  Bill Wohler  <wohler@newt.com>

	* import-emacs: MH-E now has its own directory in Emacs.

	* mh-e.el: (mh-version): Set to 7.2+cvs.

2003-02-03  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.2.

	* MH-E-NEWS, README: Updated for release 7.2.

	* mh-e.el (Version, mh-version): Updated for release 7.2.

2003-02-03  Bill Wohler  <wohler@newt.com>

	* Makefile (dist): mkdir needs to happen *before* files are
	copied.

	* MH-E-NEWS: Fixed some awkward verbiage.

2003-02-02  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-invisible-headers): Surround regexp-opt
	expression in parens to avoid problems viewing certain messages.

2003-01-30  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-flists): Search for flists in mh-progs.
	The original was inadvertently searching for flists in the user's
	path.

2003-01-27  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-default-folder-must-exist-flag): Changed
	default to t according to the principle of least surprise.

2003-01-26  Bill Wohler  <wohler@newt.com>

	* mh-utils.el: Checkdoc fixes.

	* mh-pick.el (mh-do-search, mh-search-folder): Checkdoc fixes.

	* mh-loaddefs.el: Regenerated (lm-verify fixes).

	* mh-index.el (mh-mairix-next-result): Checkdoc fixes.

	* mh-alias.el: lm-verify fix.

	* Makefile (MH-E-SRC): Added ChangeLog, now that Emacs has a
	lisp/mh-e directory.
	(MH-E-ETC-ETC): Removed ChangeLog.
	(dist): Moved creation of mail directory next to copy of files
	into mail directory.
	(install-emacs): Copy $(MH-E-SRC) into new directory
	$(EMACS_HOME/lisp/mh-e.
	(MH-E-SRC): Moved ChangeLog into new variable MH-E-OTHERS and
	include MH-E-LOADDEFS there too.
	(mh-loaddefs.el): Added lines so that lm-verify passes.
	(dist, install-emacs): Use MH-E-OTHERS instead of MH-E-LOADDEFS.

2003-01-26  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-tidy-draft-buffer, mh-compose-and-send-mail):
	Rename mh-kill-draft-hook to mh-tidy-draft-buffer.

2003-01-25  Jeffrey C Honig  <jch@honig.net>

	* mh-utils.el (mh-exec-cmd, mh-exec-cmd-daemon)
	(mh-process-daemon): Use mh-log-buffer for the output of commands
	from mh-exec-cmd.

	* mh-utils.el (mh-temp-folders-buffer): Sequences and folders
	loose the -temp from their buffer names as they are interesting to
	the user.

	* mh-seq.el (mh-list-sequences): New name, mh-sequences-buffer as
	it is intended to be interesting to the user.

	* mh-funcs.el (mh-list-folders): New name, mh-folders-buffer as it
	is intended to be interesting to the user.

	* mh-comp.el (mh-check-whom, mh-compose-and-send-mail): Use
	mh-recipients-buffer constant.  Add a kill buffer hook to delete
	the recipients buffer when a draft buffer is killed.

2003-01-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-customize): New interactive argument
	deletes other windows.
	(mh-tool-bar-show-set, mh-tool-bar-letter-set)
	(mh-tool-bar-folder-set): Modified so that clicking the customize
	and help buttons deletes the other windows in the frame.

	* mh-mime.el (mh-mm-inline-message): Remove unused code.

	* mh-seq.el (mh-notate-deleted-and-refiled): Fix a small bug where
	the wrong notation was being used.
	(mh-toggle-threads): The function had a bug if you did the
	following starting from an unthreaded wide folder:
	  (1) Create a sequence with S p
	  (2) Narrow to new sequence with S n
	  (3) Thread narrowed folder with T t
	  (4) Kill sequence with S k
	  (5) Unthread narrowed folder with T t
	At this point we would have an empty folder. The change fixes
	this.
	(mh-toggle-threads): Fix documentation.

	* mh-customize.el (mh-invisible-header-fields): Add
	X-MHE-Checksum to invisible headers.

	* mh-comp.el (mh-insert-x-mailer): Slightly more informative
	X-Mailer header.

2003-01-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-header-display): Modified so that quoted-printable
	or base64 encoded messages are left untouched.

	* mh-utils.el (mh-decode-content-transfer-encoded-message): Munge
	the Content-Transfer-Encoding header so that the MIME decoding
	routines of Gnus doesn't get confused.
	(mh-display-msg): Use insert-file-contents-literally so that
	display will work for non-ascii.

	* mh-mime.el (mh-mime-display): Use charset info to decode
	message file (closes SF #655123).

2003-01-24  Bill Wohler  <wohler@newt.com>

	* mh-alias.el (mh-alias-add-alias-to-file): Removed period from
	error message and added parens around error function.

2003-01-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-decode-quoted-printable-flag): Removed.
	(mh-decode-content-transfer-encoded-message-flag): This replaces
	mh-decode-quoted-printable-flag.

	* mh-utils.el (mh-decode-content-transfer-encoded-message): New
	function which handles messages that are encoded as base64 or
	quoted-printable (closes SF #674190).
	(mh-decode-quoted-printable): Removed.
	(mh-display-msg): Use mh-decode-content-transfer-encoded-message
	instead of mh-decode-quoted-printable.

2003-01-23  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate-scan-lines): Fix a little bug
	that would occasionally cause angles ('<' and '>') to appear at
	root level.

2003-01-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-notate-cur): Enable overlay arrow display in text
	mode too.

	* mh-e.el (mh-folder-mode): Initialize overlay-arrow-string so
	that a '>' is displayed in text mode.

2003-01-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-scan-msg-overflow-regexp): Change the variable
	so that a space is always maintained in the beginning of the scan
	line.

	* mh-seq.el (mh-notate-seq, mh-notate-cur): Make the functions
	faster by cutting down on the use of mh-goto-msg.
	(mh-toggle-threads): Add call to mh-notate-cur, since inserting
	the folder names in a search results folder screws up the
	location of the overlay arrow.

	* mh-index.el (mh-index-delete-folder-headers): Position the
	point on a message line if possible.

	* mh-funcs.el (mh-copy-msg): Use the mh-iterate macro to make the
	function faster.

	* mh-e.el (mh-scan-folder): Reuse mh-notate-deleted-and-refiled.

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-add-msgs-to-seq): Add a new parameter that
	suppresses the annotation of the sequence since it is
	inefficient.

	* mh-seq.el (mh-delete-seq): Speed up the part of the function
	that removes the sequence notation.
	(mh-put-msg-in-seq, mh-notate-deleted-and-refiled): Use
	mh-iterate-on-messages-in-region to make the function fasters when
	operating on regions. The key idea is to loop over the folder
	buffer exactly once and do all annotations. The existing algo
	would walk over the buffer multiple times thereby slowing things
	down.
	(mh-iterate-on-messages-in-region): Added an extra parameter which
	is bound to the message index as the loop is executed.
	(mh-region-to-msg-list, mh-thread-delete, mh-thread-refile): Use
	the new mh-iterate-on-messages-in-region macro.

	* mh-e.el (mh-delete-msg-no-motion, mh-refile-msg, mh-undo): Same
	as above.
	(mh-notate-user-sequences): Change algorithm to make notating of
	user sequences fast.

2003-01-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-logo.xpm: New image file that contains the MH-E logo.
	Change foreground color to the blue in the MH-E logo.

	* Makefile (MH-E-IMG): Add mh-logo.xpm to list of image files.

	* mh-utils.el (mh-show-buffer-mode-line-buffer-id): Adjust it to
	keep space in the beginning for the logo.
	(mh-logo-cache): New variable that caches the logo image file
	location.
	(mh-logo-display): Display the MH-E logo on the mode line.
	(mh-display-msg): Display logo in mh-show-mode.

	* mh-e.el (mh-make-folder-mode-line): Display logo in
	mh-folder-mode.

	* mh-comp.el (mh-compose-and-send-mail): Display logo in
	mh-letter-mode.

	* mh-loaddefs.el: Regenerated.

	* mh-seq.el (mh-iterate-on-messages-in-region): New macro to
	iterate on all messages in a region.
	(mh-region-to-msg-list): Simplified since it uses
	mh-iterate-on-messages-in-region now.

	* mh-e.el (mh-delete-msg, mh-refile-msg): Change interactive spec
	to pass the region that is to be deleted when appropriate.
	(mh-delete-msg-no-motion, mh-refile-msg, mh-undo): Operate on
	regions directly without creating the list of messages to be
	deleted/refiled.
	(mh-delete-a-msg, mh-refile-a-msg, mh-undo-msg): The msg
	parameter in these functions can now be nil. If so, the current
	message is deleted, refiled or undone respectively. Avoids the
	use of mh-goto-msg in this case and speeds up operations on
	regions quite a bit.

2003-01-19  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-read-address): Bug Fix. In XEmacs and Emacs20,
	it would always prompt using "To: " instead of using the command
	argument (closes SF #670913).

2003-01-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-folder-completion-function): If there is a
	+foo/bar folder and the user types foo//bar then the completion
	function would say a match happened without showing the
	normalized folder name. This change fixes that.

2003-01-18  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-rmail): Modified so that new and unseen messages
	are shown (closes SF #667542).

2003-01-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-generate-pretty-name): Generate nicer
	names. In particular all '-' characters are removed.

2003-01-16  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-index-program): Documentation fix.

	* mh-loaddefs.el: Regenerated.

	* mh-customize.el (mh-index-program): Add choices for mairix and
	pick.

	* mh-index.el (mh-indexer-choices): Add search interfaces for
	mairix and pick.
	(mh-index-search): Add links for mairix and pick.
	(mh-index-pick-folder, mh-pick-binary): Variables needed to
	implement pick support.
	(mh-pick-execute-search, mh-pick-next-result): New functions to
	implement pick support.
	(mh-mairix-binary, mh-mairix-directory, mh-mairix-folder): New
	variables for mairix support.
	(mh-mairix-execute-search, mh-mairix-next-result)
	(mh-mairix-regexp-builder, mh-mairix-convert-to-sop*): New
	functions for mairix.

	* mh-funcs.el (mh-kill-folder): Move message to the end.

	* mh-e.el (mh-folder-mode): Make overlay-arrow-position and
	overlay-arrow-string local variables so that the arrow will
	remain even if some other folder is visited.
	(mh-remove-cur-notation, mh-remove-all-notation): The test isn't
	required any more since overlay-arrow-position is local.
	(mh-goto-cur-msg): Remove overlay arrow if current message
	doesn't exist.

	* mh-seq.el (mh-notate-cur): Don't need to set
	overlay-arrow-string any more since it is local and has been set
	at initialization.

2003-01-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-current-folder): Keep track of current
	folder when flists is called.
	(mh-speed-flists, mh-speed-parse-flists-output): Try to avoid
	ambiguity when folders are present with + at the end of the name.
	Unfortunately it can't always be avoided.

	* mh-e.el (mh-folder-size): Remove the unnecessary error check.
	(mh-parse-flist-output-line): Add extra argument which
	occasionally avoid problems with folder names that end with '+'.

	* mh-utils.el (mh-sub-folders-actual): Fix the folder name
	parsing so that it doesn't get confused by trailing '+' chars in
	the folder name.

2003-01-14  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-normalize-folder-name): Enhanced so that it can
	now handle ".." and "." correctly during folder name completion.
	(mh-normalize-folder-name): Avoid error in boundary condition
	where the folder string is empty.

2003-01-14  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (mh-visit-folder): Pass `current-prefix-arg' to
	the `mh-read-msg-range' function as the optional
	always-prompt-flag.

2003-01-14  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-normalize-folder-name): New function that
	normalizes folder names.
	(mh-sub-folders): Use mh-normalize-folder-name. Also the function
	has been modified so that a trailing slash is only added if the
	folder potentially has subfolders.
	(mh-sub-folders-actual): Simplified since the folder has already
	been normalized in mh-sub-folders.
	(mh-remove-from-sub-folders-cache): Modified so that the cached
	results of two of the folders ancestors are invalidated.
	(mh-folder-completion-map): Ugly hack to make the error go away
	when minibuffer-complete-word is called.
	(mh-folder-completion-function): The completion function will now
	be more selective in adding '/' at the end of completed folder
	names.
	(mh-folder-completing-read): The folder name is normalized before
	return. The minibuffer-local-completion-map is shadowed to avoid
	error with SPC (bound to minibuffer-complete-word). We really
	need a better solution.

2003-01-13  Bill Wohler  <wohler@newt.com>

	* mh-seq.el: Edited comment and docstring text to conform with RFC
	2822 terminology. Message-ID is the header field. It contains a
	message identifier.

2003-01-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-sub-folders): Add an argument that returns
	sub-folders with a / character appended at the end.
	(mh-folder-completion-function): Modify the function so that one
	tab is now sufficient to complete the folder name and add a
	trailing /.
	(mh-folder-completing-read): Remove the trailing / that the
	completion function now adds to the folder name. Also multiple /
	characters in the folder input are removed. So if the user inputs
	+foo///bar//baz///// then that will be converted to +foo/bar/baz.
	This will improve the performance of caching.

	* mh-seq.el (mh-notate-cur): Check that a valid current message
	exists before trying to notate (closes SF #667331).
	(mh-message-id-regexp): New variable to store regexp to recognize
	message-ids.
	(mh-thread-generate): Use mh-message-id-regexp to filter out non
	message-id's from the References: header.

2003-01-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-notate-cur): Disable overlay-arrow display if we
	aren't on a graphic display.

2003-01-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-notate-cur): New function to notate the current
	message. The marker in the fringe is updated too.
	(mh-narrow-to-seq, mh-widen, mh-thread-inc, mh-thread-folder): Use
	the specialized function mh-notate-cur instead of mh-notate-seq.

	* mh-e.el (mh-arrow-marker): New buffer local variable to store
	the position where the marker in the fringe is going to be
	displayed (closes SF #664824).
	(mh-folder-mode): Create a marker for the fringe.
	(mh-update-sequences, mh-get-new-mail, mh-goto-cur-msg): Call the
	specialized function mh-notate-cur instead of mh-notate-seq or
	mh-notate.
	(mh-remove-cur-notation, mh-remove-all-notation): Reset the
	overlay-arrow-position if needed.

	* mh-loaddefs.el: Regenerated.

2003-01-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-remove-from-sub-folders-cache): Modified so that
	creating nested folders doesn't produce inconsistent results.
	(mh-prompt-for-folder): Remove call of mh-folder-list-change-hook.

	* mh-funcs.el (mh-kill-folder): Don't ask for confirmation if
	called on a folder holding index search results. Also the now
	removed mh-folder-list-change-hook is called no more.

	* mh-customize.el (mh-auto-folder-collect-flag)
	(mh-folder-list-change-hook): Removed.

	* mh-loaddefs.el: Regenerated.

2003-01-10  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-default-folder-must-exist-flag): New
	variable to suppress suggested folder if the folder doesn't
	already exist (closes SF #657096).
	(mh-default-folder-list): New variable that
	holds mapping between an address and the desired folder for
	filing (closes SF #657096).
	(mh-default-folder-prefix, mh-default-folder-must-exist-flag): In
	docstring, refer to documentation for mh-prompt-for-refile-folder
	and mh-folder-from-address.
	(mh-highlight-citation-p, mh-compose-insertion,
	(mh-insert-mail-followup-to-list, mh-index-program,
	(mh-identity-default): Fixed case of tags.

	* mh-e.el (mh-folder-from-address): Use new variable
	mh-default-folder-must-exist-flag to return nil if this variable
	is t and the folder doesn't already exist. In addition, can now
	look up a default folder in the new variable
	mh-default-folder-list (closes SF #657096).
	(mh-prompt-for-refile-folder): In docstring, refer to
	documentation in mh-folder-from-address.

	* mh-index.el (mh-swish-execute-search): Changed \..* to \\..* in
	the FileRules filename in the sample config file. Otherwise, the
	users don't see the backslash at all, and no files are indexed!
	(closes SF #665888).

2003-01-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-folder): Get headers for exactly the
	messages that are present. If only messages 1-10 and 3800-3900
	are being shown then we will now scan exactly those messages and
	not the full range from 1-3900 as was being done earlier.
	(mh-toggle-threads): When converting from threaded to normal view
	only the messages present in the buffer are scanned. Earlier all
	messages from the minimum to the maximum would be scanned (closes
	SF #626117).

	* mh-pick.el (mh-search-folder): Fix typo.
	(mh-pick-do-search): Fix bug from cut and paste. Also set window
	config properly.

	* mh-utils.el (mh-prompt-for-folder): Add new argument to allow
	it to accept + as a folder name. This allows the user to search
	all folders when "Fs" is used.

	* mh-pick.el (mh-search-folder): Fix interactive spec of function.
	(mh-pick-do-search): Rewritten to call pick in one go. This will
	make adding pick as a default index search program easier. Also
	pick now accepts the same query syntax as the index search
	programs (closes SF #664816).
	(mh-next-pick-field): Removed.
	(mh-pick-parse-search-buffer): New function to parse the search
	buffer.
	(mh-pick-construct-regexp, mh-pick-regexp-builder): New function
	to produce a pick query from the parsed representation.

	* mh-index.el (mh-index-do-search): Refactor the search pattern
	parser into a new function and use that instead.

	* mh-loaddefs.el: Regenerated.

2003-01-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-loaddefs.el: Regenerated.

	* mh-utils.el (mh-remove-from-sub-folders-cache)
	(mh-prompt-for-folder): Replace mh-update-sub-folders-cache with
	mh-remove-from-sub-folders-cache.
	(mh-exec-cmd-daemon): Mention set-process-filter in documentation.

	* mh-pick.el (mh-searching-function): New buffer local variable
	that keeps track of the default searching function to be used.
	(mh-pick-mode): Make mh-searching-function buffer local.
	(mh-search-folder): Set mh-searching-function to use pick.
	(mh-search-folder, mh-pick-menu, mh-pick-mode-help-messages)
	(mh-pick-mode, mh-do-pick-search, mh-pick-do-search): Rename
	mh-do-pick-search to mh-pick-do-search. But keep
	mh-do-pick-search as a deprecated function.
	(mh-do-search): New interactive function that performs the
	default search.
	(mh-pick-mode-map): Update keymap.

	* mh-index.el (mh-index-search): Set mh-searching-function to do
	index search.
	(mh-index-new-folder): Replace mh-update-sub-folders-cache with
	mh-remover-from-sub-folders-cache.

	* mh-funcs.el (mh-kill-folder): Same as above.

	* mh-index.el (mh-index-evaluate, mh-swish++-regexp-builder):
	Checkdoc fixes.

	* mh-customize.el: Fixes to make byte compiler in CVS Emacs
	perfectly happy.

2003-01-09  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-folder-from-address): New function that proposes the
	name of a folder with an alias for the address in the current message.
	(mh-prompt-for-refile-folder): Use it (closes SF #657096).

	* mh-customize.el (mh-default-folder-prefix): New variable used by
	mh-folder-from-address.
	(mh-invisible-header-fields): Edited docstring.

	* mh-alias.el (mh-alias-address-to-alias): Added ;;;###mh-autoload
	cookie (used by mh-folder-from-address in mh-e.el). Edited text in
	comment.

	* mh-utils.el: Provided naming conventions for buffer and buffer
	variable names.
	(mh-temp-folders-buffer): Renamed buffer to " *mh-folders*".
	(mh-temp-sequences-buffer): Renamed buffer to " *mh-sequences*".
	(mh-info-buffer): Renamed from mh-temp-info-buffer.
	(mh-log-buffer): New buffer variable to hold name of "*MH-E Log*"
	buffer which is expected to be used for the output of MH commands.
	Perhaps we always create this buffer at initialization and append
	to it rather than erase it each time?

	* mh-e.el (mh-quit): Loop over all buffers and delete MH-E
	temporary and working buffers. As long as the buffer naming
	conventions are followed, new buffers will be automatically
	killed.
	(mh-version): Renamed mh-temp-info-buffer to mh-info-buffer.

	* mh-comp.el (mh-insert-x-mailer): Renamed mh-temp-info-buffer to
	mh-info-buffer.

2003-01-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-folder-size): If the user doesn't have a
	Unseen-Sequence definition in .mh_profile then an error was
	produced. This change fixes that.

	* mh-seq.el (mh-thread-generate): Replace the *mh-thread* buffer
	with a temporary buffer which is cleaned up when the function
	exits.

	* mh-e.el (mh-prompt-for-refile-folder): New function which
	refactors out the intelligent folder guessing code from
	mh-refile-msg.
	(mh-refile-msg): Use mh-prompt-for-refile-folder.

	* mh-seq.el (mh-thread-refile): Use mh-prompt-for-refile-folder to
	do the same intelligent destination folder guessing as
	mh-refile-msg (closes SF #664829).

	* mh-utils.el (mh-folder-list, mh-make-folder-list-process)
	(mh-folder-list-temp, mh-folder-list-partial-line)
	(mh-set-folder-list): Removed.
	(mh-sub-folders-cache, mh-sub-folders, mh-sub-folders-actual):
	Moved over from mh-speed.el to implement hierarchical completion.
	(mh-update-sub-folders-cache): Utility function called when
	new folders are created or folders are removed.
	(mh-folder-completion-function): New function is the folder name
	completion function used in completing-read.
	(mh-folder-completing-read): A thin wrapper function that is used
	instead of completing-read directly. In the future we might want
	to allow the user a customizable variable which will turn off
	folders based completion.
	(mh-prompt-for-folder): Use mh-folder-completing-read to read in
	the folder name with hierachical completion (closes SF #664821).

	* mh-speed.el (mh-speed-folders, mh-speed-folders-cache)
	(mh-speed-folders-actual): Moved to mh-utils.el as mh-sub-folders,
	mh-sub-folders-cache and mh-sub-folders-actual respectively.
	(mh-speed-invalidate-map, mh-speed-invalidate-map)
	(mh-speed-add-folder): Use the new names.

	* mh-funcs.el (mh-kill-folder): Remove code that used to update
	mh-folder-list which is no longer present. Instead
	mh-update-sub-folders-cache is called.

	* mh-index.el (mh-index-new-folder): Same as above.

2003-01-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-exec-cmd-daemon): An argument was added which
	controls what is done with the process output.

	* mh-funcs.el (mh-kill-folder): Use mh-previous-window-config to
	restore window configuration. Also the call to mh-exec-cmd-daemon
	only displays output if an error happened (closes SF #664828).
	(mh-rmf-daemon): Check rmf output and display it only if
	something went wrong.
	(mh-print-msg): Pass in nil argument to mh-exec-cmd-daemon.

	* mh-comp.el (mh-redistribute, mh-send-letter): Pass in nil
	argument to mh-exec-cmd-daemon so that the functions will behave
	as before.

	* mh-pick.el (mh-search-folder): The current window config is
	stored.
	(mh-make-pick-template): Make the message headers read-only.
	(mh-pick-mode-help-messages): Update help message.
	(mh-do-pick-search): Fix problem when buffer isn't showing any
	messages.
	(mh-next-pick-field): Use buffer-substring-no-properties is
	better.
	(mh-pick-mode-map): Add key bindings (partially addresses
	SF #664816)

	* mh-index.el (mh-indexer-choices): Add a new field for each
	index program choice. If it is non-nil then it is the name of a
	function that given a lisp expression to search for generates a
	pattern that is acceptable to the search program.
	(mh-index-regexp-builder): New variable that stores the function
	to be used to convert from the lisp expression syntax to
	something that the search program understands.
	(mh-index-generate-pretty-name): Generalized so that it can take
	a list of strings as input.
	(mh-index-search): Modified so that if the configured program has
	a corresponding regexp-builder then a search buffer like pick
	search is produced. Otherwise the previous behavior is maintained.
	(mh-index-do-search): New interactive function that takes the
	contents of the search buffer, generates an appropriate query and
	produces the search results buffer by calling mh-index-search.
	(mh-replace-string, mh-index-parse-search-regexp)
	(mh-index-add-implicit-ops, mh-index-evaluate): New functions
	which parses the infix search expression that the user enters. A
	parse tree from which queries for different search programs can
	be produced is produced.
	(mh-swish++-regexp-builder, mh-swish++-print-regexp): Takes the
	internal form of the query and produces input suitable for
	swish++.

	* mh-loaddefs.el: Regenerated.

2003-01-08  Bill Wohler  <wohler@newt.com>

	* Makefile (emacs-logs): New target for viewing CVS Emacs logs.
	Useful to see if an Emacs developer has changed MH-E.

	* MH-E-NEWS: Fixed case of MH-E in the "Changes" title.

	* mh-utils.el (mh-temp-info-buffer): New variable to hold name of
	buffer that contains version info.

	* mh-e.el (mh-version): Use mh-temp-info-buffer instead of
	mh-temp-buffer since version information was getting clobbered by
	the aliasing code before it could be seen (closes SF #664467).
	(mh-quit): Delete mh-temp-info-buffer.

	* mh-comp.el (mh-insert-x-mailer): Use mh-temp-info-buffer to find
	version info instead of mh-temp-buffer. You kind of need this
	patch to send mail.

2003-01-07  Bill Wohler  <wohler@newt.com>

	* mh-e.el (Version, mh-version): Set to 7.1+cvs.

2003-01-07  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.1.

	* MH-E-NEWS, README: Updated for release 7.1.

	* mh-e.el (Version, mh-version): Updated for release 7.1.

2003-01-07  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-auto-folder-collect-flag,
	mh-alias-system-aliases, mh-alias-insert-file): Edited docstrings.

	* Makefile (MH-E-IMG): Added alias.pbm and alias.xpm.

	* mh-alias.el (mh-alias-insert-file, mh-alias-add-alias): Fixed
	checkdoc warnings.

2003-01-07  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-search-from-end): New function that is used to
	replace our usage of the CL function search.
	(font-lock): The library is loaded to avoid compilation warning
	in CVS Emacs.

	* mh-speed.el (mh-speed-goto-folder, mh-speed-add-folder)
	(mh-speed-extract-folder-name, mh-speed-invalidate-map): Use
	mh-search-from-end instead of search.

	* mh-seq.el (mh-thread-remove-parent-link): Use loop instead of
	remove*.
	(mh-thread-process-in-reply-to): Use mh-search-from-end instead
	of search.

	* mh-index.el (mh-md5-parser): Fix name of function.
	(mh-index-update-single-msg, mh-index-update-maps): Avoid using
	destructuring-bind since Emacs-20.7 can't handle this particular
	usage.
	(mh-namazu-next-result): Use mh-search-from-end instead of
	search.

	* mh-e.el (recursive-load-depth-limit): Add a defvar since CVS
	emacs which doesn't have the variable defined causes a compiler
	warning.
	(mh-refile-a-msg): Rewritten to avoid using pushnew.
	(mh-undo-msg): Use loop instead of remove-if.

	* mh-comp.el (mh-show-buffer-message-number): Use
	mh-search-from-end instead of search.

2003-01-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-visit-folder): Modified so that if RANGE is nil then
	all messages are displayed. Documentation modified so that this is
	explicitly stated.
	(mh-visit-folder): Really fix it this time.

2003-01-01  Mark D Baushke  <mdb@gnu.org>

	* mh-alias.el (mh-alias-from-has-no-alias-p): Needs the
	mh-autoload comment or mh-customize may have problems finding the
	function.

	* mh-loaddefs.el: Regenerated.

2002-12-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-namazu-execute-search): Fix bug in documentation.

2002-12-28  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-letter-mode): Mention mh-compose-insertion
	variable in docstring, explain how to expand directives, and
	don't mention mh-mhn-compose-insertion which isn't used directly
	any more.
	(mh-send-letter): Mention that X-Mailer and X-Face are inserted
	automatically so that a user isn't tempted to do so himself in
	mh-before-send-letter-hook.
	(mh-insert-letter): Use "variable" prefix for mh-invisible-headers
	now that we have both a function and a variable. Clarified
	language a bit.

2002-12-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-xface-function): Only load x-face-e21 if
	the emacs is not XEmacs.

	* mh-index.el (mh-index-new-folder): The folder created should
	always be added to mh-folder-list. Otherwise folder name
	completion doesn't find the new folder created.

2002-12-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-clean-message-header-flag)
	(mh-visible-headers, mh-invisible-headers)
	(mh-invisible-header-fields-set): Reworded to satisfy checkdoc.

	* mh-loaddefs.el: Regenerated.

	* mh-e.el (mh-inc-folder, mh-visit-folder, mh-read-msg-range):
	Handle nil value of mh-large-folder properly.

	* mh-customize.el (mh-tool-bar-show-set, mh-tool-bar-letter-set)
	(mh-tool-bar-folder-set, mh-tool-bar-folder-buttons)
	(mh-invisible-headers, mh-invisible-header-fields-set): Checkdoc
	fixes.
	(mh-large-folder): Updated to allow for infinity. If
	mh-large-folder is nil then all folders are deemed small.

2002-12-23  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-inc-folder, mh-visit-folder): Emit a message if
	threading was suppressed because the number of messages exceed
	mh-large-folder.

2002-12-23  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-invisible-headers): Deleted.  Moved to
	mh-customize.el

	* mh-customize.el (mh-invisible-header-fields): New
	defcustom. Simple user interface to change mh-invisible-headers.
	(mh-invisible-header-fields-set): New function called when
	mh-invisible-header-fields is set.
	(mh-invisible-headers): New function.  Does the actual work of
	building the variable mh-invisible-headers from
	mh-invisible-header-fields.
	(mh-invisible-headers): defvar moved from mh-utils.el

2002-12-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-folder-size): Removed. Something very
	similar appears as mh-folder-size.
	(mh-speed-view): Simplified since the range selection logic has
	been moved to mh-read-msg-range.
	(mh-speed-parse-flists-output-line): Moved to mh-e.el as
	mh-parse-flist-output-line.

	* mh-funcs.el (mh-pack-folder): Use the new mh-read-msg-range.

	* mh-e.el (mh-rescan-folder): Use the new mh-read-msg-range.
	(mh-parse-flist-output-line): Moved from mh-speed.el where this
	function was called mh-speed-parse-flists-output-line.
	(mh-folder-size): Renamed from mh-speed-folder-size. The function
	has been made more general and can be called from any buffer and
	not just the speedbar buffer.
	(mh-visit-folder): Use the new mh-read-msg-range (addresses SF
	#655891).
	(mh-read-msg-range): Rewritten.

2002-12-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-delete-subject-or-thread): New interactive
	function that intelligently deletes messages based on threading,
	if the folder is threaded, or on subject if folder isn't threaded.

	* mh-utils.el (mh-show-delete-subject-or-thread): New interactive
	function, callable from the show buffer, to intelligently delete
	messages based on threading info or subject.
	(mh-show-mode-map): Change binding of "k" to call
	mh-show-delete-subject-or-thread.

	* mh-e.el (mh-folder-mode-map): Change binding of "k" to call
	mh-delete-subject-or-thread.

	* mh-comp.el (mh-letter-mode-map): Add key binding for
	mh-insert-identity.

	* mh-loaddefs.el: Regenerated.

2002-12-21  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-tool-bar-letter-set): Bug fix.  The
	`tool-bar-add-item-from-menu' items were broken.  I can't use my
	constants there.

2002-12-21  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-insert-file): Bug fix.  I never checked
	that an AliasFile entry existed in .mh_profile.

2002-12-21  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-alias-insertion-location): New defustom.
	Specifies where new aliases are entered in alias files.

	* mh-alias.el (mh-alias-add-alias-to-file): Use it.

2002-12-21  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-add-alias-to-file): If ALIAS matches
	exactly, prompt to [i]nsert before old value or [a]ppend after it.
	(mh-alias-insert-file): Make sure we don't edit the passwd file.
	Add optional argument for alias; If ALIAS is specified and it
	already exists, try to return the file that contains it.
	(mh-alias-which-file-has-alias): New function. Return the name of
	writable file which defines ALIAS from list FILE-LIST.
	(mh-alias-add-alias): Remove prompts for case of alias already
	defined; done in mh-alias-add-alias-to-file.

2002-12-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-folders-actual): Fix bug in parsing of
	folder names that have spaces in them. The original function would
	truncate the folder name at the first space.
	(mh-speed-flists): Add -sequence option to flists. This guards
	against the user specifying something other than the unseen
	sequence in his .mh_profile.
	(mh-speed-parse-flists-output-line): New function that parses a
	single line in the output of flists to find the folder name and
	the counts of unseesn and total messages.
	(mh-speed-parse-flists-output): Fix parsing bug which truncates
	the folder names at the first space.

	* mh-index.el (mh-index-generate-pretty-name): New function which
	generates a nicer name for the search results. It trims white
	space at the beginning and end and replaces white space with
	underscores within the search regexp.
	(mh-index-search): Use mh-index-generate-pretty-name.

	* mh-loaddefs.el: Regenerated.

2002-12-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-new-folder): Add new folder to
	mh-folder-list to enable name completion.
	(mh-glimpse-execute-search, mh-swish-execute-search)
	(mh-swish++-execute-search): Fix documentation.

	* mh-seq.el (mh-thread-generate): Fixed a stupid bug where the wrong
	folder could get 'scan'ed when generating the threaded view.

	* mh-index.el (mh-index-search): If optional prefix arg is given
	then the search in the current index buffer is redone.
	(mh-glimpse-execute-search, mh-swish-execute-search)
	(mh-namazu-execute-search): Documentation fixes.

	* mh-e.el (mh-index-previous-search): New buffer local variable
	stores parameters of search that created the buffer.
	(mh-folder-mode): Make mh-index-previous-search buffer local.
	(mh-visit-folder): Tweak the function so that only a single window
	with the folder buffer is shown if mh-showing-mode is nil.

	* mh-loaddefs.el: Regenerated.

2002-12-19  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-add-alias): Bug fix.

2002-12-19  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-add-alias): New interactive command. Add
	ALIAS for ADDRESS in personal alias file.
	(mh-alias-grab-from-field): New interactive command. Add ALIAS for
	ADDRESS in personal alias file.
	(mh-alias-add-address-under-point): New interactive
	command. Insert an alias for email address under point.
	(mh-alias-suggest-alias): New function. Suggest an alias for STRING.
	(mh-alias-insert-file): New function. Return the alias file to
	write a new entry in.
	(mh-alias-address-to-alias): New function. Return the ADDRESS
	alias if defined, or nil."
	(mh-alias-from-has-no-alias-p): New function. Return t is From has
	no current alias set.  Used as tool-bar button enable function.
	(mh-alias-add-alias-to-file): New function. Add ALIAS for ADDRESS
	in alias FILE without alias check or prompts.

	* alias.xpm, alias.pbm: New tool-bar icon for
	mh-alias-grab-from-field.

	* mh-e.el (mh-folder-line-matches-show-buffer-p): New function.
	Return t if the message under point in folder-mode is in the show
	buffer.

	* mh-utils.el (mh-goto-address-find-address-at-point): New
	function copied from goto-addr.el, which we don't want to
	force-load on users.  Find e-mail address around or before point.
	(mh-address-mail-regexp): New defvar.  A regular expression
	probably matching an e-mail address.

	* mh-customize.el (mh-alias-insert-file): New defcustom.
	Filename to use to store new MH-E aliases.
	(mh-tool-bar-folder-buttons): Enable mh-tool-bar-item-alias icon.

	* mh-comp.el (mh-extract-from-header-value): New function.
	Extract From: string from header.

2002-12-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-update-single-msg): New defvar controls
	max number of command line args.
	(mh-index-execute): New function which is to be used
	instead of xargs so that we don't give the shell too many command
	line args.
	(mh-index-update-maps): Use mh-index-execute instead of xargs.
	(mh-index-search): Remove unused code. Also the first message in
	folder buffer is made current.

2002-12-18  Peter S Galbraith  <psg@debian.org>

	* mh-loaddefs.el: Regenerated.

	* mh-comp.el (mh-letter-tool-bar-map): Moved to mh-customize.el

	* mh-e.el (mh-folder-tool-bar-map): Moved to mh-customize.el

	* mh-utils.el (mh-get-msg-num): autoloaded.
	(mh-show-tool-bar-map): Moved to mh-customize.el

	* mh-customize.el (mh-tool-bar-item-*): 33 new defconsts for
	tool-bar setup and customization.
	(mh-tool-bar-folder-buttons-set): New function to setup the
	tool-bar after customization.
	(mh-tool-bar-folder-buttons): New defcustom to specify which icons
	appears in the tool-bar.
	(mh-tool-bar-letter-buttons-set): New function to setup the
	tool-bar after customization.
	(mh-tool-bar-letter-buttons): New defcustom to specify which icons
	appears in the tool-bar.
	(mh-tool-bar-show-set): New function to setup mh-letter-tool-bar-map.
	(mh-tool-bar-letter-set): New function to setup
	mh-letter-tool-bar-map.

2002-12-18  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-folder-mode-map): Change entries for "\t", "\M-\t"
	and backtab to call mh-index-next-folder and
	mh-index-previous-folder as appropriate.

	* mh-index.el (mh-index-next-folder, mh-index-previous-folder):
	New interactive functions which jumps to search results of next
	and previous folders respectively.

	* mh-loadddefs.el: Regenerated.

	* mh-index.el (mh-index-delete-folder-headers): Arrange for
	mh-goto-cur-msg to just go to the current message.

	* mh-e.el (mh-visit-folder): Since mh-scan-folder erases the whole
	buffer anyway, we don't need to delete the folder headers. Also
	index-data is non-nil only when the buffer folder doesn't exist.
	So we need to call mh-make-folder.
	(mh-folder-mode): Fix bug in that mh-index-checksum-origin-map was
	not being made buffer local!

2002-12-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-visit-folder): Fix bug.

	* mh-index.el (mh-md5sum-buffer): Buffer from which md5sum is run.
	(mh-index-folder-first, mh-index-folder-last)
	(mh-index-original-msg-list): Convenience macros aren't needed
	anymore since the data structure has been changed.
	(mh-index-update-single-msg): New function to update maps that
	relate MD5 checksums to actual messages and vice-versa for a
	single message.
	(mh-index-update-maps): Do the above for all messages. If some
	messages don't have MD5 checksums, they are annotated with the
	result of md5sum.
	(mh-index-search): Updated for the new version of mh-index-data.
	(mh-msg-exists-p): New function to test a message exists.
	(mh-index-insert-folder-headers): Updated for new mh-index-data.
	(mh-index-delete-folder-headers): New function used to eliminate
	original folder names from the buffer and make it look like a
	plain folder buffer. This is used from mh-process-commands.
	(mh-index-visit-folder): Use new version of mh-index-data.
	(mh-index-match-checksum): New function which checks if the
	X-MHE-Checksum header of a message matches.
	(mh-index-execute-commands): New function that rmm's the original
	messages. Then after mh-execute-commands executes it will seem
	that the original messages were executed upon. This completes the
	fix of SF #623321.
	(mh-checksum-buffer): Renamed from mh-md5sum-buffer.
	(mh-checksum-cmd, mh-checksum-parser): New globals to allow
	different checksum programs to be used.
	(mh-checksum-choose): New functions to find a checksum program.
	(mh-openssl-parser, mh-md5sum-parser, mh-md5-parser): Functions to
	parse the output of md5, md5sum and openssl.
	(mh-index-update-maps): Use checksum parsing function.
	(mh-index-search): Set checksum choice. Add a call to recenter,
	otherwise the window point in the index buffer doesn't get set
	properly.

	* mh-funcs.el (mh-pack-folder, mh-sort-folder): Enable these
	functions in folders created by index search.

	* mh-e.el (mh-index-msg-checksum-map)
	(mh-index-checksum-origin-map): New buffer local variables that
	keep track of message checksums (used to implement
	refiling/deletion for folders created by index folders).
	(mh-last-msg): Make the function behave like mh-first-msg.
	(mh-visit-folder): Add new optional argument which initializes
	folders created by mh-index-search.
	(mh-folder-mode): Make the variables mh-index-msg-checksum-map and
	mh-index-checksum-origin-map buffer local.
	(mh-process-commands): Call mh-index-execute-commands when called
	from an index search buffer. This will reflect the changes being
	made in the search folder to the original folders.

	* mh-loaddefs.el: Regenerated.

2002-12-16  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-insert-folder-headers): Fix a bug which
	caused the folder buffer to be marked as modified after rescanning
	an index folder.

2002-12-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-visit-folder): The function should insert folder
	names if it is visiting a folder created by index search.

	* mh-index.el (mh-index-insert-folder-headers): The function now
	maintains the old value of buffer-modified-p and temporarily makes
	the buffer writable.

	* mh-utils.el (mh-show-index-visit-folder): New interactive
	function callable from show buffer that displays search results
	from one folder.
	(mh-show-mode-map): Key binding for "v".

	* mh-speed.el: Fix credits.
	(mh-index-folder-speedbar-buttons)
	(mh-index-show-speedbar-buttons)
	(mh-index-folder-speedbar-key-map)
	(mh-index-show-speedbar-key-map)
	(mh-index-folder-speedbar-menu-items)
	(mh-index-show-speedbar-menu-items): Removed since the modes
	mh-index-folder-mode and mh-index-show-mode no longer exist.
	(mh-speed-extract-folder-name): Remove the bits about
	mh-index-folder-mode and mh-index-show-mode.

	* mh-seq.el (mh-copy-seq-to-eob): Updated to work properly with
	index search results.
	(mh-region-to-msg-list): Skip over non-scan lines.
	(mh-thread-inc, mh-thread-add-spaces, mh-thread-folder): Skip
	non-scan lines when populating mh-thread-scan-line-map.
	(mh-thread-folder, mh-toggle-threads): Move the check for buffer
	modification from mh-thread-folder to mh-toggle-threads.
	(mh-toggle-threads): When returning to unthreaded view insert the
	folder names if called from a index folder.

	* mh-index.el: Fix credits and update commentary.
	(font-lock-defaults, mh-index-buffer, mh-index-show-buffer)
	(mh-index-ma-x-msg-index, mh-index-other-buffer)
	(mh-index-matches, mh-index-previous-window-configuration)
	(mh-index-current-msg, mh-index-folder-mode-keymap)
	(mh-index-button-map, mh-index-folder-mode-help-messages): Remove
	eliminated variables.
	(mh-index-folder): New variable sets the MH folder under which the
	index searches are stored.
	(mh-index-folder-first, mh-index-folder-last)
	(mh-index-original-msg-list): Convenience macros used to pull data
	elements out of a list. If needed setf can be used to change them
	as well.
	(mh-index-search): Rewritten to create real folders where all the
	normal folder operation. This partially fixes SF #623321 (refiles
	and deletes doesn't work on original messages).
	(mh-index-find-max-width, mh-index-search-again)
	(mh-index-insert-scan, mh-index-callback, mh-index-search)
	(mh-index-notate, mh-index-show, mh-index-header-display)
	(mh-index-next, mh-index-folder-mode, mh-index-show-mode):
	Functions, macros and modes removed.
	(mh-folder-exists-p): New function to check if a folder exists.
	(mh-index-new-folder): Generate a new folder name from a given
	base string that mimics the way emacs generates buffer names.
	(mh-index-insert-folder-headers): Insert folder names among the
	search results.
	(mh-index-visit-folder): New interactive function to show the
	search results of one individual folder.
	(mh-swish++-execute-search): Update documentation.

	* mh-funcs.el (mh-pack-folder, mh-sort-folder): Disable these
	functions if index search results are being viewed.

	* mh-e.el (mh-folder-font-lock-keywords): Add highlight for
	folder.
	(mh-index-data): New buffer local variable that will be used to
	store info about index search results.
	(mh-rescan-folder): Implement rescanning for index search results.
	(mh-folder-mode): Make mh-index-data buffer local.
	(mh-remove-all-notation): Modified to take into account not all
	lines in the folder buffer are normal scan lines.
	(mh-folder-mode-map): Add key binding for "v" to jump to original
	folder narrowed to search results.

	* mh-customize.el (mh-index-folder-face): Make it bold so that it
	will look like before.

	* mh-loaddefs.el: Regenerated.

2002-12-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-map-to-seq-msgs): Modified so that it can be given
	a list of messages in addition to a sequence.
	(mh-region-to-sequence, mh-region-to-msg-list): The function
	mh-region-to-msg-list replaces mh-region-to-sequence. The new
	function avoids creating a dummy sequence in MH-E.
	(mh-thread-delete, mh-thread-refile, mh-put-msg-in-seq): Modified
	to use mh-region-to-msg-list.

	* mh-funcs.el (mh-copy-msg): Modified to use mh-region-to-msg-list.

	* mh-e.el (mh-delete-msg, mh-refile-msg, mh-undo): Modified to use
	mh-region-to-msg-list.

	* mh-comp.el (mh-forward): Modified to use mh-region-to-msg-list.
	The buffer-local variable mail-header-separator is no longer
	bound. This fixes a bug where the default value of
	mail-header-separator gets used if mh-forward is called in a fresh
	emacs session.
	(mh-annotate-msg): Update this so that it will handle message
	lists too.
	(mh-insert-letter): Make the test stronger. Since %d is being used
	the argument better be an integer.

	* mh-loaddefs.el: Regenerated.

2002-12-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-funcs.el (mh-copy-msg): Add support for transient-mark-mode.
	If mark is active and transient-mark-mode is enabled then all the
	messages in the region are copied.

	* mh-seq.el (mh-list-sequences): Use mh-coalesce-msg-list to print
	messages in sequence nicely. The prompt for the folder is removed
	(the current folder is always used) and the output is made nicer
	by not overflowing the screen width.

	* mh-loaddefs.el: Regenerated.

2002-12-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-letter-complete): Checkdoc fix.

	* mh-seq.el (mh-thread-current-indentation-level): New function
	which returns the thread indentation level of current message.
	(mh-thread-next-sibling, mh-thread-previous-sibling): New
	interactive functions to jump to the next and previous siblings in
	thread tree respectively.
	(mh-thread-immediate-ancestor): New function to jump to ancestor
	of current message in thread tree.
	(mh-thread-ancestor): New interactive function to jump to
	immediate ancestor or to root message of current thread depending
	on optional argument.

	* mh-utils.el (mh-show-thread-ancestor)
	(mh-show-thread-next-sibling, mh-show-thread-previous-sibling):
	Interactive functions callable from the show buffer.
	(mh-show-thread-map): Bindings for Tu, Tp and Tn.

	* mh-e.el (mh-thread-map): Bindings for Tu, Tp and Tn.

	* mh-loaddefs.el: Regenerated.

2002-12-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-region-to-sequence): Change name of region
	sequence created to 'mhe-region. This avoids any chance of
	collision with actual MH sequences.
	(mh-put-msg-in-seq, mh-thread-delete, mh-thread-refile): Change
	name of region sequence used to 'mhe-region. Also delete the
	'mhe-region sequence when done.

	* mh-e.el (mh-delete-msg, mh-refile-msg, mh-undo): Same as above.

	* mh-comp.el (mh-forward): Same as above.

	* mh-loaddefs.el: Regenerated.

2002-12-08  Bill Wohler  <wohler@newt.com>

	* mh-alias.el: Edited documentation. Broke up file into 2
	sections: Alias Loading and Alias Expansion. Made terminology
	consistent (replaced expand, substitute, and translate with
	expand).
	(mh-alias-reload): Brought message in line with coding conventions
	and made more concise too.
	(mh-alias-translate): Renamed to mh-alias-expand.
	(mh-alias-substitute-aliases-flag): Renamed to
	mh-alias-expand-aliases-flag.
	(mh-alias-reload-local-users): Renamed to mh-alias-local-users.
	Now just returns an alist of local users rather than have
	side-effects.
	(mh-alias-reload): Set timestamp at beginning of function to catch
	edge case when alias added just after ali runs. Changed logic to
	reflect return value of mh-alias-local-users.

	* mh-customize.el (mh-alias-substitute-aliases-flag): Renamed to
	mh-alias-expand-aliases-flag.
	(mh-alias-local-users): Fixed documentation.

	* mh-loaddefs.el: Regenerated

2002-12-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (require): Load Gnus at compile time so that the
	constant gnus-version is defined when MH-E is being compiled.
	(mh-macro-expansion-time-gnus-version, mh-run-time-gnus-version):
	Use the constant gnus-version instead of the function gnus-version
	to find out about gnus version information.
	(gnus-version): Remove the autoload since it is not needed any
	more.

2002-12-08  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-version): Moved compilation information in front of
	Emacs information. The idea is that you start at MH-E and move
	outwards. Show N/A if Gnus not compiled (be explicit). Matched
	coding style with other output statements. (Aside: not that
	efficiency matters here, but fewer calls to format have to be
	faster, right? ;-). Matched output style of old output to new
	statement--liked Satyaki's indentation better ;-).

2002-12-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (gnus-version): Autoload the function for use in
	mh-version.
	(mh-macro-expansion-time-gnus-version): New macro that finds the
	Gnus version at macro expansion time.
	(mh-run-time-gnus-version): New function to find the Gnus version
	at run time.
	(mh-version): Add information about Gnus versions available at
	compile time and run time.

2002-12-07  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-ali): Add optional argument.  if USER is
	t, then assume ALIAS is an address and call ali with option -user.

	* mh-alias.el (mh-alias-filenames): if ARG is t, appends list of
	files from `mh-alias-system-aliases' to output list obtained from
	mhparam output user list only.
	(mh-alias-tstamp): Use it.

2002-12-05  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-inline-vcard-p): A new function which decides if
	a vcard should be displayed inline.
	(mh-mime-display-single): Use mh-inline-vcard-p to display
	attached vcard as a signature if no other signature is present
	(this partially addresses SF #649216).

2002-12-05  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-send-letter): Edits docs for mh-mml-to-mime
	getting run if variable `mh-mml-compose-insert-flag' is set.
	(mh-get-header-field): use buffer-substring-no-properties instead
	of buffer-substring.

2002-12-04  Peter S Galbraith  <psg@debian.org>

	* mh-loaddefs.el: Regenerated.

	* mh-customize.el (mh-customize): Add ;;;###mh-autoload tag.

2002-12-04  Peter S Galbraith  <psg@debian.org>

	* mh-loaddefs.el: Regenerated.

	* mh-comp.el (mh-letter-complete): New command to do alias or word
	completion in letter-mode.
	(mh-letter-mode-map): Add \M-\t binding for mh-letter-complete.

	* mh-alias.el (mh-alias-letter-mode-expand-alias-hook): Obsolete.
	Replaced by mh-letter-complete command.
	(mh-alias-reload-maybe): New function to rebuild alias table if
	out of date.
	(mh-alias-letter-expand-alias): No longer interactive.  Use
	mh-letter-complete instead.

2002-12-04  Peter S Galbraith  <psg@debian.org>

	* mh-customize.el (mh-letter-complete-function): New defcustom.
	Function to call when completing outside of fields specified to
	aliases.

	* mh-alias.el (mh-alias-filenames):
	s/mh-mhparam-component/mh-profile-component/
	(mh-profile-component): Move to mh-utils.el and make interactive.
	(mh-read-address): Make it autoloaded.

	* mh-loaddefs.el: Regenerated.

	* mh-comp.el (mh-read-address): Removed.  Replaced by mh-alias
	version.

	* mh-utils.el (mh-profile-component): Moved from mh-alias.el.

2002-12-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-msg-is-in-seq): Formatting change.

	* mh-index.el (mh-index-insert-scan): Remove unused variable.

2002-12-04  Bill Wohler  <wohler@newt.com>

	* mh-loaddefs.el: Regenerated.

	* Makefile (MH-E-SRC): Moved mh-loaddefs.el into MH-E-LOADDEFS as
	this was causing a cycle.
	(MH-E-LOADDEFS): New variable to house mh-loaddefs.el.
	(emacs): Reintroduced autoloads.
	(autoloads): We're baaa-aack!
	(dist, install-emacs): Use MH-E-LOADDEFS.

	* mh-comp.el (mh-customize): Moved to mh-customize.el.

	* mh-customize.el (mh-customize): Moved here from mh-comp. Makes
	more sense, doesn't it?

	* mh-alias.el, mh-comp.el, mh-e.el, mh-index.el, mh-mime.el,
	mh-pick.el, mh-speed.el: Added mh-autoload cookie to all
	interactive functions.

2002-12-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* Makefile (world): Remove target.
	(mh-loaddefs.el): Add comment that only GNU Emacs can be used to
	regenerate mh-loaddefs.el.

	* mh-make.el: Removed.

2002-12-04  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (recursive-load-depth-limit): Only modify the limit
	if it is an integer.

2002-12-04  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-header-field-beginning): New function. Move to
	the beginning of the current header field.

2002-12-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-make.el (mh-files): Read in the MH-E filenames from the
	environment variable where the Makefile puts it.
	(mh-generate-autoloads, step2): Simplified since we now have the
	complete file names.

	* Makefile (world): Pass the MH-E files into the script, so that
	the filenames don't need to be repeated in the script.

2002-12-04  Bill Wohler  <wohler@newt.com>

	* mh-loaddefs.el: New file. Check in automatically generated file
	and include in package for the benefit of those who don't want to
	or can't compile.

	* Makefile (MH-E-SRC): Added mh-loaddefs.el now that it is checked
	in and will be packaged.
	(emacs): Removed autoloads. Adding mh-loaddefs.el to MH-E-SRC is
	sufficient to build it.
	(compile): Depend on MH-E-SRC instead of MH-E-OBJ and pass $? into
	emacs so that Emacs is only invoked once to compile files. This
	speeds things up by a factor of 3. It would be nice to only pass
	those files that have been modified, but Emacs 21.4 will have
	batch-byte-compile-if-not-done which we might be able to copy into
	mh-make.el (or my proposed mh-e-dev.el which would be more
	general-purpose).
	(.SUFFIXES): Removed. Now that compile works directly on the
	sources, the implicit rule is obsolete.
	(autoloads): Deleted. See emacs change above.

2002-12-03  Bill Wohler  <wohler@newt.com>

	* Makefile (MH-E-SRC, emacs):

2002-12-03  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-make.el (mh-emacs): Make failing condition more strict.
	(mh-loaddefs-end): Remove redundant statement.

	* Makefile (world): A little typo. The bug didn't seem to make any
	difference though.

	* mh-make.el: New script that compiles MH-E.
	(mh-loaddefs-beginning, mh-loaddefs-end): Don't save the autoloads
	file in between. Only save at the end.
	(mh-emacs-generate-autoloads, mh-xemacs-generate-autoloads)
	(mh-generate-autoloads): Replace the separate functions in Emacs
	and XEmacs with one that works in both variants. This simplifies
	the script a lot.
	(mh-generate-autoloads): doc fix.

	* Makefile (world): New target which works for both GNU Emacs and
	XEmacs.

2002-12-03  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-mhparam-component): Don't raise error if call to
	mhparam fails.

	* mh-alias.el (mh-alias-letter-expand-alias): Build alias table if
	not already available.

2002-12-03  Bill Wohler  <wohler@newt.com>

	* mh-customize.el (mh-show-threads-flag): Alphabetized.

2002-12-03  Jeffrey C Honig  <jch@honig.net>

	* Makefile: Moved .PHONY rule after all rule for compatibility
	with BSD/OS's old pmake.

2002-12-03  Mark D Baushke  <mdb@gnu.org>

	* mh-e.el (mh-get-new-mail): Simplify no-new-mail test.
	(mh-add-cur-notation): Remove unnecessary function.

2002-12-03  Peter S Galbraith  <psg@debian.org>

	* mh-identity.el (mh-identity-make-menu): Check if
	'mh-letter-mode-map' is bound, since this code also gets run when
	mh-customize.el is loaded at startup.

2002-12-03  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-customize.el (mh-show-threads-flag): New customizable
	variable which controls if new folders start of in threaded mode
	(closes SF #646794).

	* mh-e.el (mh-rescan-folder): Fix the function so that threading
	is preserved across rescans.
	(mh-visit-folder, mh-inc-folder): The folder is threaded if it was
	already threaded or if mh-show-threads-flag is non-nil and the
	number of scan lines is fewer than mh-large-folders (closes SF
	#646794).

2002-12-02  Mark D Baushke  <mdb@gnu.org>

	* mh-e.el (mh-add-cur-notation): New function to mark the
	current message with the mh-note-cur character.
	(mh-get-new-mail): Use mh-add-cur-notation to undo the work of
	mh-remove-cur-notation if there was no new mail	(closes SF #647681).

	* mh-e.el (mh-set-cmd-note): Do not update the default mh-cmd-note
	value (closes SF #643701).

2002-12-02  Peter S Galbraith  <psg@debian.org>

	* mh-alias.el (mh-alias-reload): Renamed from mh-alias-learn-aliases.
	(mh-alias-load-local-users): Renamed from mh-alias-learn-local-users.
	(mh-alias-passwd-alist): New variable, holding aliases extracted
	from the passwd file.
	(mh-alias-tstamp): New variable storing the timestamp for alias
	list generation.
	(mh-read-address, mh-alias-reload, mh-alias-reload-local-users):
	Complete rewrite.
	(mh-alias-minibuffer-confirm-address): Use mh-alias-translate.
	(mh-alias-translate): New function.  Return translation for alias,
	checking if in blind or passwd list.
	(mh-alias-letter-expand-alias): Rewrite using
	mail-abbrev-complete-alias from mailabbrev.el
	(mh-alias-expand-alias-map): New variable.
	(mh-alias-ali): New function. Return formatted string of
	translated ALIAS from ali.
	(mh-mhparam-component): New function. Return COMPONENT value from
	mhparam, or nil if unset.
	(mh-alias-filenames): New function. Provide list of alias
	filenames from mhparam, or nil if none are set.

	* mh-customize.el (mh-alias-display-blind-name-on-completion-flag):
	Obsoleted.
	(mh-alias-timestamp): Renamed to mh-alias-system-aliases.

2002-12-02  Bill Wohler  <wohler@newt.com>

	* Makefile (mh-loaddefs.el): Suppress creation of backup file.

2002-12-02  Mark D. Baushke  <mdb@gnu.org>

	* Makefile (mh-loaddefs.el): Simplify rule.

	* Makefile (clean): Remove mh-loaddefs.el* for good measure.
	($(MH-E-OBJ)): Depend on mh-loaddefs.el to compile these.
	(autoloads, mh-loaddefs.el): Revamp rules.
	(mh-loaddefs.el-tail, autoloads-gen): Remove rules.

	* mh-e.el (recursive-load-depth-limit): Do not try to
	bump the value unless the variable exists.

	* mh-e.el (recursive-load-depth-limit): Bump value of
	recursive-load-depth-limit to 50 to allow emacs 21.1 which
	normally has a default value of 10 to be able to compile MH-E.

2002-12-02  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-funcs.el (mh-pack-folder, mh-sort-folder): Fix the functions
	so that threading is preserved (needed for SF #646794).

	* mh-identity.el (mh-identity-signature-start)
	(mh-identity-signature-end): Checkdoc fixes.

	* mh-e.el (mh-previous-unread-msg, mh-next-unread-msg): Checkdoc
	fixes.

2002-12-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-identity.el (compile): Make mh-identity.el compile without
	warnings.

	* mh-e.el (mh-previous-unread-msg, mh-next-unread-msg): New
	interactive functions that go to next and previous unread
	messages (closes SF #630328).
	(mh-folder-mode-map): Add key bindings for M-n and M-p to
	mh-folder-mode-map.

	* mh-utils.el (mh-show-next-unread-msg)
	(mh-show-previous-unread-msg): New interactive functions that go
	to the next and previous unread messages respectively. These are
	callable from the show buffer.
	(mh-show-mode-map): Add key bindings for M-n and M-p to
	mh-show-mode-map.

2002-12-01  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-defun-compat): Make it indent like a defun.

	* mh-index.el (mh-defun-index): Make it indent like a defun.

	* mh-customize.el: New file (closes SF #643722).

	* Makefile (MH-E-SRC): Added mh-customize.el (closes SF #643722).

	* mh-speed.el, mh-pick.el, mh-mime.el, mh-index.el, mh-e.el,
	mh-comp.el: Moved all defgroups, defcustoms, and deffaces to
	mh-customize.el (closes SF #643722).

	* mh-utils.el (mh-xemacs-flag): Moved here from below since
	needed by mh-customize.el.
	(mh-customize): Required. mh-invisible-headers)
	(mh-bury-show-buffer-flag, mhl-formfile):
	Moved all defgroups, defcustoms, and deffaces to mh-customize.el
	(closes SF #643722) .

	* mh-identity.el (mh-comp-loaded): New variable in a desparate
	attempt to prevent an infinite loop.
	(eval-when-compile): Was able to remove these defvars as they are
	now predefined in mh-loaddefs and mh-customize.
	(mh-identity-list-set): Added ;;;###mh-autoload cookie.
	Moved all defgroups, defcustoms, and deffaces to mh-customize.el
	(closes SF #643722).

	* mh-alias.el (mh-e): Require this, as it needs defcustoms, which
	is in mh-customize which is required by mh-utils which is required
	by mh-e.
	Moved all defgroups, defcustoms, and deffaces to mh-customize.el
	(closes SF #643722).

2002-11-30  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-thread-map): Add key bindings "Td" and "To" (closes
	SF #630493).
	(mh-help-messages): Update help message for prefix map.
	(mh-help-messages): Doc fix.
	(mh-help-messages): Really fix it.

	* mh-utils.el (mh-show-thread-delete, mh-show-thread-refile): New
	interactive functions corresponding to mh-thread-delete and
	mh-thread-refile callable from the show buffer.
	(mh-show-thread-map): Add key bindings for "Td" "To".

	* mh-seq.el (mh-narrow-to-seq, mh-put-msg-in-seq, mh-rename-seq)
	(mh-narrow-to-subject, mh-delete-subject, mh-toggle-threads): Add
	mh-autoload cookies.
	(mh-thread-find-children): New function which finds the region
	containing all children of a message.
	(mh-thread-delete): New interactive function that marks for
	deletion the current message and its children.
	(mh-thread-refile): New interactive function that marks for
	refiling the current message and its children.

2002-11-30  Bill Wohler  <wohler@newt.com>

	* mh-funcs.el, mh-identity.el, mh-index.el, mh-pick.el, mh-seq.el:
	Removed MH-E autoloads. These are now provided by mh-loaddefs.el.
	Added ;;;###mh-autoload tag to selected functions so that
	autoloads for those functions can be automatically created in
	mh-loaddefs.el (closes half of SF #643722).

	* mh-mime.el (mh-buffer-data): Moved to mh-utils where it is used.
	Added ;;;###mh-autoload tag to selected functions so that
	autoloads for those functions can be automatically created in
	mh-loaddefs.el (closes half of SF #643722)..

	* mh-utils.el (mh-loaddefs): Added require.
	(mh-buffer-data): Moved here from mh-mime.el as it is used in
	mh-display-msg.
	(mh-set-cmd-note): Moved to mh-e.el.
	Removed MH-E autoloads. These are now provided by mh-loaddefs.el.
	Added ;;;###mh-autoload tag to selected functions so that
	autoloads for those functions can be automatically created in
	mh-loaddefs.el (closes half of SF #643722)..

	* mh-e.el (mh-set-cmd-note): Moved here from mh-utils.el since it
	uses mh-scan-format-file which is defined here.
	Removed MH-E autoloads. These are now provided by mh-loaddefs.el.
	Added ;;;###mh-autoload tag to selected functions so that
	autoloads for those functions can be automatically created in
	mh-loaddefs.el (closes half of SF #643722)..

	* mh-comp.el, mh-speed.el (mh-utils): Removed require. mh-utils is
	provided via mh-e.el.
	Removed MH-E autoloads. These are now provided by mh-loaddefs.el.
	Added ;;;###mh-autoload tag to selected functions so that
	autoloads for those functions can be automatically created in
	mh-loaddefs.el (closes half of SF #643722)..

	* Makefile (emacs): Add dependency on autoloads.
	(clean): Remove mh-loaddefs.el too.
	(autoloads): New target. Builds mh-loaddefs.el.
	(mh-loaddefs.el): New target. Initializes mh-loaddefs.el.
	(mh-loaddefs.el-tail): New target. Appends to mh-loaddefs.el.
	(autoloads-gen): Runs batch-update-autoloads to populate
	mh-loaddefs.el (closes half of SF #643722)..
	(auto-autoloads.elc): Renamed from autoloads to be explicit about
	file that's created.
	(custom-load.elc): Ditto.

2002-11-30  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-last-ancestor): New variable which keeps
	track of oldest ancestor of last message. If due to narrowing the
	common ancestor of two messages is lost then one of them is
	promoted to be the parent of the other. This variable helps in
	this process.
	(mh-thread-generate-scan-lines): Group messages which belong to
	the same thread tree, even if a common ancestor is no longer
	present.
	(mh-thread-folder, mh-copy-seq-to-eob, mh-thread-inc): Bind
	mh-thread-last-ancestor to nil when calling
	mh-thread-generate-scan-lines.

	* mh-mime.el (font-lock): Font-lock required at compile time to
	avoid warning about font-lock-maximum-size
	(mh-display-smileys, mh-display-emphasis): Show graphical smileys
	and emphasis only if message isn't too large.

	* mh-e.el (mh-visit-folder): Revisiting a buried folder which has
	been threaded or narrowed confuses MH-E. Even though the folder is
	displayed as not threaded and not narrowed, MH-E still believes
	the folder is in the previous state. This can cause problems when
	trying to narrow/thread the folder. The change fixes this.

	* mh-mime.el (mh-mime-display-alternative): The setting of
	mh-display-buttons-for-inline-parts-flag was not being used when
	displaying one of the alternatives. This change fixes that.

	* mh-comp.el (mh-show-buffer-message-number): Replace subseq with
	substring.
	(mh-filter-out-non-text): When filtering out MIME buttons from
	yanked text, the last line of the MIME part was getting lost. The
	fix avoids that and removes only the last new line instead.

2002-11-29  Peter S Galbraith  <psg@debian.org>

	* Makefile (MH-E-SRC): Add mh-alias.

	* mh-alias.el: Assign copyright to FSF instead of myself.
	(mh-read-address): Add support for emacs-21's
	completing-read-multiple to prompt for multiple entries.
	(mh-alias-PC-complete-address): Deleted.
	(mh-alias-learn-aliases): Use mh-exec-cmd-quiet instead of old kludge.
	(mh-alias-letter-mode-expand-alias-hook): Simplify.
	(mh-alias-hostname): Deleted.
	(mh-alias-substitute-aliases-flag): Change default to nil.
	(mh-alias-display-blind-name-on-completion-flag) Change default to
	nil.
	(mh-alias-alist): Now holds alias values.
	(mh-alias-lowercase-alist): Deleted.
	(mh-alias-minibuffer-confirm-address, mh-alias-learn-aliases)
	(mh-alias-learn-local-users, mh-alias-letter-expand-alias): Use
	new mh-alias-alist instead of old mh-alias-lowercase-alist.

	* mh-alias.el: Moved from contrib/ directory.  Now part of MH-E!

	* Makefile (MH-E-SRC): Add mh-identity.

	* mh-identity.el (mh-compose-and-send-mail, mh-insert-identity)
	(mh-identity-make-menu, mh-identity-default, mh-identity-menu):
	Moved to mh-comp.el.

	* mh-comp.el (mh-compose-and-send-mail): Add mh-identity support.
	(mh-insert-identity, mh-identity-make-menu, mh-identity-default)
	(mh-identity-menu): Added from mh-identity.el

2002-11-29  Bill Wohler  <wohler@newt.com>

	* mh-comp.el, mh-e.el, mh-funcs.el, mh-identity.el, mh-index.el,
	mh-mime.el, mh-pick.el, mh-seq.el, mh-speed.el, mh-utils.el:
	Ran indent-region, reformatted long lines, ran untabify.
	(indent-tabs-mode): Set file local variable to nil.

2002-11-29  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 7.0.

	* mh-e.el (Version, mh-version): Updated for release 7.0.

	* mh-comp.el (subseq, search): Require cl instead of autoloading
	these due to compilation warnings in CVS Emacs.

2002-11-23  Bill Wohler  <wohler@newt.com>

	* MH-E-NEWS: Emphasize the renaming of the variables at the top of
	the notes.

2002-11-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-mode-map): Remove binding for RET since it
	is not needed and the binding is more useful to toggle display of
	MIME parts.

	* mh-mime.el (mh-mime-button-commands): Remove bindings for "i"
	and "o" from MIME buttons.
	(mh-insert-mime-button): Change comment to reflect change in
	button key map.

2002-11-21  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 6.1.91.

	* mh-e.el (Version, mh-version): Updated for release 6.1.91.

	* MH-E-NEWS: Inline HTML parts supported with Gnus 5.10, not 5.9.

2002-11-21  Mark D. Baushke  <mdb@gnu.org>

	* mh-comp.el (mh-letter-insert-signature-hook): This should be in
	customize-group mh-compose.

2002-11-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (load): Load mm-view.el here so that
	mm-inline-text-html would be defined if available.
	(mh-mm-inline-media-tests): If mm-inline-text-html is available
	then use it, otherwise fall back on using mm-inline-text (closes
	SF #641482).

	* mh-mime.el (load): Remove the load of mm-view here since it
	happens in mh-utils.el now.

2002-11-15  Bill Wohler  <wohler@newt.com>

	* Released MH-E version 6.1.90.

	* README (Compile): New section. Users must now compile MH-E due
	to the vagaries of the various versions of gnus.

	* Makefile (MH-E-IMG): Added reply-all.pbm, reply-all.xpm,
	reply-from.pbm, reply-from.xpm, reply-to.pbm, reply-to.xpm.
	(MH-E-ETC-ETC): Added Makefile and README.
	(dist): Depend on all, so clean happens. Don't add .elc files to
	tarball as they are built upon installation now.

2002-11-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-process-commands): Fix a bug in mh-execute-commands.
	If called in threaded mode, cur was always getting set to the last
	message in the folder.

2002-11-14  Bill Wohler  <wohler@newt.com>

	* mh-e.el (Version, mh-version): Updated for release 6.1.90.

	* MH-E-NEWS, README: Updated for release 7.0.

	* mh-utils.el (mh-index-search): Added full docstring which new
	users will need before they run a search!
	(mh-swish++-execute-search, mh-swish-execute-search,
	mh-namazu-execute-search mh-glimpse-execute-search): Added
	autoloads with full docstrings for the same reason!

	* mh-e.el (mh-limit-map): Removed / / alias for
	mh-narrow-to-subject.

	* mh-utils.el (mh-show-thread-map): Removed / / alias for
	mh-show-narrow-to-subject.

	* mh-seq.el (mh-delete-subject): Checkdoc fix.

	* mh-e.el (mh-help-messages): Added / prefix character to help
	string. Tweaked / helpstring a little.

2002-11-14  Mark D. Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-set-cmd-note): Fix nitpick by adding one to the
	width for cosmetic reasons.

2002-11-14  Peter S Galbraith  <psg@debian.org>

	* mh-identity.el (mh-insert-identity): Fix a few things undone by
	Jeff's patch.
	(mml-insert-tag): Add autoload.

2002-11-13  Mark D. Baushke  <mdb@gnu.org>

	* mh-identity.el (mh-insert-identity):  A value of either nil or
	"" should cause the field to be removed.
	(mh-identity-list): Update the docstring.

2002-11-13  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-limit-map): New key map for limits (subject for now).
	* mh-utils.el (mh-show-limit-map): Same.

	* mh-seq.el (mh-delete-subject): Renamed from
	mh-delete-subject-sequence.
	(mh-narrow-to-subject): Renamed from mh-narrow-to-subject-sequence.
	(mh-next-unseen-subject-sequence): Removed. :-(
	* mh-e.el: Use 'em
	* mh-seq.el: Use 'em.

2002-11-13  Mark D. Baushke  <mdb@gnu.org>

	* mh-e.el (mh-alt-show): New defalias for mh-show.
	(mh-alt-refile-msg): New defalias for mh-refile-msg.
	(mh-alt-send): New defalias for mh-send.
	(mh-folder-mode-map): Use mh-alt-show, mh-alt-refile-msg and
	mh-alt-send for the alias bindings.
	(mh-alt-visit-folder): New defalias for mh-visit-folder.
	(mh-folder-map): Use it.
	(mh-folder-message-menu): Revert previous change.

2002-11-13  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-message-menu): Make key binding "o" appear in
	menu for mh-refile-msg.

2002-11-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate-scan-lines): In threaded view,
	scan lines of duplicate messages were too long. The change fixes
	that.

2002-11-13  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (mh-adaptive-cmd-note-flag): Improved grammar in
	docstring.

	* mh-speed.el (mh-speed-run-flists-flag): While documenting this
	variable in the release notes, I was unsure what would happen if
	set to nil. So, I clarified the docstring and indicated
	implications of setting this variable to nil, and offered manual
	workaround.

2002-11-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-quit): Fix documentation and run
	mh-before-quit-hook and mh-quit-hook.

2002-11-13  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (with-mh-folder-updating): Renamed local variable
	mh-save-modification-flag to save-modification-flag.

2002-11-12  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-index-keymap): Renamed to
	mh-index-folder-mode-keymap to be a closer to the usual keymap
	naming convention. Since we want our own keymap and not inherit
	the one in mh-folder-mode, we need to use a suffix other than
	-map.

	* mh-e.el (mh-folder-sequence-menu): s/Msg/Message.
	s/Seq/Sequence.
	(mh-folder-message-menu): s/Msg/Message. Removed redundant refile
	item.
	(mh-folder-folder-menu): Aligned symbols.

	* mh-index.el (mh-index-folder-message-menu): s/Msg/Message.

	* mh-utils.el (mh-show-sequence-menu): s/Msg/Message.
	s/Seq/Sequence.
	(mh-show-message-menu): s/Msg/Message. Removed redundant refile
	item.
	(mh-show-folder-menu): Aligned symbols.

2002-11-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-matches, mh-index-current-match): Remove
	these variables since they were only used for glimpse and grep.
	Now the functionality of all the indexing programs will be
	uniform.
	(mh-index-search, mh-index-insert-scan, mh-defun-index)
	(mh-index-show): Simplify functions since matches are no longer
	shown.
	(mh-index-parse-match): Remove function.

	* mh-e.el (mh-scan-cmd-note-width, mh-scan-destination-width)
	(mh-scan-date-width, mh-scan-date-flag-width)
	(mh-scan-from-mbox-width, mh-scan-from-mbox-sep-width): New
	variables to keep track of the widths of the different fields in
	the scan lines.
	(mh-scan-field-from-start-offset, mh-scan-field-from-end-offset)
	(mh-scan-field-subject-start-offset): Offsets that are computed
	from the scan line widths.

	* mh-seq.el (mh-copy-seq-to-eob, mh-thread-inc)
	(mh-thread-parse-scan-line): Use new variables that remember the
	various offsets in place of integer constants.
	(mh-thread-generate-scan-lines): Space shouldn't be added here!

2002-11-12  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-scan-format-mh, mh-scan-format-nmh): Noted that the
	first column is column number 0 and changed "sixth column" to
	"fifth column" accordingly.

	* mh-index.el (mh-index-folder-mode): Clarified method of replying
	in mode documentation.
	(mh-index-folder-tool-bar-map): s/mh-e/MH-E/.

	* mh-e.el (mh-generate-new-cmd-note): Try not to mention internal
	variable mh-cmd-note in docstrings.

	* mh-utils.el (mh-adaptive-cmd-note-flag): Set default value to t.
	Reworded docstring so it doesn't mention internal variable
	mh-cmd-note. Added information about using fixed-width message
	numbers.
	(mh-cmd-note): Mention mh-set-cmd-note in docstring. Also suggest
	that it is updated dynamically only if mh-scan-format-file is t.
	(mh-set-cmd-note): Grammer fix in docstring.
	(mh-cmd-note): Noted that the first column is column number 0.

	* mh-e.el (mh-scan-format-file): Added information about
	mh-set-cmd-note and mh-adaptive-cmd-note-flag to docstring.

	* mh-index.el (mh-index-keymap): Added bindings for i
	(mh-inc-folder), m (mh-send alias), and s (mh-send) since these
	appear to be supported and are found in the toolbar.
	(mh-index-folder-key-map): Ditto for f (mh-visit-folder alias), o
	(mh-visit-folder) alias, and v (mh-visit-folder).
	(mh-index-folder-mode-help-messages): Changes for above.
	(mh-index-folder-message-menu, mh-index-folder-folder-menu): New
	menus. I decided to delete the unavailable items since greying out
	implies that the user can do something to access them. In this
	case, that's not the case. Well, that's not entirely true--the
	user could write code for those functions ;-).
	(mh-index-folder-mode): Use new menus.

	* mh-utils.el (mh-prompt-for-folder): Added optional argument
	default-string which can be used in case the string for default
	isn't intuitive enough.

	* mh-index.el (mh-index-search): Made default prompt more
	intuitive (I hope!).

2002-11-11  Peter S Galbraith  <psg@debian.org>

	* mh-identity.el (mh-header-field-delete): Remove save-excursion.
	Strange that this worked for me before... Thanks to Jeff for the
	patch.
	(mh-insert-identity): Numerous tweaks and fixes from Jeff who also
	adds a nicer-looking MIME header for signatures inserted after
	MIME insertions.

2002-11-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-parse-scan-line): Generalize this function
	so that it can take a string containing the scan-line as argument
	in addition to using the line at point.
	(mh-thread-add-spaces): New function to pad each scan line to the
	appropriate length. This is called when mh-cmd-note is increased.

	* mh-e.el (mh-generate-new-cmd-note): Make this work on a threaded
	folder by using mh-thread-add-spaces to pad the pre-existing lines
	in mh-thread-scan-line-map appropriately.
	(mh-thread-add-spaces): Autoload from mh-seq.

2002-11-11  Mark D. Baushke  <mdb@gnu.org>

	* mh-index.el: Fix checkdoc nit.

	* mh-mime.el (mh-display-buttons-for-inline-parts-flag): Renamed
	from mh-display-buttons-for-inline-parts.
	(mh-mime-display-single): Use it.
	This addresses part of SF #627015.

	* mh-e.el (mh-print-background-flag): Renamed from
	mh-print-background.
	* mh-funcs.el (mh-print-msg): Use it.
	This addresses part of SF #627015.

	* mh-comp.el (mh-delete-yanked-msg-window-flag): Renamed from
	mh-delete-yanked-msg-window.
	(mh-yank-from-start-of-msg, mh-yank-cur-msg): Use it.
	This addresses part of SF #627015.

	* mh-utils.el (mh-update-sequences-after-mh-show-flag): Renamed
	from mh-update-sequences-after-mh-show.
	(mh-show-msg): Use it.
	This addresses part of SF #627015.

	* mh-utils.el (mh-decode-quoted-printable-flag): Renamed from
	mh-decode-quoted-printable
	(mh-display-msg, mh-decode-quoted-printable-have-mimedecode):
	Use it.
	This addresses part of SF #627015.

	* mh-utils.el (mh-recursive-folders-flag): Renamed from
	mh-recursive-folders.
	(mh-make-folder-list-background): Use it.
	* mh-funcs.el (mh-list-folders): Ditto.
	This addresses part of SF #627015.

	* mh-utils.el (mh-auto-folder-collect-flag): Renamed from
	mh-auto-folder-collect.
	(mh-find-path): Use it.
	This addresses part of SF #627015.

	* mh-utils.el (mh-decode-mime-flag): Renamed from
	mh-decode-mime.
	* mh-utils.el (mh-show-mode, mh-show-xface)
	(mh-decode-quoted-printable, mh-display-msg, mh-display-msg): Use it.
	* mh-mime.el (mh-graphical-smileys-flag)
	(mh-graphical-emphasis-flag): Ditto.
	* mh-index.el (mh-index-search, mh-index-show): Ditto.
	* mh-e.el (mh-header-display): Ditto.
	This addresses part of SF #627015.

	* mh-e.el (mh-make-folder-mode-line): Use save-window-excursion
	to get back to the current message.

2002-11-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-keymap, mh-index-page-msg)
	(mh-index-folder-tool-bar-map): Replace mh-index-scroll-up with
	mh-index-page-msg.
	(mh-index-keymap, mh-index-previous-page): Replace
	mh-index-scroll-down with mh-index-previous-page.

2002-11-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (autoload/require): Load mh-mime when mh-index.el is
	loaded. This fixes the infinite load loop. I am not sure what the
	actual problem is. Also removed the nop requires/autoloads.
	(mh-defun-index): Use the right argument for mh-recenter.
	Otherwise it misbehaves for the default value of
	mh-summary-height.

	* mh-e.el (mh-goto-next-button): Fix infinite loop when S-Tab was
	used on first line of index folder buffer.

2002-11-09  Peter S Galbraith  <psg@debian.org>

	* mh-index.el (mh-index-folder-tool-bar-map): Tool-bar for
	mh-index-mode.
	(mh-index-folder-mode): Use it.
	(mh-index-keymap): Added mouse-2 binding, like in regular
	folder-mode.

2002-11-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-folder-mode): Fix doc string for major
	mode. It was pointing to the wrong keymap.
	(mh-index-show-mode): Fix doc string for mode. Also add mh-help
	support.

	* mh-comp.el (mh-forward, mh-yank-cur-msg): Use new macro
	mh-mark-active-p instead. This does the right thing for different
	variants of Emacs.
	(mh-yank-cur-msg): Add a space between sexprs.

	* mh-utils.el (mh-mark-active-p): New macro which papers over
	diffences between GNU Emacs and XEmacs. The variables mark-active
	and transient-mark-mode are used in GNU Emacs while zmacs-regions
	and region-active-p are used in XEmacs.

	* mh-seq.el (mh-put-msg-in-seq, mh-thread-ancestor-p): Use
	mh-mark-active-p as above.

	* mh-e.el (mh-delete-msg, mh-refile-msg, mh-undo): Use
	mh-mark-active-p as above.

2002-11-06  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-cur-msg): Fix for XEmacs.  It didn't work
	with a selected region, and left the inserted text selected (in
	reverse video).  I didn't use SF patch #402315 to implement this.

2002-11-05  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-show-tool-bar-map): Change call to
	mh-tool-bar-search-command such that user can customize it for the
	current session.

	* mh-e.el (mh-folder-tool-bar-map): Same.

2002-11-05  Bill Wohler  <wohler@newt.com>

	* mh-utils.el, mh-e.el (mh-tool-bar-search-function): Renamed from
	mh-tool-bar-search-command.

	* mh-index.el (mh-index-search): Backed out previous change to
	prompt. There ain't no folder named "all."

	* mh-utils.el (mh-tool-bar-search-command): Added mh-search-folder
	and mh-index-search to the docstring so that user can easily click
	on them for more information.

	* mh-pick.el (mh-search-folder): Mention that this function uses
	the MH pick command to give the user more information when
	choosing between mh-search-folder and mh-index-folder.

	* mh-index.el (mh-index-search): Edited the docstring. Direct the
	 user to mh-index-program if necessary.
	 (mh-index-program): Edited this docstring too. Viewing the help
	 in a *Help* buffer really exposes grammatical flaws.

2002-11-05  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-tool-bar-search-command): New defcustom to set
	what search function to use in tool-bar.
	(mh-show-tool-bar-map): Use it.

	* mh-e.el (mh-folder-tool-bar-map): Use it.

2002-11-05  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-index-search): Changed default prompt from "+"
	to "all". mh-prompt-for-folder doesn't seem to mind.

	* mh-e.el (mh-folder-folder-menu): Added menu entry for
	mh-index-search.

	* mh-utils.el (mh-show-folder-menu): Added menu entry for
	mh-index-search.

	* mh-index.el: Added commentary on supported search engines and
	for getting started (initializing database).

2002-11-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-keymap, mh-index-folder-key-map): Move key
	binding of "i" to "Fi".
	(mh-index-folder-mode-help-messages): Change help message to
	reflect above change.

2002-11-04  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-index-program, mh-indexer): Swapped names since
	the former seems like a better user variable name. If you've
	customized mh-indexer, be sure to toss it out and customize
	mh-index-program.

2002-11-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-indexer-choices): Not having the quotes in the
	binary names is a bit nicer since that maintains uniformity with
	the other names.
	(mh-index-choose): Use symbol-value instead of eval. Eval should
	be avoided except when it can't be :-).

2002-11-04  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-index-program): New variable to hold the name of
	the indexer that was found; use this instead of clobbering
	user-customizable variable mh-indexer.
	(mh-index-search): Use it. Added comments to keep others from
	doing what I had done (fortunately, I caught myself before
	checking it in ;-).
	(mh-index-choose): Set mh-index-program instead of mh-indexer.
	Update docstring to describe side-effects.

	* mh-index.el (mh-indexer): Added swish++ to docstring. Chances
	are good that if someone has both swish++ and swish, they want to
	use the much faster, much smaller swish, so move it up in the
	list.
	(mh-indexer-choices): Ditto for rationale for moving swish++ up in
	priority over swish. Also, use -binary symbols instead of
	hard-coding binary names. This allows package installers to
	customize the location of the binaries in site-lisp and still have
	the auto-detection code work. It also allows one to have alternate
	binary names (see mh-swish++-binary).
	(mh-index-search): Ditto (moving swish++ up).
	(mh-swish++-binary): Look for search++, then search. The rationale
	is that a package maintainer may rename search to search++ if
	search is already in use (e.g., Debian) so try it first.
	(mh-swish++-execute-search): Replaced Satyaki's path with dummy
	path in docstring. Also removed RecurseSubdirs since this is the
	default. Added comment that index might be named index++ on some
	systems (e.g., Debian).
	(mh-index-choose): Updated to work with new mh-indexer-choices.

2002-11-04  Peter S Galbraith  <psg@debian.org>

	* mh-identity.el (mh-identity-list-set): Don't call easy-menu-add
	here, since that adds the menu to the Customize buffer in XEmacs.

2002-11-04  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-mhn-compose-insert-flag)
	(mh-mml-compose-insert-flag): Removed eval-when-compile defvar.

	* mh-mime.el (mh-mhn-compose-insert-flag)
	(mh-mml-compose-insert-flag): Move variables to mh-utils.el.
	Fixes mh-letter-menu for XEmacs.

2002-11-04  Eric Ding  <eding@rational.com>

	* mh-comp.el (mh-rejected-letter-start): add another string

2002-11-04  Eric Ding  <ericding@alum.mit.edu>

	* mh-comp.el (mh-rejected-letter-start): regexp-opt doesn't take
	regexps as args, only regular strings

2002-11-04  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-mail-followup-to): Don't modify a
	pre-existing M-F-T field.  If a nmh replgroupcomps propagates a
	M-F-T field in a message reply, then we have to have it alone.

2002-11-02  Bill Wohler  <wohler@newt.com>

	* mh-comp.el, mh-e.el, mh-funcs.el, mh-identity.el, mh-index.el,
	mh-mime.el, mh-pick.el, mh-seq.el, mh-speed.el, mh-utils.el,
	mh-xemacs-compat.el: Added Local Variables section. Defined
	sentence-end-double-space to be nil so that those who might not
	buy my setting of this variable can at least run checkdoc without
	a whole lot of noise.

2002-11-02  Peter S Galbraith  <psg@debian.org>

	* mh-identity.el: New file.  Multiple Identify support for MH-E.
	Used to easily set different fields such as From and Organization,
	as well as diffrent signature files.  This file won't be included
	with V7.0.

2002-11-02  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-mm-save-part): New function to wrap mm-save-part
	from Gnus 5.10 to make it explicit which code has been
	commandeered.
	(mh-mime-save-part): Call mh-mm-save-part instead of cut-n-pasted
	code from Gnus 5.10.

2002-11-02  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-from-start-of-msg): Edit docstring to
	mention related variables mh-reply-show-message-flag and
	mh-delete-yanked-msg-window.
	(mh-reply): Change the "Reply to whom" prompt.

2002-11-01  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-show-hook): Moved to mh-utils.el where it is used.
	(mh-folder-list-change-hook): Converted this from defvar in other
	files to defcustom here. It is called, not documented as
	obsolete, and might as well be documented.
	(mh-inc-folder, mh-quit, mh-delete-a-msg, mh-refile-a-msg,
	mh-process-commands, mh-update-unseen): Added missing
	documentation about hook, or made verbiage about hook consistent
	throughout, even if the function isn't interactive.

	* mh-utils.el (mh-folder-list-change-hook): Moved defvar to mh-e
	and made it a defcustom.
	(mh-show-mode-hook): Put it back in (actually, it was in mh-e.el,
	but this is the place where it is called).
	(mh-show-hook): Moved here from mh-e.el since it's called here.
	(mh-show-mode): Call mh-show-mode-hook.
	(mh-show-mode, mh-show-msg, mh-find-path, mh-prompt-for-folder,
	mh-prompt-for-folder, mh-set-folder-list): Added missing
	documentation about hook, or made verbiage about hook consistent
	throughout, even if the function isn't interactive.

	* mh-comp.el (mh-send-letter): Made verbiage about hook consistent
	throughout.
	(mh-insert-prefix-string): Made docstring more descriptive of what
	is going on.

	* mh-funcs.el (mh-kill-folder): Added missing documentation about
	hook.

	* mh-index.el (mh-index-show-hook): Moved defvar to defcustom.
	(mh-index-show): Made verbiage about hook consistent throughout.

	* mh-mime.el (mh-edit-mhn-hook): Moved defvar to defcustom.
	(mh-edit-mhn): Added missing documentation about hook.

	* mh-pick.el (mh-pick-mode): Made verbiage about hook consistent
	throughout. Call the damn hook.

2002-11-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-insert-mail-followup-to-list): Fix typo so that
	it will look right in info.

	* mh-index.el (mh-index-search): Change argument name from
	new-buffer-p to new-buffer-flag.
	(mh-index-search-again, mh-index-search): New index-buffers were
	being named *mh-index*<2>, *m-index*<2><2> and so on. This problem
	is fixed.
	(mh-index-scroll-up, mh-index-scroll-down): Scrolling in index
	show buffers (after the first one) was broken.
	(mh-index-quit): Bury show buffer instead of killing it. Killing
	it, without killing the corresponding folder buffer, can cause
	confusion with two folder buffers trying to display in the same
	show buffer.

	* mh-seq.el (mh-thread-prune-containers): Rewritten without
	recursion. Also removed the top-level-p argument since it isn't
	required anymore.
	(mh-thread-sort-containers): New function factored out from
	previous definition of mh-thread-prune-containers. It sorts
	message containers in ascending order wrt their message indices.
	(mh-thread-generate): Use new mh-thread-prune-containers.

	* mh-e.el (mh-remove-all-notation): Fix the test. It was testing
	at the wrong place!

2002-10-31  Bill Wohler  <wohler@newt.com>

	* Makefile, README, import-emacs, mh-comp.el, mh-e.el,
	mh-funcs.el, mh-index.el, mh-mime.el, mh-pick.el, mh-seq.el,
	mh-speed.el, mh-utils.el: Replaced mh-e with MH-E.

2002-10-31  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-parse-scan-line): Modified to remove user
	sequence notation and leave notation for other things alone. This
	ensures that threading doesn't lose notations for replied-to
	messages.

	* mh-e.el (mh-inc-folder): Remove call to mh-widen here and
	instead do it in mh-get-new-mail. This way the widening happens
	only if new mail is incorporated.
	(mh-generate-new-cmd-note): The function now returns the point
	from which the new messages start. This will allow threading to do
	the right thing.
	(mh-get-new-mail): Always call mh-remove-cur-notation. Otherwise
	adaptive scan mode leaves two messages marked as current in
	certain cases. Fix indentation of if statement. If there are
	messages to be incorporated, the folder is widened. If mh-cmd-note
	changes set start-of-inc correctly.
	(mh-remove-all-notation): Change this function to only remove user
	sequence notation and leave notation for replied-to messages and
	similar notation alone. This means operations like narrowing to
	subject sequence and widening don't lose notations.

2002-10-31  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-insert-mail-followup-to-list): Fixed typo in
	docstring and other minor edits. Checkdoc removed trailing spaces.
	(mh-insert-signature): Checkdoc flagged docstring. Reverted to
	previous value. Added specific name of hook that is run.
	(mh-regexp-in-field-p, mh-insert-letter): Checkdoc removed
	trailing spaces.

2002-10-31  Jeffrey C Honig  <jch@honig.net>

	* mh-e.el (mh-show-mode-hook): Remove the unused
	mh-show-mode-hook, mh-show-hook is the one that is used.

	* mh-utils.el (mh-show-mode): Change the documentation to refer to
	mh-show-hook instead of the unused mh-show-mode-hook.

2002-10-31  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-mail-followup-to-list): Set default to nil
	and include example in doc string.

2002-10-31  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-indexer): Add customization choice for swish++.
	(mh-indexer-choices): Add swish++ choice.
	(mh-index-search): Change doc to reflect addition of swish++ option.
	(mh-swish++-binary, mh-swish++-directory): New variables for
	swish++ interface.
	(mh-swish++-execute-search): New function to execute swish++
	search.
	(mh-swish++-next-result): Function aliased to mh-swish-next-result
	since the result format of swish++ is the same as that of swish-e.
	(mh-index-search): Always overwrite window-configuration with new
	value. This is needed since we don't kill the index-buffer when
	quitting which means the window configuration wasn't getting set
	properly.
	(mh-index-search-again): If index buffer is reused, reset the old
	window config to its original value.

2002-10-30  Bill Wohler  <wohler@newt.com>

	* Makefile (emacs, xemacs): New targets.
	(all): Use these targets instead of calling specific targets.
	(.PHONY): Added emacs, xemacs, autoloads, custom-loads. Broke up
	target and moved pieces into their own sections.


2002-10-30  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-show-font-lock-keywords): Wrap an
	'eval-and-compile around its defvar, otherwise byte-compilation
	fails on `mh-show-font-lock-keywords-with-cite'.

2002-10-29  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-letter-insert-signature-hook)
	(mh-insert-signature): Add a hook to be called before inserting
	the signature.  Do not attempt to insert the signature if
	mh-insert-signature-file-name is nil.

2002-10-29  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-inc-folder): Call mh-widen when mh-narrowed-to-seq
	(Closes SF #629233: inc in narrowed folder suboptimal)

	* mh-comp.el (mh-insert-letter): Stop using mhl to include a
	message before it mangles the header, and supercite fails
	(Closes SF #629153: mh-insert-letter uses mhl?).
	(mh-insert-prefix-string): Leave point at beginning instead of
	end, since that's what sc-cite-original does.
	(mh-yank-cur-msg): Adjust for mh-insert-prefix-string change.

2002-10-30  Steve Youngs  <youngs@xemacs.org>

	* mh-e.el (mh-folder-mode): Check for 'font-lock-auto-fontify'
	when in XEmacs so we don't do font-locking unconditionally.

	* mh-utils.el (mh-show-mode): Ditto.

2002-10-29  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-refiled-face, mh-folder-cur-msg-number-face)
	(mh-folder-to-face, mh-folder-body-face): Define faces instead of
	copying them from font-lock faces.  This mh-e will look the same
	in XEmacs as it does in Emacs.
	* mh-utils.el (mh-show-cc-face, mh-show-date-face)
	(mh-show-header-face): Ditto.

2002-10-29  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-send-letter): I meant to use
	mh-goto-header-field, not mh-get-header-field.  The former returns
	nil if the header is not found and doesn't need a conditional.

2002-10-29  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-forward): Bug fix.  Change 'kill-line for a
	'delete-region, because I don't want that text yanked with C-y.

	* mh-seq.el (mh-put-msg-in-seq): Add support for selected
	region (Closes SF feature request #630324).

2002-10-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-prune-subject): Make the regexp a little
	general so that a subject of the form "Re[218]: howdy" would be
	properly pruned.

	* mh-mime.el (mh-mime-save-part): Copy function definition of
	mm-save-part from cvs gnus since that function is buggy in gnus
	that comes with emacs21.2.

2002-10-28  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-scan-subject-regexp): Add an expression to match an
	optional bracketed number after "Re", such as in "Re[2]:"
	(Patch by Satyaki; I checked it and applied).
	(mh-folder-font-lock-subject): Adapt to new mh-scan-subject-regexp.
	* mh-seq.el (mh-subject-to-sequence): Ditto.

	* mh-e.el (mh-folder-sequence-menu):  Remove "Toggle Subject
	Thread" from menu.   mh-toggle-threads is in the Folder menu.

	* mh-e.el (mh-folder-sequence-menu): Minor menu text edits.

	* mh-utils.el (mh-show-update-sequences): Added to
	mh-defun-show-buffer builds; needed for menu.
	(mh-show-sequence-menu, mh-show-message-menu)
	(mh-show-folder-menu): 3 new menus in mh-show-mode-map that mirror
	the menus used in mh-folder-mode.
	(mh-show-mode): easy-menu-add the 3 menus.

2002-10-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-goto-msg): Fix the regexp to search so that we
	go to the right message. In a threaded folder message 2 may be
	present after 26 and the previous regexp would go to 26 when we
	really wanted to go to 2!

	* mh-seq.el (mh-widen): Add call to mh-recenter to make it like
	mh-narrow-to-seq.

2002-10-28  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (mh-show-mime-save-parts): Deleted definition.
	(mh-show-mime-map, tool-bar-map): Use mh-mime-save-parts instead
	of mh-show-mime-save-parts.

2002-10-28  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-letter-tool-bar-map): tool-bar-add-item key name
	bug fix.
	* mh-utils.el (mh-show-tool-bar-map): Same.
	* mh-e.el (mh-folder-tool-bar-map, mh-folder-seq-tool-bar-map): Same

2002-10-27  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-toggle-threads): Add call to mh-recenter to make
	its behavior like that of mh-narrow-to-seq.

2002-10-27  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-mime-save-parts): Renamed from
	mh-store-mime-parts for consistency with mh-mime-save-part. Fixed
	bug whereby mh-mime-save-parts-directory was not getting
	initialized properly from a string-valued
	mh-mime-save-parts-default-directory.
	(mh-mime-save-parts-default-directory): Ditto. Check your
	customizations!
	(mh-mime-save-parts-directory): Ditto.

	* mh-utils.el (mh-show-mime-save-parts): Renamed from
	mh-store-mime-parts.
	(mh-show-mime-map): Added keybinding "K a" for
	mh-show-mime-save-parts.

	* mh-e.el (mh-mime-save-parts) Renamed from mh-store-mime-parts.
	(mh-mime-map): Added keybinding "K a" for mh-mime-save-parts.
	(mh-help-messages): Added help for "K a".

2002-10-27  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-search-addr-regexp, mh-regexp-in-field-p): Rename
	the first to the second (and recode a bit).
	(mh-insert-mail-followup-to): Use it.

2002-10-27  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (mh-invisible-headers): Backed out change. Removed
	Mail-Followup-To due to objections from Peter and Mark.

2002-10-27  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-msg-is-in-seq): Modified to show info about
	whether the message being queried about has been marked to be
	deleted or refiled.

	* mh-mime.el (mh-insert-mime-security-button): Make
	pressed-details a local.

2002-10-27  Steve Youngs  <youngs@xemacs.org>

	* .cvsignore: New file.

2002-10-26  Steve Youngs  <youngs@xemacs.org>

	* mh-seq.el (mh-notate-deleted-and-refiled): Don't bind local
	variable 'dest', it isn't used anywhere.

	* mh-pick.el (mh-do-pick-search): Don't bind local variable
	'finding-messages', it isn't used anywhere.

	* mh-utils.el: Byte-compiler warning suppression.
	(mh-gnus-article-highlight-citation): Rather than redefining
	'gnus-cite-face-list', just re-order it.
	(mh-show-mode): Force turning on font-lock in XEmacs.

	* mh-seq.el: Byte-compiler warning suppression.

	* mh-index.el: Byte-compiler warning suppression.

	* mh-comp.el: Byte-compiler warning suppression.

	* mh-xemacs-compat.el: Add defaliases for 'timerp' &
	'cancel-timer' to the equivalent 'itimer' functions.
	(rfc822): Require it for 'rfc822-goto-eoh'.
	Byte-compiler warning suppression.

	* mh-e.el (mh-folder-mode): Force turning on font-lock in XEmacs.
	(mh-toggle-threads): Remove duplicate autoload.
	Byte-compiler warning suppression.
	(mh-folder-unseen-seq-list): Use 'with-temp-buffer' to fix a bug
	in XEmacs when font-lock is on.
	(mh-folder-unseen-seq-name): Ditto.

2002-10-27  Mark D. Baushke  <mdb@gnu.org>

	* Makefile: Reorganize to allow for building also compiling for
	XEmacs too. Sanitize so that it will work using least-common
	denominator versions of 'make'. Tested using GNU make, Solaris make,
	and Berkely make.
	(all): Use recursive invokation based on the emacs or xemacs
	executable passed on the 'make EMACS=xemacs' command line.
	(XEMACS_OPTIONS): The incantation to be passed to an xemacs editor
	to compile things properly.
	(AUTO_PRELOADS): Magic XEmacs glue.
	(clean): Ditto.
	(autoloads): Ditto.
	(custom-loads): Ditto.

2002-10-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-last-msg): Add call to mh-recenter.

2002-10-26  Peter S Galbraith  <psg@debia.org>

	* mh-comp.el (mh-search-addr-regexp, mh-re-search-to-cc): Remove
	`mh-re-search-to-cc' in favour of more generalized new function
	`mh-search-addr-regexp'.
	(mh-insert-mail-followup-to): Use it.

2002-10-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-copy-seq-to-eob): Avoid rethreading when the
	folder is already threaded. This is more efficient and also avoids
	problems when the folder is widened.
	(mh-thread-inc): Don't try to restore the point to original
	location since mh-inc-folder from where this is called changes
	point location after calling this function.

	* mh-e.el (mh-make-folder-mode-line): Fix a small bug where the
	test was wrong.

2002-10-26  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-mail-followup-to): Fix for new defcustom.

2002-10-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-notate-deleted-and-refiled): Remove unused binding
	of dest. The problem was pointed out by Steve as well.

	* mh-e.el (mh-toggle-threads): Remove duplicate autoload as
	pointed out by Steve.

2002-10-26  Bill Wohler  <wohler@newt.com>

	* mh-utils.el (mh-invisible-headers): Added Mail-Followup-To.

2002-10-26  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-mail-followup-to-list): Change defvar to
	defcustom.

2002-10-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-remove-all-notation): New function that removes all
	notation.

	* mh-seq.el (mh-narrow-to-seq): When hiding the original folder
	remove all notation. This avoids stale notation hanging around.
	Also changes in show buffer and position in folder buffer are
	avoided if possible.
	(mh-widen): When widening the scan-lines are notated based on the
	current state of the folder. This means any changes made when the
	folder was narrowed are shown consistently.
	(mh-notate-deleted-and-refiled): Update the documentation.
	(mh-thread-parse-scan-line): For some reason the ASCII value of
	the space character was being used here. This is fixed.
	(mh-thread-inc, mh-toggle-threads): Avoid change of point in
	folder and message being displayed in shown buffer.

	* mh-utils.el (mh-recenter): Rewrite mh-recenter to show fewer
	blank lines when point is towards the end of the folder buffer.

2002-10-25  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-mail-followup-to-flag): New boolean
	defcustom to append a Mail-Followup-To field to the header.  The
	insertion is done if the To: or Cc: fields matches an entry in
	`mh-insert-mail-followup-to-list'."
	(mh-insert-mail-followup-to-list): New defvar. List of addresses
	for which a Mail-Followup-To field is inserted.
	(mh-re-search-to-cc): New function. Search for REGEXP in To: and
	Cc: fields.
	(mh-insert-mail-followup-to): New function. Insert
	Mail-Followup-To: if To or Cc match `mh-insert-mail-followup-to-list'.
	(mh-compose-and-send-mail): Call mh-insert-mail-followup-to if
	mh-insert-mail-followup-to-flag is true.

2002-10-25  Mark D. Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-show-maximum-size): New variable to control
	the display of large messages.
	(mh-display-msg): Use it (Closes SF #488696).

	* mh-seq.el (mh-toggle-threads): Checkdoc fix.

	* mh-e.el (mh-reset-threads-and-narrowing): Checkdoc fix.

	* mh-comp.el (mh-insert-x-mailer-flag): Renamed from
	mh-insert-x-mailer-p. Update docstring.
	(mh-send-letter): Use it.
	(mh-reply-show-message-flag): Renamed from
	mh-reply-show-message-p. Update docstring.
	(mh-reply): Use it.
	This addresses part of SF #627015.

	* mh-e.el (mh-recenter-summary-flag): Renamed from
	mh-recenter-summary-p. Update docstring.
	(mh-set-scan-mode): Use it.
	This addresses part of SF #627015.

2002-10-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-reset-threads-and-narrowing): New function which
	resets all thread and narrowing state to completely unthreaded and
	widened state. As a side effect, the folder buffer is erased.
	(mh-rescan-folder): Reset threads and narrowing state.

	* mh-funcs.el (mh-pack-folder-1): Reset threads and narrowing state.

	* mh-seq.el (mh-copy-seq-to-eob): Change mh-view-ops after
	threading is over so that if user aborts threading, it doesn't
	leave mh-e in an inconsistent state.
	(mh-toggle-threads): Use mh-scan-folder to populate the folder
	buffer instead of mh-rescan-folder which resets threading and
	narrowing state.

2002-10-24  Bill Wohler  <wohler@newt.com>

        * mh-e is completely checkdoc clean now.

	* mh-utils.el (mh-clean-message-header-flag): Renamed from
	mh-clean-message-header.
	(mh-bury-show-buffer-flag): Renamed from mh-bury-show-buffer.
	(mh-show-use-goto-addr-flag): Renamed from mh-show-use-goto-addr.
	This addresses part of SF #627015.

	* mh-mime.el (mh-clean-message-header-flag): Renamed from
	mh-clean-message-header.
	Checkdoc fixes. This addresses part of SF #627015.

	* mh-index.el (mh-clean-message-header-flag): Renamed from
	mh-clean-message-header. This addresses part of SF #627015.

	* mh-funcs.el (mh-do-not-confirm-flag): Renamed from
	mh-do-not-confirm. This addresses part of SF #627015.

	* mh-e.el (mh-do-not-confirm-flag): Renamed from
	mh-do-not-confirm.
	(mh-clean-message-header-flag): Renamed from
	mh-clean-message-header.
	This addresses part of SF #627015.

	* mh-comp.el: checkdoc fixes.

2002-10-24  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-copy-seq-to-eob): Rewritten to scan the headers
	fresh instead of yanking from buffer. This is needed to get
	correct threading in copied sequence.
	(mh-thread-inc, mh-thread-update-scan-line-map)
	(mh-thread-parse-scan-line): Eliminate the use, and hence the
	definition of, the kludgy mh-thread-update-scan-line-map. Instead
	the functions mh-notate-deleted-and-refiled and
	mh-notate-user-sequences are used to get the message marks right.
	(mh-thread-generate-scan-lines): Updated to allow the thread tree
	to be used in a narrowed folder buffer.
	(mh-thread-folder, mh-toggle-threads): Remove
	mh-folder-threaded-view-flag.
	(mh-thread-old-scan-line-map): New buffer-local variable that
	remembers the original scan-line map so that the sequence thread,
	narrow, widen will work.
	(mh-narrow-to-seq, mh-widen): Remember the scan-line map when
	narrowing and restore it when widening.

	* mh-e.el (mh-folder-threaded-view-flag, mh-folder-folder-menu)
	(mh-regenerate-headers, mh-get-new-mail)
	(mh-make-folder-mode-line, mh-process-commands)
	(mh-delete-scan-msgs): Remove mh-folder-threaded-view-flag.
	Instead (memq 'unthread mh-view-ops) is used to test if the folder
	is threaded.

	* mh-mime.el (mh-display-emphasis): Shadow article-goto-body here
	since we want to do emphasis on the whole of the region and not
	just after the first blank line.
	(mh-mm-display-part): When displaying a text part show smilies and
	emphasis.

	* mh-index.el (mh-index-insert-scan): Attempt to keep number of
	args to scan small if there are lots of adjacent matches.
	(mh-index-quit): Bury index-buffer on quit instead of killing it.
	This behavior is more like that of mh-quit.

	* mh-seq.el (mh-widen): If folder was threaded after narrowing
	then make mh-widen undo the threading instead of erroring out.

2002-10-24  Peter S Galbraith  <psg@debian.org>

	* mh-seq.el (mh-toggle-threads): Add a cond (as suggested by
	Satyaki) to properly unthread a narrowed-to-sequence.

	* mh-seq.el (mh-thread-generate-scan-lines): Fix threading
	breakage from partial switch to mh-container-real-child-flag and
	to dupl-flag.

	* mh-comp.el (mh-yank-cur-msg): Bug fix: specify
	  (eq t mh-yank-from-start-of-msg) when that's what we want.

2002-10-24  Mark D. Baushke  <mdb@gnu.org>

	* mh-seq.el (mh-thread-prune-subject): Renamed subject-pruned-p as
	subject-pruned-flag.
	(mh-thread-inc): Renamed old-buffer-modified-p as
	old-buffer-modified-flag.
	(mh-thread-generate-scan-lines): Renamed dupl-p as dupl-flag.
	This addresses part of SF #627015.

	* mh-index.el (mh-index-advance):  Renamed backward-p
	local variable as backward-flag.
	(mh-index-next-button): Renamed backward-p
	argument as backward-flag.
	(mh-index-show): Renamed display-headers-p argument as
	display-headers-flag.
	This addresses part of SF #627015.

	* mh-e.el (mh-scan-format, mh-version): Use mh-nmh-flag.
	(mh-folder-mime-action): Renamed include-security-p
	argument as include-security-flag.
	(mh-goto-next-button, mh-next-button): Renamed backward-p
	argument as backward-flag.
	(mh-get-new-mail): Renamed new-mail-p local variable as
	new-mail-flag.
	(mh-goto-cur-msg): Renamed minimal-changes-p argument as
	minimal-changes-flag.
	(redraw-needed-flag): Renamed redraw-needed-p local variable as
	redraw-needed-flag.
	(mh-seq-containing-msg): Renamed include-internal-p argument as
	include-internal-flag.
	(mh-page-msg): Use mh-page-to-next-msg-flag.
	This addresses part of SF #627015.

	* mh-mime.el (mh-mhn-compose-insert-flag): Renamed from
	mh-mhn-compose-insert-p. Make it buffer-local.
	(mh-mhn-compose-type, mh-mhn-compose-external-type,
	mh-mhn-compose-forw, mh-edit-mhn): Use mh-mhn-compose-insert-flag.
	(mh-mml-to-mime, mh-mml-secure-message-encrypt-pgpmime,
	mh-mime-display-part, mh-mime-display-single): Use
	mh-gnus-pgp-support-flag renamed from mh-gnus-pgp-support-p.
	(mh-mime-display-single): Renamed small-image-p local
	variable as small-image-flag.
	(mh-mime-inline-part): Renamed local variable inserted-p as
	inserted-flag.
	(mh-mime-inline-part): Renamed local variable displayed-p as
	displayed-flag.
	This addresses part of SF #627015.

	* mh-comp.el (mh-letter-menu, mh-letter-mode, mh-send-letter):
	mh-mhn-compose-insert-flag.
	(mh-repl-group-formfile, mh-forward): Use mh-nmh-flag
	renamed from mh-nmh-p.
	(mh-reply, mh-insert-x-mailer, mh-send-letter): Use mh-nmh-flag.
	(mh-letter-mode-map): Use mh-gnus-pgp-support-flag renamed from
	mh-gnus-pgp-support-p.
	(mh-mml-secure-message-sign-pgpmime): Use
	mh-gnus-pgp-support-flag.
	This addresses part of SF #627015.

	* mh-utils.el (mh-page-to-next-msg-flag): Renamed from
	mh-page-to-next-msg-p.
	(mh-show-msg): Use mh-page-to-next-msg-flag.
	(mh-gnus-pgp-support-flag): Renamed from
	mh-gnus-pgp-support-p.
	(mh-show-font-lock-fontify-region): Fix docstring per checkdoc.
	(with-mh-folder-updating): Renamed argument
	save-modification-flag-p as mh-save-modification-flag.
	(mh-prompt-for-folder): Renamed new-file-p local
	variable as new-file-flag.
	This addresses part of SF #627015.

2002-10-24  Mark D Baushke  <mdb@gnu.org>

	* mh-comp.el (mh-forward): Fix mh-mml-compose-insert-p reference
	in last commit to be mh-mml-compose-insert-flag.
	(mh-mml-compose-insert-flag): Move defvar to fix compiler warning.

2002-10-24  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-forward): Add support for transient-mark mode.
	When using nmh, always specify -mime so as to preserve the
	original message(s).  If mh-compose-insertion is 'gnus, convert
	the mhbuild format forwarding directives into MML.

2002-10-24  Eric Ding  <ericding@alum.mit.edu>

	* mh-comp.el (mh-send-letter): Fix for earlier change that added
	"-mime" for bcc'ed MIME mail; still doesn't work with nmh 1.0, but
	at least no longer triggered for every outgoing message!

2002-10-24  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-cur-msg): Fix selected regions for supercite
	(see text below).

	* mh-comp.el (mh-yank-cur-msg): Fix for supercite.  Someone played
	with the point and mark setting prior to the call to
	'mh-insert-prefix-string and that broke supercite.  I put comments
	to make it obvious to future coders why those settings exists.
	Note that supercite is still broken when a region is selected in
	the show buffer.  Presumably it's been like that for a long time.
	We need to insert the header as well as the selected region oin
	that case.  I'll submit an SF bug.

2002-10-24  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-yank-from-start-of-msg, mh-reply): Use -noformat
	flag to reply when 'autosupercite or 'autoattrib are specified to
	prevent duplicate cites of the body of a message.

2002-10-23  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (font-lock-default-fontify-region): Add autoload to
	avoid compiler warning.

2002-10-23  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-letter-mode): set fill-paragraph-function to our
	own 'mh-fill-paragraph-function instead of simply
	'mail-mode-fill-paragraph (because it doesn't handle a non-nil
	fill-prefix correctly).
	(mh-fill-paragraph-function): New function for mh-letter-mode
	fill-paragraph-function in order to handle non-nil fill-prefix.
	Call sendmail's mail-mode-fill-paragraph if in the mail header,
	else call default fill-paragraph with fill-prefix set to nil.
	(Closes SF #489927)

	* mh-comp.el (mh-letter-mode): Let's use font-lock even if gnus is
	used in show-mode.  The reason is that gnus uses static text
	properties which are not appropriate for a buffer that will be
	edited.  So the choice here is either fontify the citations and
	header or the header only.

	* mh-utils.el (mh-show-font-lock-fontify-region): Limit font-lock
	in mh-show-mode to the header.  Used when mh-highlight-citation-p
	is set to gnus, leaving the body to be dealt with by gnus
	highlighting.  This fixes gnus text emphasis in mh-show-mode.
	(mh-show-mode): In font-lock-defaults, set
	font-lock-fontify-region-function to mh-show-font-lock-fontify-region.

2002-10-23  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-mml-attach-file): Prompt for disposition should
	be Disposition, not Content-Type. The Content-Type has been
	determined automatically.

2002-10-23  Mark D. Baushke  <mdb@gnu.org>

	* MH-E-NEWS:
	s/mh-adaptive-cmd-note/mh-adaptive-cmd-note-flag/
	s/mh-show-use-xface/mh-show-use-xface-flag/
	s/mh-tool-bar-reply-3-buttons/mh-tool-bar-reply-3-buttons-flag/
	This addresses part of SF #627015.

	* mh-comp.el:
	s/mh-mml-compose-insert-p/mh-mml-compose-insert-flag/
	s/mh-xemacs-p/mh-xemacs-flag/
	(mh-letter-menu): Use mh-mml-compose-insert-flag.
	(mh-insert-x-mailer): Use mh-xemacs-flag.
	(mh-mml-compose-insert-flag): Renamed from
	mh-mml-compose-insert-p.
	(mh-send-letter): Use mh-mml-compose-insert-flag.
	This addresses part of SF #627015.

	* mh-e.el:
	s/mh-folder-threaded-view-p/mh-folder-threaded-view-flag/
	s/mh-adaptive-cmd-note/mh-adaptive-cmd-note-flag/
	s/mh-xemacs-p/mh-xemacs-flag/
	(mh-folder-threaded-view-flag): Renamed from
	mh-folder-threaded-view-p. Make it buffer local.
	(mh-folder-tool-bar-map): Use mh-tool-bar-reply-3-buttons-flag.
	(mh-remove-xemacs-horizontal-scrollbar): Use mh-xemacs-flag.
	(mh-make-folder, mh-regenerate-headers, mh-get-new-mail): Use
	mh-adaptive-cmd-note-flag.
	(mh-folder-folder-menu, mh-regenerate-headers, mh-get-new-mail,
	mh-make-folder-mode-line, mh-process-commands,
	mh-delete-scan-msgs): Use mh-folder-threaded-view-flag.
	This addresses part of SF #627015.

	* mh-index.el:
	s/mh-adaptive-cmd-note/mh-adaptive-cmd-note-flag/
	(mh-index-search): Use mh-adaptive-cmd-note-flag.
	This addresses part of SF #627015.

	* mh-mime.el:
	s/mh-mml-compose-insert-p/mh-mml-compose-insert-flag/
	s/mh-xemacs-p/mh-xemacs-flag/
	(mh-mml-compose-insert-flag): Renamed from
	mh-mml-compose-insert-p. Make it buffer local.
	(mh-mml-attach-file, mh-mml-secure-message-sign-pgpmime,
	mh-mml-secure-message-encrypt-pgpmime): Use it.
	(gnus-local-map-property): Use mh-xemacs-flag.
	This addresses part of SF #627015.

	* mh-seq.el:
	s/mh-folder-threaded-view-p/mh-folder-threaded-view-flag/
	(mh-thread-generate, mh-thread-folder, mh-toggle-threads): Use
	mh-folder-threaded-view-flag.
	This addresses part of SF #627015.

	* mh-speed.el:
	s/mh-speed-run-flists-p/mh-speed-run-flists-flag/
	s/mh-speed-refresh-p/mh-speed-refresh-flag/
	(mh-speed-run-flists-flag): Renamed from mh-speed-run-flists-p.
	(mh-folder-speedbar-buttons): Use it.
	(mh-speed-refresh-flag): Renamed from mh-speed-refresh-p.
	(mh-speed-update-current-folder, mh-speed-invalidate-map,
	mh-speed-add-folder): Use it.
	This addresses part of SF #627015.

	* mh-utils.el:
	s/mh-xemacs-p/mh-xemacs-flag/
	s/mh-tool-bar-reply-3-buttons/mh-tool-bar-reply-3-buttons-flag/
	s/mh-show-use-xface/mh-show-use-xface-flag/
	(mh-xemacs-flag): Renamed from mh-xemacs-p.
	(mh-show-xface-function): Use it.
	(mh-tool-bar-reply-3-buttons-flag): Renamed from
	mh-tool-bar-reply-3-buttons.
	(mh-show-tool-bar-map): Use it.
	(mh-adaptive-cmd-note-flag): Renamed from mh-adaptive-cmd-note.
	(mh-cmd-note): Use it in description.
	(mh-show-use-xface-flag): Renamed from mh-show-use-xface. Use
	mh-xemacs-flag.
	(mh-show-xface): Use mh-show-use-xface-flag.
	This addresses part of SF #627015.

2002-10-23  Bill Wohler  <wohler@newt.com>

	* Makefile (all): Rather than have to run "make clean all" all the
	time, make the default target do a clean so all you have to say is
	"make".

	* mh-e.el (mh-folder-map): Moved "t (mh-toggle-threads)" to T
	prefix.

2002-10-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-indexer-choices, mh-swish-binary): The
	executable swish-e can be used to search (just like swish-search).
	However the Makefile in swish-e-2.2.2 doesn't install
	swish-search. So it is preferable to use swish-e.

2002-10-22  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-letter-mode-map): Added aliases for keybindings.
	For example, you now have "C-c C-m C-i" in addition to "C-c C-m
	i".

2002-10-22  Mark D. Baushke  <mdb@gnu.org>

	* mh-mime.el (mh-graphical-smileys-flag): Renamed from
	 mh-graphical-smileys-p.
	 (mh-display-smileys): Use it.
	 (mh-graphical-emphasis-flag): Renamed from
	 mh-graphical-emphasis-p.
	 (mh-display-emphasis): Use it. This addresses part of SF #627015.

2002-10-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-insert-mime-security-button): A message is
	produced if PGP decryption/verification fails. This addresses
	SF# 627025.

2002-10-21  Bill Wohler  <wohler@newt.com>

	* mh-seq.el (mh-widen): Checkdoc removed the period in the error.
	The info node (elisp) Coding Conventions says: "An error message
	should start with a capital letter but should not end with a
	period."

	* mh-e.el, mh-utils.el (mh-tool-bar-reply-3-buttons): Moved
	defcustom to mh-utils because I got an error about a nil value for
	mh-tool-bar-reply-3-buttons when I fired up mh-rmail.

	* mh-comp.el, mh-funcs,el, mh-mime.el, mh-pick.el: Moved (provide)
	to the end of the file to be consistent with most other files (see
	additional rationale in mh-e.el description below).

	* mh-e.el: Had to remove eval-when-compile from the (require 'cl)
	here too (because the remove-if generated a warning in CVS Emacs).
	Moved (provide) to the end of the file to be consistent with most
	other files. My guess is that this is good to keep a feature from
	being "provided" if the file craps out while being loaded.

2002-10-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-reply, Info-goto-node): Add autoloads to avoid
	compiler warnings.
	(mh-tool-bar-reply-3-buttons): Add defvar to avoid compiler
	warning.

	* mh-seq.el (mh-narrow-to-seq): Remember that a narrowing has
	occurred.
	(mh-valid-view-change-operation-p): New function that checks if
	the widening or unthreading that we are about to perform is
	allowed.
	(mh-widen): Check if widening is applicable.
	(mh-thread-inc, mh-thread-folder): Use delete-region instead of
	erase-buffer. This means if the buffer is narrowed then the hidden
	parts aren't removed. This allows widening of the folder later on.
	(mh-toggle-threads): Maintain mh-view-ops.

	* mh-e.el (mh-view-ops, mh-folder-mode): New buffer-local variable
	that keeps track of the sequence in which threading and narrowing
	of the folder buffer has been carried out. This is needed so that
	narrowing followed by threading (or vice versa) behaves in a
	reasonable manner.
	(mh-regenerate-headers): Use delete-region instead of
	erase-buffer.
	(mh-make-folder-mode-line): Change mh-first-msg-num and
	mh-last-msg-num conservatively. This might show a larger range in
	the mode-line but allows the unthreading to not miss messages
	present initially.

2002-10-21  Bill Wohler  <wohler@newt.com>

	* mh-mime.el (mh-graphical-emphasis-p): Added _underline_ to the
	docstring, as well as the source of the strings,
	gnus-emphasis-alist.
	(mh-graphical-emphasis-p, mh-graphical-smileys-p): Set the default
	to t.

2002-10-21  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-show-mode): Invoke new toolbar.
	(mh-show-tool-bar-map): New tool-bar for mh-show-mode, similar to
	mh-letter-mode.

2002-10-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-display-msg): Call the smiley display function
	after the call to mh-show-mode. This is needed since mh-show-mode
	kills all buffer-local variables and resets the variable that
	controls display of graphical smileys.

2002-10-21  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-folder-mime-action): Change mime to MIME in message.

	* mh-comp.el (mh-mml-to-mime autoload): Ditto.

2002-10-21  Mark D Baushke  <mdb@gnu.org>

	* mh-mime.el (smiley-region): Use load for a non-fatal dependency
	on the smiley library.

2002-10-21  Jeffrey C Honig  <jch@honig.net>

	* mh-comp.el (mh-forward): Search for a blank line as well as
	mail-header-separator.
	(mh-letter-mode): Search for a blank line as well as
	mail-header-separator.
	(mh-send-letter): The default BCC encapsulation will make a MIME
	message unreadable.  If we are running nmh and the letter contains
	a Bcc: and a Content-Type: field, add the -mime switch to to the
	arguments to send.

2002-10-21  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el: Add a mh-defun-show-buffer call to define
	mh-show-pack-folder.

2002-10-21  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-store-mime-parts): Simplify code a bit.

	* mh-e.el (mh-help-messages): Update help message for changed
	keybindings.

2002-10-21  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-invalidate-map): Invalidate
	mh-speed-folders-cache before it is used by mh-speed-folders. Also
	fix indentation of if statement.
	(mh-speed-folder-size): The folder name should be extracted from
	the speedbar buffer and not from the temp buffer has was happening
	before.
	(mh-speed-folder-size): Harden the function some more. It
	shouldn't produce errors any more unless flist really didn't work.

2002-10-21  Bill Wohler  <wohler@newt.com>

	* mh-seq.el (mh-put-msg-in-seq): Formatting only. The reason I was
	in there is because I was trying to use mh-put-msg-in-seq and
	mh-msg-is-in-seq non-interactively and found that although the
	docstring says it uses the current message by default, I got
	errors if I passed in nil for the message. Is this expected, or is
	this a bug? I suppose the fix would be to make the arguments
	optional, right? This would cause the arguments in
	mh-put-msg-in-seq to be reversed, however. Might be a backwards
	compatibility problem.

	* mh-speed.el (mh-speed-view): Convert default size to string
	before passing it to read-string. This was done because XEmacs
	can't handle a numeric value for the default.

2002-10-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-mode-map, mh-show-folder-map)
	(mh-show-sequence-map, mh-show-thread-map, mh-show-extract-map)
	(mh-show-digest-map, mh-show-mime-map): Interactive functions
	callable in show buffer are now prefixed with mh-show.

	* mh-seq.el (mh-notate-deleted-and-refiled): Take into account the
	changes to mh-refile-list and the removal of the 'deleted
	sequence.
	(mh-toggle-threads): Changing from threaded to normal view doesn't
	try to push out message refiles and deletions to MH.

	* mh-e.el (mh-rescan-folder, mh-scan-folder): Add a new optional
	argument to both functions that prevents them from carrying out
	pending refiles and deletes.
	(mh-undo): Remove dead code.
	(mh-delete-a-msg, mh-undo-msg): Get rid of the 'deleted sequence.
	The same information is present in mh-delete-list any way.
	(mh-refile-a-msg, mh-undo-msg, mh-process-commands): Change the
	semantics of mh-refile-list to make it self-contained. This
	variable now contains a list of lists. The first element of each
	sublist is the destination folder name. The remaining elements are
	the messages that are to be refiled to the destination folder.
	(mh-toggle-threads, mh-folder-folder-menu): Use mh-toggle-threads
	instead of mh-thread-folder.

2002-10-20  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-store-mime-parts): Bug fix?  Make this command
	work when in the show buffer, and not just in the folder buffer
	pointing to a message.

2002-10-20  Peter S Galbraith  <psg@debian.org>

	* mh-seq.el (mh-narrow-to-subject-sequence): Renamed from
	mh-narrow-to-subject-thread.
	(mh-subject-to-sequence): Renamed from mh-subject-thread-to-sequence.
	(mh-delete-subject-sequence): Renamed from mh-delete-subject-thread.
	(mh-next-unseen-subject-sequence): Renamed from
	mh-next-unseen-subject-thread.
	(mh-toggle-subject-thread): Removed.  :-(

	* mh-e.el: s/subject-thread/subject-sequence/
	(mh-thread-map): Bind mh-widen to "w".

	* mh-utils.el: s/subject-thread/subject-sequence/
	(mh-show-thread-map): Bind mh-widen to "w".

2002-10-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-folder): This function is no longer
	interactive. The mh-toggle-threads is the interactive function
	that gets called by the user. Also the already computed values in
	mh-first-msg-num and mh-last-msg-num are used instead of
	recomputing the first and last message indices in the current
	folder.
	(mh-toggle-threads): New interactive function that toggles
	threaded view of the folder.

	* mh-utils.el (mh-letter-toggle-threads): New interactive function
	which toggles thread view from show buffer. This function replaces
	mh-letter-thread-folder.
	(mh-show-folder-map): Use mh-letter-toggle-threads instead of
	mh-letter-thread-folder.

	* mh-e.el (mh-folder-map): Use mh-toggle-threads instead of
	mh-thread-folder.

2002-10-20  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-scan-folder): Formatting only.
	(mh-goto-cur-msg): Removed call to mh-last-msg in those cases
	where there isn't a current message. Since I've started using the
	speedbar to read my mh-e mail, I've had to use M-< every time to
	go to the beginning of the new messages. Very annoying! Thus, if
	there isn't a current message, the cursor is left alone, which
	sounds like the right thing to do anyway.

2002-10-19  Peter S Galbraith  <psg@debian.org>

	* mh-seq.el (mh-subject-thread-to-sequence): Bug fix.  After
	making the 'subject sequence real, I now have to delete it globally.

	* mh-seq.el (mh-toggle-subject-thread): Make toggle back to full
	scan exactly mh-widen (removed moving to current message).

	* mh-seq.el (mh-subject-thread-to-sequence): Make 'subject
	sequence a real one, exported to MH.  This means you can, for
	example, mh-forward it.  But it also shows up with a mark in the
	scan output.  (Closes SF #489445).

2002-10-19  Bill Wohler  <wohler@newt.com>

	* mh-speed.el (mh-speed-view): If there weren't any unseen
	messages, and you specified a string (a sequence like "last") when
	prompted for the number of messages to display, you got an error.
	This has been fixed.

2002-10-19  Mark D Baushke  <mdb@gnu.org>

	* mh-e.el (mh-last-destination-folder): Destination of last refile
	command.
	(mh-last-destination-write): Destination of last write command.
	(mh-refile-msg): Use 'mh-last-destination-folder and update both it
	and 'mh-last-destination.
	(mh-write-msg-to-file): Use 'mh-last-destination-write and update
	both it and 'mh-last-destination (Closes SF #580772).

2002-10-19  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-yank-from-start-of-msg): Changed default to
	'attribution.
	(mh-letter-mode-map): Removed commented-out keybindings as well as
	alias "C-c C-m a (mh-compose-insertion)." Prefer "C-c C-m i."

	* mh-utils.el: Removed autoload of help. It no longer appears to
	be necessary in cvs Emacs (21.4).

2002-10-18  Bill Wohler  <wohler@newt.com>

	* mh-e.el (mh-execute-commands): Doc fix.
	(mh-compat-write-file-hook): Renamed to
	mh-write-file-functions-compat.
	(mh-folder-mode): Add mh-write-file-functions-compat instead of
	mh-compat-write-file-hook

2002-10-18  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-invisible-headers-show-xface): Killed this
	variable.
	(mh-invisible-headers): Use 'mh-show-use-xface instead of
	'mh-invisible-headers-show-xface to determine whether to render
	the X-Face header line visible or not.

2002-10-18  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-compat-write-file-hook, mh-folder-mode): Use the new
	macro mh-compat-write-file-hook to use write-file-functions for
	Emacs 21.4 and local-write-file-hooks for older versions.

2002-10-18  Mark D Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-invisible-headers): Add more anti-spam headers.

2002-10-18  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-mml-forward-message): mml-attach-file constructs
	a malformed composition if the description string is empty, so
	test for that and call mml-attach-file without that argument if
	it's an empty string (closes SF #625168).

2002-10-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-keymap): Removed extra binding of " ".
	(mh-index-folder-mode-help-messages): Made the cheat sheet entry
	of quit like the others.
	(mh-index-search): If space was pressed in the index buffer before
	a search result has been shown with ".", the old show buffer would
	be scrolled. This is confusing since the index and show buffer
	contents are contradictory. Killing the show buffer here avoids
	this problem.
	(mh-index-configure-windows): Refine the window configuration
	logic. Avoid the two window view unless there is a message being
	displayed in the show buffer.
	(mh-index-scroll-up): Rewrite this function. The old version had a
	bizarre problem where the show buffer wouldn't be scrolled if the
	speedbar was present.
	(mh-index-scroll-down): Rewritten because of similar reason as
	above.

2002-10-17  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-reply): Add an undo boundary in the undo list
	before calling 'mh-yank-cur-msg (closes SF #623693).

2002-10-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-folder-mode): Use local-write-file-hooks instead of
	write-file-hooks. This is required for XEmacs and also the right
	thing according to GNU Emacs21 documentation.

2002-10-16  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate): Get threading to work correctly
	on partial folders. The fix here disregards messages that aren't
	already present in the buffer.
	(mh-thread-folder): When querying scan about thread info try to
	avoid asking about messages that aren't present in the folder
	buffer. A more efficient fix would be to ask scan about just the
	messages that are present instead of a range of messages. However
	that runs the risk of sending long command lines to scan. Another
	change was to populate the mh-scan-line-map early so that the
	change in mh-thread-generate would work.
	(mh-thread-generate-scan-lines): In case duplicates are present
	make one of them the pseudo parent of the rest. This makes it look
	prettier if there are multiple duplicates at top level.

	* mh-comp.el (mh-edit-again): If a buffer in show-mode is being
	reused then reinsert message file. This should fix SF #624283.

	* mh-mime.el (mh-mm-display-part): Make sure mh-display-part is
	always called when we want to remove the displayed MIME part.

2002-10-16  Bill Wohler  <wohler@newt.com>

	* mh-speed.el (mh-speed-folder-size): checkdoc fix.
	(mh-speed-view): Tweaked output to mirror gnus verbiage. Offer
	to view number of messages in folder rather than mh-large-folder.
	Replaced (intern mh-unseen-seq) with mh-unseen-seq since the
	former was generating errors.

2002-10-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-large-folder): New customizable variable to
	control mh-e's perception of large folders.
	(mh-speed-folder-size): New function which computes the size of
	folder on current line.
	(mh-speed-view): Modified to handle large folders. If the folder
	being clicked has unseen messages then only those messages are
	shown. Otherwise if number of messages in folder is larger than
	mh-large-folders then the user is asked for the number of messages
	to be shown. If the folder satisfies neither of the above cases
	then it is displayed in its entirety

2002-10-15  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-index-keymap): Use gnus-define-keys. Sorted.
	Noticed that there were two key bindings for SPACE...

	* mh-speed.el (mh-folder-speedbar-key-map): Ditto (except for the
	dup SPACE binding).

	Completed help in other modes:

	* mh-utils.el (mh-xemacs-p): Fixed doc.
	(mh-show-mode-map, mh-show-folder-map, mh-show-sequence-map)
	(mh-show-thread-map, mh-show-extract-map): Added binding for
	mh-help.

	* mh-pick.el (mh-search-folder): Added startup help message.
	(mh-pick-mode-help-messages): New variable that contains help
	messages for pick buffer.
	(mh-pick-mode): Set local buffer variable mh-help-messages to
	mh-pick-mode-help-messages.

	* mh-index.el (mh-index-keymap): Added binding for mh-help
	(mh-index-folder-mode-help-messages): New variable that contains
	help messages for MH Index buffer.
	(mh-index-folder-mode): Set local buffer variable mh-help-messages
	to mh-index-mode-help-messages.

	* mh-funcs.el (mh-help, mh-prefix-help): Call
	substitute-command-keys on the help messages.

	* mh-e.el (mh-help-messages): Added ,. Ran C-M-q.
	(mh-help): This autoload doc is now used for more than just the
	MH-Folder, so drop that specific text.

	* mh-comp.el (mh-edit-again, mh-extract-rejected-mail)
	(mh-forward, mh-reply, mh-send-sub): Call mh-letter-mode-message
	to display a help message at startup.
	(mh-letter-mode): Set local buffer variable mh-help-messages to
	mh-letter-mode-help-messages.
	(mh-letter-mode-help-messages): New variable with help messages
	for the MH-Letter buffer.
	(mh-letter-mode-message): New function that displays a startup
	help message.
	(mh-letter-mode-map): Added binding for mh-help. Sorted.

2002-10-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speedbar-selected-folder-with-unseen-messages-face)
	(mh-speedbar-folder-face, mh-speedbar-selected-folder-face)
	(mh-speedbar-folder-with-unseen-messages-face): New faces for mh-e
	speedbar.
	(mh-folder-speedbar-buttons, mh-speed-update-current-folder)
	(mh-speed-add-buttons): Use the new faces.
	(mh-speed-normal-face, mh-speed-bold-face): Functions to convert
	to bold face and back to normal face.
	(mh-speed-set-face): Removed.
	(mh-speed-highlight): Modified to allow it to be used instead of
	mh-speed-set-face. Also changes were made to fontify folders with
	unread messages.
	(mh-speed-parse-flists-output, mh-speed-parse-flists-output)
	(mh-speed-invalidate-map): Use mh-speed-highlight instead of
	mh-speed-set-face.

2002-10-15  Bill Wohler  <wohler@newt.com>

	* mh-mime.el, mh-seq.el, mh-speed.el, mh-utils.el: It appears that
	the cl package has been restructured in 21.4 in such a way that
	the use of eval-when-compile no longer suppresses warnings when
	compiling so that (require 'cl) must be called directly (maybe
	this is a bug in 21.4 ;-). Thus the autoloads of cl are no longer
	needed. Now compiles clean under 21.4.

	* mh-e.el (mh-folder-mode): The use of local-write-file-hooks is
	deprecated in Emacs 21.4, so use add-hook write-file-functions (or
	write-file-hook for older versions) with the LOCAL argument
	instead. Now compiles clean under 21.4.

	* mh-comp.el (mh-yank-cur-msg): Push a mark at the opposite end of
	the included text to make it easy to jump or delete to the other
	end of the included text.

2002-10-15  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-insert-prefix-string): Remove the erroneous use
	of set-mark and other related functions.

2002-10-14  Bill Wohler  <wohler@newt.com>

	* mh-comp.el (mh-yank-from-start-of-msg): Fixed documentation. It
	isn't ignored if there is a region. It is still used for the
	attribution.
	(mh-yank-cur-msg): Removed unnecessary push-mark when snarfing the
	entire message. Move the cursor to the end of the snarfed message
	if there is a region. In this case, push a mark so user can pop to
	the beginning of the snarfed fragment.
	(mh-insert-prefix-string): This calls set-mark which I find
	suspect since I found that my last user mark was deleted after
	yanking a message. Added a comment to this effect. Will probably
	add a bug report...

	* README (Installed, Supported versions): To appear in GNU Emacs
	21.3; supported on Emacs 21, 20.7 and XEmacs 21.

	* mh-funcs.el (mh-concat-list): Deleted. Use mapconcat instead.
	(mh-help, mh-prefix-help): Use mapconcat instead of mh-concat-list.
	(mh-ephem-message): Use "%s" in message.

	* mh-funcs.el (mh-concat-list): New function to concatenate a list
	of strings into a single string. I would have thought elisp
	already contained a function like this, but I couldn't find it.
	(mh-ephem-message): New function to display a message in the
	minibuffer ephemerally. minibuffer-message seemed like the right
	function, but it writes to the current buffer oddly enough.
	(mh-help, mh-prefix-help): New functions to display command
	cheat sheets in the minibuffer (closes SF #493740). It would be
	nice to refactor these two into a single function if possible.

	* mh-e.el (mh-folder-mode-map, mh-folder-map, mh-sequence-map)
	(mh-thread-map, mh-extract-map): Added ? keybinding for `mh-help'
	and `mh-prefix-help' (closes SF #493740).
	(mh-help-messages): New variable to hold various help messages.
	(mh-help, mh-prefix-help): Autoload from mh-funcs.el.

2002-10-13  Bill Wohler  <wohler@newt.com>

	* mh-index.el (mh-glimpse-directory, mh-swish-directory,
	mh-namazu-directory): New variables that hold the name of the
	configuration and indexing directory. All are now hidden `.'
	directories.

	* mh-e.el, mh-funcs.el, mh-index.el, mh-mime.el, mh-pick.el,
	mh-seq.el, mh-xemacs-compat.el (Docstrings): Converted comments to
	docstrings, reworded some docstrings to conform to Emacs
	documentation conventions, and eliminated all checkdoc warnings
	(except for -flag, which we'll fix after 6.2 is released).

2002-10-13  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-swish-next-result): Fix a bug in a corner case
	where the lack of a trailing "/" caused the function to wrongly
	filter out correct hits. This should fix SF #622679.

2002-10-12  Steve Youngs  <youngs@xemacs.org>

	* mh-utils.el (mh-xemacs-p): Simplify it, don't test for
	'defvaralias' and don't use 'running-xemacs'.

2002-10-11  Bill Wohler  <wohler@newt.com>

	* mh-comp.el: (Docstrings): Eliminated all checkdoc warnings by
	converting comments to docstrings and rewording some docstrings to
	conform to Emacs documentation conventions.

2002-10-11  Steve Youngs  <youngs@xemacs.org>

	* mh-utils.el (mh-xemacs-p): New.
	(mh-show-use-xface): Use it.
	(mh-show-xface-function): Ditto.

	* mh-e.el (toplevel): Ditto.
	(mh-remove-xemacs-horizontal-scrollbar): Ditto.
	(mh-folder-mode-map): Ditto.

	* mh-comp.el (mh-insert-x-mailer): Ditto.

	* mh-mime.el (gnus-local-map-property): Ditto.
	(mh-mml-to-mime): Move (require 'mh-utils) to toplevel.
	(mh-prompt-for-folder): Autoloading this not needed because
	mh-utils is now required at toplevel.
	(mh-show-xface): Ditto.
	(mh-show-addr): Ditto.

2002-10-11  Bill Wohler  <wohler@newt.com>

	* Makefile (EMACS_HOME): Set default to $(TOP)/../emacs so it
	would be useful.

	* mh-utils.el (mh-invisible-headers): Added various spam header
	fields.
	(mh-path-search): Removed argument `func-p' and related code. It
	was not documented and no one used it.
	(Docstrings): Converted comments to docstrings, reworded some
	docstrings to conform to Emacs documentation conventions, and
	basically eliminated all checkdoc warnings (except for -flag
	warnings).

2002-10-11  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate): Kill dead code.

2002-10-10  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-region-to-sequence): Don't include point-max in
	region (closes SF #621632).

	* mh-utils.el (mh-defun-show-buffer): Fix call of
	frame-first-window to work with XEmacs. Also avoid warning about
	cur-buffe-name in XEmacs.
	(mh-modify, mh-goto-msg): Remove dead code.

	* mh-speed.el (mh-speed-toggle, mh-speed-add-buttons): Remove dead
	code.

	* mh-seq.el (mh-subject-thread-to-sequence, mh-thread-get-message,
	mh-thread-generate, mh-thread-folder): Remove dead code.

	* mh-mime.el (mh-mm-inline-message): Remove dead code.

	* mh-index.el (mh-index-search): Remove dead code.

	* mh-comp.el (mh-open-line): Remove dead code.

	* mh-e.el (mh-folder-mode): Use the macro
	mh-remove-xemacs-horizontal-scrollbar to avoid compiler-warning in
	Emacs.
	(mh-remove-xemacs-horizontal-scrollbar): New macro to avoid
	compiler-warnings.

2002-10-10  Mark D Baushke  <mdb@gnu.org>

	* Makefile (EMACS_OPTIONS): New macro for command-line compile
	options.
	(EMACS): Allow the user to specify which emacs command to use for
	the compile.
	(COMPILE_COMMAND): Combine the compile command with its options.
	(.el.elc): Use the new $(COMPILE_COMMAND).

2002-10-10  Mark D Baushke  <mdb@gnu.org>

	* mh-speed.el (mh-speed-select-attached-frame): Define a new
	compatibility macro for getting to the attached-frame.
	(mh-speed-update-current-folder): Use it.

2002-10-10  Mark D Baushke  <mdb@gnu.org>

	* mh-speed.el (mh-speed-update-current-folder): Use
	'dframe-select-attached-frame if we are in a newer speedbar
	version that no longer supports the 'speedbar-attached-frame
	variable.

2002-10-10  Steve Youngs  <youngs@xemacs.org>

	* mh-speed.el (mh-speed-update-current-folder): Use
	'dframe-select-attached-frame' if we're in XEmacs.

	* mh-e.el (mh-folder-mode): Remove the horizontal scrollbar from
	the MH-Folder buffer if we're in XEmacs.

2002-10-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-show-xface-function): New global that stores
	what function needs to be called to display X-Face.
	(mh-show-xface): Rewritten to avoid compiler warning.

2002-10-09  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-exchange-point-and-mark-preserving-active-mark):
	Simplify code for all emacsen to avoid byte-compilation warnings.

2002-10-09  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-mm-display-part): If a sub-part of the current
	part is an inline image then clicking the button keeps the image
	around. The change fixes this bug.

2002-10-09  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-exec-cmd-output): Use new function
	'mh-exchange-point-and-mark-preserving-active-mark instead of
	'exchange-point-and-mark.  Fixes a bug in emacs20 and XEmacs21.
	(mh-exchange-point-and-mark-preserving-active-mark): New function.
	Does like 'exchange-point-and-mark but doesn't activate the mark.

	* mh-comp.el (mh-letter-menu): Allow access to "Pull in All
	Compositions" menu entries when edits have really occurred.
	Works with "forw: -mime" mh_profile entry, so this fixes a bug.

	* mh-mime.el (mh-mime-inline-part, mh-mm-display-part): Use
	line-beginning-position and line-end-position instead of
	point-at-bol and point-at-eol XEmacs functions.
	* mh-xemacs-compat.el: Added line-end-position and
	line-beginning-position compatibility aliases.

2002-10-08  Mark D. Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-scan-msg-format-regexp): The regexp to find
	%number(msg).
	(mh-scan-msg-format-string): Format to be used with the current
	maximum width of message number for the folder in the
	`mh-upate-scan-format' function.
	(mh-update-scan-format): Use `mh-scan-msg-format-regexp' for greater
	flexibility. The message number is no longer anchored to the
	beginning of the `mh-scan-format-nmh' or `mh-scan-format-mh' format
	strings. The `mh-update-scan-format' allows for using zero-filled
	message numbers.

2002-10-08  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-folder-folder-menu): Add entry for "Thread Folder".

2002-10-07  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate): Use mh-progs to get path to mh
	executables.

	* mh-speed.el (mh-speed-flists): Use mh-progs to get path to mh
	executables right.
	(mh-speed-folders-actual): Same as above.

2002-10-05  Steve Youngs  <youngs@xemacs.org>

	* mh-comp.el (mh-yank-from-start-of-msg): Make default setting 't'
	a const.

	* mh-xemacs-compat.el (match-string-no-properties): Rewrite as a
	defsubst using 'buffer-substring-no-properties' so we don't grab
	any extents.
	(rfc822-goto-eoh): Removed.  This exists in the XEmacs mail-lib
	package.
	(mail-header-end): Ditto.
	(mail-mode-fill-paragraph): Ditto.

2002-10-05  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-invalidate-map): When called interactively
	the function will clear mh-speed-folders-cache.

2002-10-02  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-insert-mime-button): Rewrite without using
	replace-match.

2002-10-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-file-mime-type-substitutions): Reorder code to
	avoid compiler warning.

2002-10-01  Bill Wohler  <wohler@newt.com>

	* Makefile (MH-E-ETC): Moved ChangeLog into MH-E-ETC-ETC since it
	shouldn't get installed in Emacs.
	(install-emacs): Install MH-E-IMG into Emacs' lisp/toolbar and
	MH-E-IMG2 into Emacs' lisp/mail.

2002-10-01  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-tool-bar-reply-3-buttons): New customization.
	Non-nil means use three buttons for reply commands in tool-bar.
	If you have room on your tool-bar because you are using a large
	font, you may set this variable to expand the single reply
	button into three buttons that won't lead to minibuffer prompt
	about who to reply to.
        (mh-folder-tool-bar-map): Use mh-tool-bar-reply-3-buttons to
	decide how many buttons to use for replying.

	* mh-mime.el (mh-file-mime-type-substitutions)
	(mh-file-mime-type-substitute):  Fix typos and doc strings.

2002-09-30  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-file-mime-type): Run Content-Type string returned
	by file command through mh-file-mime-type-substitute (see below).
	(mh-file-mime-type-substitute): Possibly change Content-Type
	string using mh-file-mime-type-substitutions variable.  This is
	mostly because all MS-Office file are seen as application/msword
	by the file command.
	(mh-file-mime-type-substitutions): New variable.  Defines
	substitutions to make for Content-Type returned from file command.

2002-09-27  Bill Wohler  <wohler@newt.com>

	* README: Moved Id to end of file since it broke outline mode at
	the beginning.

	* import-emacs (release): Renamed "mainline" tag to
	"emacs-mainline" to correspond with existing CVS tag.
	(EMACS_HOME): Fixed typo in docstring.

	* mh-utils.el (mh-folder-name-p, mh-defun-show-buffer): Lowercase
	NIL and T in docstring.
	(mh-update-scan-format): Fixed typo.

	* mh-comp.el, mh-e.el, mh-pick.el, mh-utils.el: Updated from CVS
	Emacs. The only new thing appears to be to downcase NIL and T in
	the documentation.

2002-09-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate): The threading code will now be
	more resistant to corruption of messages. Before the change any
	corruption of message x would cause all messages with indices
	higher than x to be neglected when threading!

2002-09-23  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-store-mime-parts): Don't store value into
	user-customizable variable mh-store-mime-parts-default-directory
	and use  mh-store-mime-parts-directory instead.

2002-09-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-prune-subject): Use regular expressions to
	make the subject pruning behave the way it is specified in the
	imap-thread RFC.

	* mh-speed.el (mh-speed-folders-actual): Don't use pop when we
	are not going to use the first element. This avoids a compilation
	warning with cvs emacs.

2002-09-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-display-msg): Put the call to
	set-buffer-modified after mh-show-mode. This is needed for CVS
	emacs since calling mh-show-mode marks the buffer as modified if
	font-lock is on.

2002-09-17  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-store-mime-parts-default-directory): Renamed from
	mh-store-mime-parts-directory
	(mh-store-mime-parts-directory): Renamed from
	mh-store-mime-parts-directory-default.

2002-09-16  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mail-citation-hook): Doc tweaks suggested by Bill.

2002-09-08  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (autoloads): Reorder autoload of mh-reply to avoid
	compiler warning.

2002-09-03  Peter S Galbraith  <psg@debian.org>

	* mh-mime.el (mh-store-mime-parts-directory): New defcustom.
	Default directory to use for mh-store-mime-parts.
	(mh-store-mime-parts): New Command.  Store the MIME parts of the
	 current message.
	(mh-store-mime-parts-directory-default): New internal working
	variable.  Default to use for mh-store-mime-parts-directory, set
	from last use.

	* mh-e.el (mh-folder-seq-tool-bar-map): Add mh-store-mime-parts to
	toolbar.


2002-08-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-generate-scan-lines): In threaded view,
	complete scan lines are printed for all messages (not just the
	ones at the top of a thread).

	* mh-index.el (mh-index-insert-scan): Replace use of kill-line
	since that pollutes the kill-ring.

	* mh-comp.el (autoloads): Add autoloads for search and subseq to
	get rid of compiler warnings.

2002-08-19  Peter S Galbraith  <psg@debian.org>

	* reply-to.xpm, reply-to.pbm, reply-from.xpm, reply-from.pbm,
	reply-all.xpm, reply-all.bpm:  New icons for various reply methods.
	* mh-e.el (mh-folder-tool-bar-map): Split reply button into three
	that won't prompt for "from", "to" and "all".
	* mh-comp.el (mh-reply): Put variable reply-to in the interactive
	list since it's specified on the command line for the new toolbar.

	* mh-comp.el (mail-citation-hook): Tweak docs concerning
	historical usage for supercite.
	(mh-yank-from-start-of-msg): Add settings 'supercite and
	'autosupercite.  Rename 'automatic to 'autoattrib.
	(mh-insert-prefix-string): Invoke sc-cite-original if
	mh-yank-from-start-of-msg is et to 'supercite or 'autosupercite.

2002-08-17  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (compilation-fix): Reorder defvars to avoid warnings
	during compilation.

2002-08-17  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-from-start-of-msg): Add 'automatic choice.
	Do as for `attribution' automatically when show buffer matches the
	message being replied-to.
	(mh-reply): Call 'mh-yank-cur-msg when mh-yank-from-start-of-msg
	is set to 'automatic and show buffer matches message number being
	replied-to.
	(mh-show-buffer-message-number): New helper function to get the
	message number of the current show-buffer.
	(mh-yank-cur-msg): Handle 'automatic choice the same as 'attribution.
	(mh-yank-cur-msg): Bug fix.  It would bail on error if
	mh-show-buffer didn't exists.

2002-08-16  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-insert-x-mailer): It wrongly assumed that Emacs
	was used even when XEmacs was used.  Fixed so X-Mailer header is
	more exact about what we are using.

2002-08-15  Peter S Galbraith  <psg@debian.org>

	* mh-e.el (mh-version): Change CVS version number to 6.1+cvs just
	so X-Mailer header is more exact about what we are using.

	* mh-mime.el (mh-mhn-compose-insertion, mh-mhn-compose-anon-ftp,
	mh-mml-attach-file):
	"Jeffrey P. Morgenthaler" <jpmorgen@congee.gsfc.nasa.go> reported
	that "require" in emacs 20.3 doesn't handle 3 arguments.  We
	use "load" at the top of file elsewhere anyway to handle such a
	case of non-essential loading, so switch to that here.

2002-08-06  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-funcs.el (autoload): Add autoload for mh-speed-invalidate-map.

	* mh-speed.el (mh-speed-add-folder): New function to make the
	speedbar aware of new folders when they are created by mh-e.

	* mh-utils.el (mh-prompt-for-folder): Use mh-speed-add-folder to
	tell speedbar that new folder is being created. Also use folder
	instead of mkdir to create new folders.

2002-08-01  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-decode-quoted-printable): Conditionalize the
	limit of search for quoted-printable.  If we're using mm-decode
	for MIME decoding, it's possible that `mimedecode' could mess our
	message, so we only run a full search for quoted-printable parts
	when not using gnus' mm-decode.  When using mm-decode, mimedecode
	can still help by handling the case of the whole message being
	quoted-printable as opposed to only a part.

2002-07-31  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-compose-insertion): Moved from mh-mime.el because
	the pulldown menu were broken in XEmacs21 from this variable being
	undefined.

2002-07-28  Mark D. Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-show-mode): Use the default paragraph-start
	rather than the inherited text-mode value.

2002-07-28  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-duplicates): New hash table to track
	duplicate messages.
	(mh-thread-get-message): Remove debug code.
	(mh-thread-canonicalize-id): Modified to handle messages without
	message-id header. Such messages are given distinct copies of the
	empty string as message-id.
	(mh-thread-generate): The function was inadvertently rebuilding
	the thread tree when message refiles and message deletes are
	processed. The change here fixes that. Also code has been added to
	keep track of duplicate message-id's.
	(mh-thread-generate-scan-lines): Modified to print scan lines for
	duplicate messages (that is messages with the same message-id).
	(mh-thread-forget-message): Modified to maintain
	mh-thread-duplicates.

2002-07-22  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-parse-flists-output): Use delete-region
	instead of kill-region. Otherwise the kill ring gets polluted.

2002-07-16  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el (mh-thread-update-scan-line-map): New function to
	refresh the stale scan lines.
	(mh-thread-inc): Update old scan lines when mh-thread-inc is
	called. Otherwise notations for deleted and refiled messages get
	lost and the folder display gets out of sync with real mh-e state.

	* mh-mime.el (mh-mm-display-part): Call Gnus citation highlight
	code when text part is displayed. Otherwise buttonized text parts
	aren't correctly fontified when they are displayed.

2002-07-15  Mark D. Baushke  <mdb@gnu.org>

	* mh-utils.el (mm-decode): Use load for the Non-fatal depencency
	on the mm-decode library.
	* mh-mime.el (mm-decode, mm-uu, mm-view): Use load for the
	Non-fatal depencencies on the mm-decode, mm-uu and mm-view
	libraries.

2002-07-15  Satyaki Das <satyaki@theforce.stanford.edu>

	* mh-utils.el (mh-require, mh-autoload): Remove these macros.
	(mh-decode-mime): Initialized to t iff the mm-decode library is
	present in the load-path.
	* mh-mime.el (mh-require): Don't use it anymore.

2002-07-15  Mark D Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-update-scan-format): Rewrite for compatibility
	with Xemacs as replace-match appears not to have identical
	functionality with FSF emacs.
	(mh-scan-msg-format-regexp): Deleted. This regexp is now hardcoded
	into the mh-update-scan-format function.

2002-07-12  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-seq.el: Add message threading code.

	* mh-utils.el (mh-letter-thread-folder): New interactive function
	that allows switching to threaded view from show buffer.
	(mh-show-folder-map): Bound "F t" to call mh-letter-thread-folder.
	(mh-goto-msg): Replace the function to not assume that messages
	are sorted in the folder buffer.

	* mh-e.el (mh-folder-threaded-view-p): New buffer local variable
	in the folder buffer that records whether threaded view is being
	used currently.
	(mh-scan-subject-regexp, mh-scan-format-regexp): Get font lock
	working for threaded view as well.
	(mh-regenerate-headers): Reset mh-folder-threaded-view-p to nil.
	(mh-get-new-mail, mh-process-commands): Do incremental threading
	if folder is in threaded view.
	(mh-delete-scan-msgs): Update thread tables if folder is in
	threaded view.
	(mh-folder-map): Add "F t" as key binding for mh-thread-folder

	* mh-comp.el (mh-yank-cur-msg): Bug fix. mh-show-buffer is only
	has a meaningful value in the folder buffer.

2002-07-11  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-cur-msg): Run only if mh-show-buffer
	actually exists (otherwise a back-traceable error occurred).

	* mh-utils.el (mh-find-progs): Run PATH search only when mh-progs,
	mh-lib and mh-lib-progs are not all already set.  This allows the
	user to set them using a simple setq prior to loading mh-e.  This
	is useful for implementation of mh-e on win32.  Note that many
	commands still call mh-find-path which also parses the mh_profile
	file (that may still fail on win32), so this is still done often.
	But it lets us change the mh_profile file and have mh-e see the
	changed file without exiting emacs and starting over so I left
	that in.

2002-07-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-show): Fixed a bug in mh-index-show which
	caused it to lose track of point when called from show buffer.

2002-07-04  Mark D. Baushke  <mdb@gnu.org>

	* Makefile: Add more information and common methods to allow both
	GNU make and Berkeley make to properly build everything.

2002-07-04  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-push-button): Bug fix for mime display with
	mouse. Select show window before executing the mime display
	functions.

2002-07-01  Mark D. Baushke  <mdb@gnu.org>

	* Makefile: Use a conditional variable assignment operator rather
	than ifndef to let Makefile be used by both GNU make and Berkeley
	make (or similar versions of make). This does not help Solaris
	/usr/ccs/bin/make, but Solaris make has problems with the ifndef
	syntax too.

2002-07-01  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-search): Check for mh-decode-mime before
	adding mh-mime-cleanup to kill-buffer-hook.

	* mh-mime.el (mm-destroy-parts): Add definition for old emacs.

2002-06-30  Mark D Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-update-scan-format): Add documentation string.
	(mh-scan-msg-format-regexp): Update the regexp to find %(msg).
	(mh-set-cmd-note): When mh-scan-format-file is not t, dynamic
	update of mh-cmd-note is wrong. Do not assume that
	mh-scan-format-nmh and mh-scan-format-mh can be kept in lock-step
	with mh-cmd-note via mh-set-cmd-note. The mh-scan-format function
	is now where the updated mh-cmd-note value is put into the scan
	format.

	* mh-e.el (mh-generate-new-cmd-note): Add documentation string.
	(mh-scan-format): Use mh-update-scan-format to get updated copies
	of mh-scan-format-nmh and mh-scan-format-mh to avoid format skew.
	(mh-get-new-mail): Do not try to adapt mh-cmd-note unless
	mh-scan-format-file is equal to t.
	(mh-scan-format-nmh): No longer buffer local.
	(mh-scan-format-mh): No longer buffer local.

2002-06-30  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-max-msg-index): New variable to keep track
	of max message index among search results. If mh-adaptive-cmd-note
	is non-nil this is used to compute the width of the index field.
	(mh-index-search): Keep track of max index seen while parsing the
	search results and set it if mh-adaptive-cmd-note is non-nil.
	(mh-index-find-max-width): New function to find the required width
	of the message index field.
	(mh-defun-index): Binding buffer local variables is bad, so don't
	do that.
	(mh-index-show): New argument display-headers-p decides whether
	the message is displayed in raw form or not.
	(mh-index-header-display): New interactive function bound to ","
	which shows the message in raw form.
	(mh-index-keymap): Add appropriate bindings for backtab and ",".
	(read-from-string): Add ignore-errors around it so that the code
	doesn't die when it gets unexpected input.

2002-06-29  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-count-windows): This function works around the
	lack of the window-list builtin function in emacs20.

2002-06-29  Mark D Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-message-number-width): New function to scan
	the last message of a folder and return its width.
	(mh-adaptive-cmd-note): New variable, if Non-nil indicates that
	mh-set-cmd-note should be called with the message width for the
	folder.
	(mh-cmd-note): Update documentation.
	(mh-update-scan-format): Helper function for updating the
	mh-scan-format-nmh and mh-scan-format-mh variables.
	(mh-scan-msg-overflow-regexp): New variable to help find problem
	messages after an inc.
	(mh-scan-msg-format-regexp): New variable to find the old message
	width in one of the mh-scan-format-nmh or mh-scan-format-mh
	variables.
	(mh-set-default-cmd-note): Replaced by mh-set-cmd-note.
	(mh-set-cmd-note): New function to replace update mh-cmd-note
	value.

	* mh-e.el (mh-regenerate-headers): If mh-adaptive-cmd-note is
	non-nil, use mh-set-cmd-note on empty folder buffers.
	(mh-make-folder): Ditto.
	(mh-generate-new-cmd-note): New function to adapt the mh-cmd-note
	to fit when mh-get-new-mail gets message number truncation.
	(mh-get-new-mail): Maybe use mh-generate-new-cmd-note if
	mh-adaptive-cmd-note is Non-nil.

2002-06-29  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el (mh-speed-view): The display gets confused if the
	cursor is in the show buffer when mh-speed-view is called. This is
	a fix for that.

2002-06-27  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-e.el (mh-next-undeleted-msg): Get rid of optional arg
	reverse-p. If there are no more undeleted messages the the point
	remains at its original position and a message is produced (closes
	SF #494304).
	(mh-previous-undeleted-msg): Change similar to
	mh-next-undeleted-msg.
	(mh-next-msg, mh-refile-msg, mh-delete-msg): Backout previous
	change.
	(mh-folder-map): Bind "S-tab" and "K S-tab" to mh-prev-button.

	* mh-utils.el (mh-show-mode-map): Bind "S-tab" and "K S-tab" to
	mh-letter-prev-button.

	* mh-mime.el (gnus-newsgroup-name): Initialize it to nil, so that
	mm-uu-dissect doesn't cause error.

2002-06-27  Mark D Baushke  <mdb@gnu.org>

	* mh-utils.el (mh-cmd-note): Make buffer-local. Changes to this
	variable should be made via the new mh-set-default-cmd-note
	function.
	(mh-set-default-cmd-note): New function to setq-default the
	mh-cmd-note, mh-scan-format-mh and mh-scan-format-nmh values to
	related values.

	* mh-e.el (mh-scan-format-mh): Make buffer-local.
	(mh-scan-format-nmh): Ditto.
	(mh-scan-good-msg-regexp): Use a more general regular expression
	so that the width of message numbers, mh-cmd-note, may vary.
	(mh-scan-deleted-msg-regexp): Ditto.
	(mh-scan-refiled-msg-regexp): Ditto.
	(mh-scan-cur-msg-number-regexp): Ditto.
	(mh-scan-cur-msg-regexp): Ditto.
	(mh-scan-subject-regexp): Ditto.

2002-06-26  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-speed.el: Speedbar support code.

	* Makefile: Add mh-speed.el to MH-E-SRC.

	* mh-utils.el (mh-prompt-for-folder): Add speedbar hook if
	speedbar is being used.

	* mh-funcs.el (mh-kill-folder): Add speedbar hook if speedbar is
	being used.

	* mh-e.el (speedbar-autoloads): Autoload speedbar initialization
	functions so that speedbar can find them.

2002-06-25  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-grep-execute-search, mh-grep-next-result): Allow
	grep to be used to search mail.
	(mh-index-font-lock-keywords): Modified to avoid bug when using
	lazy font-lock.

	* mh-e.el (mh-delete-msg, mh-refile-msg): Modify so that if no
	undeleted (or unrefiled) message exists in the current movement
	direction then try to find an undeleted (or unrefiled) message in
	the opposite direction instead.
	(mh-next-undeleted-msg): Added a new optional argument. If non-nil
	search for undeleted message backwards if none exists in the
	forward direction.
	(mh-previous-undeleted-msg): Added an optional argument. If
	non-nil search for undeleted message in the forward direction if
	none exists in the backward direction.
	(mh-next-msg): Optional argument to change direction if undeleted
	messages are not found in the current direction.

	* mh-index.el (mh-cmd-note): Use mh-cmd-note instead of hardcoding
	the index field size to 4.

	* mh-utils.el (mh-show-addr, mh-show-xface): New functions added
	to do xface display and goto-addr interface to allow reuse by the
	mime display code.
	(mh-show-mode): Use mh-show-addr and mh-show-xface. Only add
	mh-mime-cleanup to kill-buffer-hook if mime decoding is enabled.
	(mh-modify): Use mh-letter-mode instead of mh-show-mode when
	editing messages.

	* mh-mime.el (mh-mm-inline-message): Arrange for xface and
	highlighting to work in forwarded messages.

2002-06-23  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-yank-from-start-of-msg): Add 'attribution' option
	to add an attribution line in mh-yank-cur-msg.
	(mh-extract-from-attribution-verb): Verb to use for attribution
	when a message is yanked by mh-yank-cur-msg.  Provides a method
	for setting a different language.
	(mh-yank-cur-msg): Add support for 'attribution' option.
	(mh-extract-from-attribution): Function to get the attribution
	line, or the sender from the From: line in the current show buffer.

2002-06-20  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-index.el (mh-index-show): mh-display-msg was not being called
	in the show buffer. This causes weird results on some mime messages.

	* mh-mime.el (gnus-newsgroup-charset): Defvar to avoid error in
	pgp messages if gnus hasn't been used yet.

	* mh-comp.el (mh-letter-mode-map): Typo fix.

2002-06-19  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-mime.el (mh-mml-secure-message-encrypt-pgpmime): Typo fix.
	(compiler-warnings): Add autoloads to remove compiler warnings.

	* mh-index.el (autoload-fixes): Fix autoload forms.

2002-06-18  Satyaki Das  <satyaki@theforce.stanford.edu>

	* mh-comp.el (mh-letter-mode-map): Change binding of "\C-c\C-ma"
	to mh-compose-insertion. Remove duplicate binding for "C-c\C-mf".
	(compiler-warnings): Add defvar to remove compiler-warning.

2002-06-18  Peter S Galbraith  <psg@debian.org>

	* mh-comp.el (mh-letter-menu): Conditionalize GPG function on
	mh-gnus-pgp-support-p.

	* mh-mime.el (mh-mml-forward-message): s/subseq/substring/.
	(mh-compose-forward): cut&paste typo: s/messages/message/.
	(mml-minibuffer-read-file): autoload added.
	(mml-minibuffer-read-description): autoload added.
	(mml-insert-empty-tag): autoload added.
	(mh-mml-secure-message-sign-pgpmime): Check mh-gnus-pgp-support-p.
	(mh-mml-secure-message-encrypt-pgpmime): Check mh-gnus-pgp-support-p.

2002-06-17  Peter S Galbraith  <psg@debian.org>

	* mh-utils.el (mh-show-use-xface): Check for availability of
	`uncompface' executable on system.

	* mh-mime.el (mh-compose-forward): New front end for both
	mh-mml-forward-message and mh-mhn-compose-forw.
	(mh-compose-insertion): New front end for both mh-mml-attach-file
	and mh-mhn-compose-insertion.
	(mh-mml-to-mime): New function. Compose mime message from mml
	directives.
	(mh-mml-forward-message): New function. Forward a message as
	attachment.
	(mh-mml-attach-file): New function.  Attach a file to the outgoing
	MIME message.
	(mh-mml-compose-insert-p): New variable. Buffer-local variable to
	know whether MIME insertion was done.  Triggers an automatic call
	to `mh-mml-to-mime' in `mh-send-letter'.
